(* MLangUtils

Ver, 1.00 2016/09/17 DetectCodepage, GetEncodingInstance B
Ver, 1.01 2017/08/19 SupportsMLang2 ǉB
Ver, 1.02 2018/11/22 וB

Winapi.MLang ֘A[eBWB
ǉꂽ񂾂HMultiLanguage_TLB Ƃ͎dlႤ݂ǁB
pɂ Internet Explorer 5 ȍ~KvB

   R[h[eBeBW *)

unit MLangUtils;

interface

uses
  System.SysUtils, System.Classes, Winapi.ActiveX, Winapi.MLang;

function SupportsMLang2: Boolean;
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStr: Pointer; SrcSize: Integer): Cardinal; overload;
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStream: TStream): Cardinal; overload;
function GetEncodingInstance(CodePage: Cardinal): TEncoding;
function GetEncodingName(CodePage: Cardinal): string;

implementation

uses
  System.Win.ComObj;

{ MLang.dll  IMultiLanguage2 g邩ׂ }
function SupportsMLang2: Boolean;
var
  MLang: IUnknown;
begin
  MLang := CreateComObject(CLSID_CMultiLanguage);
  Result := Supports(MLang, IID_IMultiLanguage2);
end;

{ R[hy[W𒲂ׂ
@pnScores = 1  lpEncoding.nCodePage Ԃق DetectInputCodepage Ɠ }
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStr: Pointer; SrcSize: Integer): Cardinal;
var
  MLang2: IMultiLanguage2;
  Scores: Integer;
  Encoding: TDetectEncodingInfo;
begin
  Result := $FFFFFFFF;

  CoInitialize(nil);  //XbhŎgꍇ͌ĂяoȂƂȂȂ݂B
  try
    MLang2 := CoCMultiLanguage.Create as IMultiLanguage2;
    if Assigned(MLang2) then
    begin
      Scores := 1;
      if MLang2.DetectInputCodepage(Flag, CodePage, SrcStr, SrcSize, @Encoding, Scores) = S_OK then
        Result := Encoding.nCodePage;
    end;
  finally
    CoUninitialize;
  end;
end;

{ R[hy[W𒲂ׂ
@pnScores = 1  pstmIn ̌^ TStream ɂȂA
@lpEncoding.nCodePage Ԃق DetectCodepageInIStream Ɠ
  Ȃ񂾂ǁADetectCodepageInIStream gƌᔽN̂ DetectInputCodepage gp }
function DetectCodepage(Flag: LongWord; CodePage: LongWord;
  SrcStream: TStream): Cardinal;
var
  SavedPos: Int64;
  SrcStr: array of Char;
  SrcSize: SYSINT;
begin
  SavedPos := SrcStream.Position;
  try
    SrcStream.Position := 0;
    SrcSize := SrcStream.Size;
    SetLength(SrcStr, SrcSize);
    SrcStream.Read(SrcStr[0], Length(SrcStr));

    Result := DetectCodepage(Flag, CodePage, @SrcStr[0], SrcSize);
  finally
    SrcStream.Position := SavedPos;
  end;
end;

{ CodePage  TEncoding 𓾂
@T|[g̏ꍇ̓ftHg̃GR[hԂ }
function GetEncodingInstance(CodePage: Cardinal): TEncoding;
begin
  case CodePage of
    932:   Result := TMBCSEncoding.Create(932);         //Shift-JIS
    1200:  Result := TUnicodeEncoding.Create;           //UTF-16
    1201:  Result := TBigEndianUnicodeEncoding.Create;  //UTF-16BE
    20932: Result := TMBCSEncoding.Create(20932);       //JIS-0208-1990 and 0121-1990
    50220: Result := TMBCSEncoding.Create(50220);       //iso-2022-jp
    51932: Result := TMBCSEncoding.Create(20932);       //EUC-JP
    65001: Result := TMBCSEncoding.Create(65001);       //UTF-8 BOM͋ʂȂ炵B
    //12000: Result := ;  //UTF-32 TEncodingł͖T|[gB
    //12001: Result := ;  //UTF-32BE TEncodingł͖T|[gB
  else
    Result := TMBCSEncoding.Create(0);
  end;

end;

{ CodePage R[hy[Ŵ̖𓾂
@͓̎̂Ǝ`B`̏ꍇ͔ԍ̂܂ܕԂ }
function GetEncodingName(CodePage: Cardinal): string;
begin
  case CodePage of
    0:     Result := GetEncodingName(DefaultSystemCodePage);
    932:   Result := 'Shift-JIS';
    1200:  Result := 'UTF-16';
    1201:  Result := 'UTF-16BE';
    1252:  Result := 'Latin-ANSI';
    12000: Result := 'UTF-32';
    12001: Result := 'UTF-32BE';
    20127: Result := 'US-ASCII';
    20932: Result := 'JIS';
    50220: Result := 'iso-2022-jp';
    51932: Result := 'EUC-JP';
    65001: Result := 'UTF-8';
  else
    Result := IntToStr(CodePage);
  end;
end;

end.
