(* Reference Ctrls

Ver, 1.00 2016/09/25 ^B
Ver, 1.01 2016/12/03 TRefFileButton, TRefDirectoryButton ǉBRefEdits  RefCtrls ɉBToolTips vpeB TextTip ɕύXB
Ver, 1.02 2017/03/06 TSelectFile.Style ǉB

TSelectFile
TOpenDialog, TSaveDialog ̃JvZH

vpeB
Style: _CAǑ`B

\bh
Execute: TOpenDialog.Execute ƓBStyle ɂ [J]  [ۑ] ωB

̂ق̃vpeB TOpenDialog, TSaveDialog ƓB\bhACxg͉BB

TRefFileEdit
t@C̎Qƃ{^GfBbgB
TEdit + TButton + TSelectFile ̃ZbgB

vpeB
Dialog:   TSelectFile ̊evpeBƓB
Button;   TButton ̊evpeBECxgƓB
Margin;   GfBbgƃ{^̊ԊuB
ToolTips;  Text  Hint ɕ\B\̂ ShowHint ŐB

̂ق̃vpeBA\bhACxg TEdit ƓB

TRefFileButton
t@C̎Qƃ_CAO{^B

vpeB
Dialog:     TSelectFile ̊evpeBƓB

Cxg
OnExecute:  Self.Click  Dialog.Execute = True ̂ƂɔB莞ɂ̓t@CIsȂB

̂ق̃vpeBA\bhACxg TButton ƓB

TSelectDirectory
Vcl.FileCtrl.SelectDirectory ̃JvZB

\bh
Execue: Vcl.FileCtrl.SelectDirectory sB

̂ق̃vpeB Vcl.FileCtrl.SelectDirectory ̈ƓB

TRefDirectoryEdit
tH_̎Qƃ{^GfBbgB
TEdit + TButton + TSelectDirectory ̃ZbgB

vpeB
Dialog:   TSelectDirectory ̊evpeBƓB
Button;   TButton ̊evpeBECxgƓB
Margin;   GfBbgƃ{^̊ԊuB
TextTip;   Text  Hint ɕ\B\̂ ShowHint ŐB

̂ق̃vpeBA\bhACxg TEdit ƓB

TRefDirectoryButton
tH_̎Qƃ_CAO{^B

vpeB
Dialog:     TSelectDirectory ̊evpeBƓB

Cxg
OnExecute:  Self.Click  Dialog.Execute = True ̂ƂɔB莞ɂ̓tH_IsȂB

̂ق̃vpeBA\bhACxg TButton ƓB

   Qƃ_CAORg[ *)

unit RefCtrls;

interface

uses
  Winapi.Messages, System.SysUtils, System.Classes, Vcl.Controls, Vcl.StdCtrls, Vcl.Dialogs,
  Vcl.FileCtrl;

type
  TEllipsisButton = class(TCustomButton)
  private
    { Private 錾 }
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
  published
    { Published 錾 }
    property Caption;
    property Constraints;
    property Hint;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Width;
    property WordWrap;
    property OnClick;
  end;

  TCustomRefEdit = class(TCustomEdit)
  private
    { Private 錾 }
    FButton: TEllipsisButton;
    FMargin: Integer;
    FTextTip: Boolean;
    procedure CMEnabledChanged(var Msg: TMessage); message CM_ENABLEDCHANGED;
    procedure CMVisibleChanged(var Msg: TMessage); message CM_VISIBLECHANGED;
    procedure CMBiBiModeChanged(var Message: TMessage); message CM_BIDIMODECHANGED;
    procedure CMHintShow(var Msg: TCMHintShow); message CM_HINTSHOW;
    procedure AdjustButton;
    procedure SetMargin(Value: Integer);
  protected
    { Protected 錾 }
    procedure SetParent(AParent: TWinControl); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure SetName(const Value: TComponentName); override;
    property Button: TEllipsisButton read FButton;
    property Margin: Integer read FMargin write SetMargin default 4;
    property TextTip: Boolean read FTextTip write FTextTip default False;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer; AHeight: Integer); override;
  published
    { Published 錾 }
  end;

  TDialogStyle = (
    dsOpen, //TOpenDialog
    dsSave  //TSaveDialog
  );

  TSelectFile = class(TPersistent)
  private
    { Private 錾 }
    FOwner: TComponent;
    FFileName: string;
    FFiles: TStrings;
    FFilter: string;
    FFilterIndex: Integer;
    FDefaultExt: string;
    FTitle: string;
    FInitialDir: string;
    FOptions: TOpenOptions;
    FStyle: TDialogStyle;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function Execute: Boolean;
    property Files: TStrings read FFiles;
  published
    { Published 錾 }
    property FileName: string read FFileName write FFileName;
    property Filter: string read FFilter write FFilter;
    property FilterIndex: Integer read FFilterIndex write FFilterIndex default 1;
    property DefaultExt: string read FDefaultExt write FDefaultExt;
    property Title: string read FTitle write FTitle;
    property InitialDir: string read FInitialDir write FInitialDir;
    property Options: TOpenOptions read FOptions write FOptions default [ofHideReadOnly, ofEnableSizing];
    property Style: TDialogStyle read FStyle write FStyle default dsOpen;
  end;

  TRefFileEdit = class(TCustomRefEdit)
  private
    { Private 錾 }
    FDialog: TSelectFile;
    procedure SetDialog(Value: TSelectFile);
  protected
    { Protected 錾 }
    procedure EllipsisBtnClick(Sender: TObject);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property Dialog: TSelectFile read FDialog write SetDialog;
    property Button;
    property Margin;
    property TextTip;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property NumbersOnly;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TRefFileButton = class(TCustomButton)
  private
    { Private 錾 }
    FDialog: TSelectFile;
    FOnExecute: TNotifyEvent;
    procedure SetDialog(Value: TSelectFile);
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
  published
    { Published 錾 }
    property Dialog: TSelectFile read FDialog write SetDialog;
    property OnExecute: TNotifyEvent read FOnExecute write FOnExecute;
    property Action;
    property Align;
    property Anchors;
    property BiDiMode;
    property Cancel;
    property Caption;
    property CommandLinkHint;
    property Constraints;
    property Default;
    property DisabledImageIndex;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownMenu;
    property ElevationRequired;
    property Enabled;
    property Font;
    property HotImageIndex;
    property ImageAlignment;
    property ImageIndex;
    property ImageMargins;
    property Images;
    property ModalResult;
    property ParentBiDiMode;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property PressedImageIndex;
    property SelectedImageIndex;
    property ShowHint;
    property Style;
    property StylusHotImageIndex;
    property TabOrder;
    property TabStop;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDownClick;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TSelectDirectory = class(TPersistent)
  private
    { Private 錾 }
    FOwner: TWinControl;
    FCaption: string;
    FRoot: WideString;
    FDirectory: string;
    FOptions: TSelectDirExtOpts;
    procedure SetOptions(Value: TSelectDirExtOpts);
  public
    { Public 錾 }
    constructor Create(AOwner: TWinControl);
    destructor Destroy; override;
    procedure Assign(Source: TPersistent); override;
    function Execute: Boolean;
  published
    { Published 錾 }
    property Caption: string read FCaption write FCaption;
    property Root: WideString read FRoot write FRoot;
    property Directory: string read FDirectory write FDirectory;
    property Options: TSelectDirExtOpts read FOptions write SetOptions;
  end;

  TRefDirectoryEdit = class(TCustomRefEdit)
  private
    { Private 錾 }
    FDialog: TSelectDirectory;
    procedure SetDialog(Value: TSelectDirectory);
  protected
    { Protected 錾 }
    procedure EllipsisBtnClick(Sender: TObject);
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published 錾 }
    property Dialog: TSelectDirectory read FDialog write SetDialog;
    property Button;
    property Margin;
    property TextTip;
    property Align;
    property Alignment;
    property Anchors;
    property AutoSelect;
    property AutoSize;
    property BevelEdges;
    property BevelInner;
    property BevelKind default bkNone;
    property BevelOuter;
    property BevelWidth;
    property BiDiMode;
    property BorderStyle;
    property CharCase;
    property Color;
    property Constraints;
    property Ctl3D;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property NumbersOnly;
    property OEMConvert;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PasswordChar;
    property PopupMenu;
    property ReadOnly;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Text;
    property TextHint;
    property Visible;
    property OnChange;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

  TRefDirectoryButton = class(TCustomButton)
  private
    { Private 錾 }
    FDialog: TSelectDirectory;
    FOnExecute: TNotifyEvent;
    procedure SetDialog(Value: TSelectDirectory);
  protected
    { Protected 錾 }
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Click; override;
  published
    { Published 錾 }
    property Dialog: TSelectDirectory read FDialog write SetDialog;
    property OnExecute: TNotifyEvent read FOnExecute write FOnExecute;
    property Action;
    property Align;
    property Anchors;
    property BiDiMode;
    property Cancel;
    property Caption;
    property CommandLinkHint;
    property Constraints;
    property Default;
    property DisabledImageIndex;
    property DoubleBuffered;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownMenu;
    property ElevationRequired;
    property Enabled;
    property Font;
    property HotImageIndex;
    property ImageAlignment;
    property ImageIndex;
    property ImageMargins;
    property Images;
    property ModalResult;
    property ParentBiDiMode;
    property ParentDoubleBuffered;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property PressedImageIndex;
    property SelectedImageIndex;
    property ShowHint;
    property Style;
    property StylusHotImageIndex;
    property TabOrder;
    property TabStop;
    property Visible;
    property WordWrap;
    property OnClick;
    property OnContextPopup;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDownClick;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnMouseActivate;
    property OnMouseDown;
    property OnMouseEnter;
    property OnMouseLeave;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

{ TEllipsisButton }

constructor TEllipsisButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  SetSubComponent(True);
end;

{ TCustomRefEdit }

constructor TCustomRefEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FButton := TEllipsisButton.Create(Self);
  FButton.FreeNotification(Self);
  FMargin := 4;
  FTextTip := False;
end;

destructor TCustomRefEdit.Destroy;
begin
  if Assigned(FButton) then
    FButton.Destroy;

  inherited Destroy;
end;

procedure TCustomRefEdit.CMEnabledChanged(var Msg: TMessage);
begin
  inherited;

  if Assigned(FButton) then
    FButton.Enabled := Enabled;
end;

procedure TCustomRefEdit.CMVisibleChanged(var Msg: TMessage);
begin
  inherited;

  if Assigned(FButton) then
    FButton.Visible := Visible;
end;

procedure TCustomRefEdit.CMBiBiModeChanged(var Message: TMessage);
begin
  inherited;

  if Assigned(FButton) then
    FButton.BiDiMode := BiDiMode;
end;

procedure TCustomRefEdit.CMHintShow(var Msg: TCMHintShow);
var
  Canvas: TControlCanvas;
begin
  if TextTip then
  begin
    Canvas := TControlCanvas.Create;
    try
      Canvas.Control := Self;
      Canvas.Font := Font;
      if ClientWidth < Canvas.TextWidth(Text) then
        Msg.HintInfo^.HintStr := Text
      else
        Msg.HintInfo^.HintStr := '';
      Msg.Result := 0;
    finally
      Canvas.Free;
    end;
  end
  else
    inherited;
end;

procedure TCustomRefEdit.SetParent(AParent: TWinControl);
begin
  inherited SetParent(AParent);

  if Assigned(FButton) then
  begin
    FButton.Parent := Self.Parent;
    FButton.Width := Self.Height;
    FButton.Height := Self.Height;
    FButton.Caption := '...';
  end;
end;

procedure TCustomRefEdit.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);

  if (AComponent = FButton) and (Operation = opRemove) then
    FButton := nil;
end;

procedure TCustomRefEdit.SetName(const Value: TComponentName);
begin
  inherited SetName(Value);

  if Assigned(FButton) and (csDesigning in ComponentState) then
    FButton.Name := 'EllipsisBtn';
end;

procedure TCustomRefEdit.AdjustButton;
begin
  if Assigned(FButton) then
    FButton.SetBounds(Left + Width + Margin, Top, FButton.Width, FButton.Height);
end;

procedure TCustomRefEdit.SetBounds(ALeft: Integer; ATop: Integer; AWidth: Integer;
  AHeight: Integer);
begin
  inherited SetBounds(ALeft, ATop, AWidth, AHeight);

  AdjustButton;
end;

procedure TCustomRefEdit.SetMargin(Value: Integer);
begin
  if Value = FMargin then Exit;

  FMargin := Value;
  AdjustButton;
end;

{ TSelectFile }

constructor TSelectFile.Create(AOwner: TComponent);
begin
  inherited Create;

  FOwner := AOwner;
  FFileName := '';
  FFiles := TStringList.Create;
  FFilter := '';
  FFilterIndex := 1;
  FDefaultExt := '';
  FTitle := '';
  FInitialDir := '';
  FOptions := [ofHideReadOnly, ofEnableSizing];
  FStyle := dsOpen;
end;

destructor TSelectFile.Destroy;
begin
  FFiles.Free;

  inherited Destroy;
end;

procedure TSelectFile.Assign(Source: TPersistent);
begin
  if Source is TSelectFile then
  begin
    FFileName := (Source as TSelectFile).FFileName;
    FFiles.Assign((Source as TSelectFile).FFiles);
    FFilter := (Source as TSelectFile).FFilter;
    FDefaultExt := (Source as TSelectFile).FDefaultExt;
    FTitle := (Source as TSelectFile).FTitle;
    FInitialDir := (Source as TSelectFile).FInitialDir;
    FOptions := (Source as TSelectFile).FOptions;
    FStyle := (Source as TSelectFile).FStyle;
  end
  else
    Inherited;
end;

function TSelectFile.Execute: Boolean;
var
  Dialog: TOpenDialog;
begin
  if Style = dsSave then
    Dialog := TSaveDialog.Create(FOwner)
  else
    Dialog := TOpenDialog.Create(FOwner);
  try
    Dialog.FileName := FileName;
    Dialog.Filter := Filter;
    Dialog.FilterIndex := FilterIndex;
    Dialog.DefaultExt := DefaultExt;
    Dialog.Title := Title;
    Dialog.InitialDir := InitialDir;
    Dialog.Options := Options;

    Result := Dialog.Execute;
    if Result then
    begin
      FileName := Dialog.FileName;
      Files.Assign(Dialog.Files);
    end;
  finally
    Dialog.Free;
  end;
end;

{ TRefFileEdit }

constructor TRefFileEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDialog := TSelectFile.Create(Self);
  Button.OnClick := EllipsisBtnClick;
end;

destructor TRefFileEdit.Destroy;
begin
  FDialog.Free;

  inherited Destroy;
end;

procedure TRefFileEdit.EllipsisBtnClick(Sender: TObject);
begin
  if FDialog.Execute then
    Text := FDialog.FileName;
end;

procedure TRefFileEdit.SetDialog(Value: TSelectFile);
begin
  FDialog.Assign(Value);
end;

{ TRefFileButton }

constructor TRefFileButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDialog := TSelectFile.Create(Self);
end;

destructor TRefFileButton.Destroy;
begin
  FDialog.Free;

  inherited Destroy;
end;

procedure TRefFileButton.Click;
begin
  inherited Click;

  if Assigned(FOnExecute) and FDialog.Execute then
    FOnExecute(Self);
end;

procedure TRefFileButton.SetDialog(Value: TSelectFile);
begin
  FDialog.Assign(Value);
end;

{ TSelectDirectory }

constructor TSelectDirectory.Create(AOwner: TWinControl);
begin
  inherited Create;

  FOwner := AOwner;
  FCaption := '';
  FRoot := '';
  FDirectory := '';
  FOptions := [];
end;

destructor TSelectDirectory.Destroy;
begin

  inherited Destroy;
end;

procedure TSelectDirectory.Assign(Source: TPersistent);
begin
  if Source is TSelectDirectory then
  begin
    FCaption := (Source as TSelectDirectory).FCaption;
    FRoot := (Source as TSelectDirectory).FRoot;
    FDirectory := (Source as TSelectDirectory).FDirectory;
    FOptions := (Source as TSelectDirectory).FOptions;
  end
  else
    Inherited;
end;

function TSelectDirectory.Execute: Boolean;
var
  Dir: string;
begin
  Dir := Directory;
  Result := Vcl.FileCtrl.SelectDirectory(Caption, Root, Dir, Options, FOwner);
  if Result then
    Directory := Dir;
end;

procedure TSelectDirectory.SetOptions(Value: TSelectDirExtOpts);
begin
  FOptions := Value;
end;

{ TRefDirectoryEdit }

constructor TRefDirectoryEdit.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDialog := TSelectDirectory.Create(Self);
  Button.OnClick := EllipsisBtnClick;
end;

destructor TRefDirectoryEdit.Destroy;
begin
  FDialog.Free;

  inherited Destroy;
end;

procedure TRefDirectoryEdit.EllipsisBtnClick(Sender: TObject);
begin
  if FDialog.Execute then
    Text := FDialog.Directory;
end;

procedure TRefDirectoryEdit.SetDialog(Value: TSelectDirectory);
begin
  FDialog.Assign(Value);
end;

{ TRefDirectoryButton }

constructor TRefDirectoryButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FDialog := TSelectDirectory.Create(Self);
end;

destructor TRefDirectoryButton.Destroy;
begin
  FDialog.Free;

  inherited Destroy;
end;

procedure TRefDirectoryButton.Click;
begin
  inherited Click;

  if Assigned(FOnExecute) and FDialog.Execute then
    FOnExecute(Self);
end;

procedure TRefDirectoryButton.SetDialog(Value: TSelectDirectory);
begin
  FDialog.Assign(Value);
end;

procedure Register;
begin
  RegisterComponents('Samples', [
    TRefFileEdit, TRefDirectoryEdit, TRefFileButton, TRefDirectoryButton
  ]);
end;

end.
