{*********************************************************		}
{                                                         		}
{       Delphi Visual Component Library           			}
{                                                         		}
// Copyright (c) 1995-2010 Embarcadero Technologies, Inc.
{                                                         		}
{*********************************************************		}
(* Tvt̂̂CEg

2014/02/05
  ꕔ̓֐ ShellUtils ɈړB
  TRootFolder ɃCu֘A̎ʎqǉB

  TShellFolder
    DetailsEx ֐ǉB
    Details vpeB LoadColumnDetails 葱 DetailsOf ֐ɕύXB

  TShellChangeThread
    [[N̏CB
    ݌v̓I[gtbV𖳌B

  TCustomShellTreeView
    CuΉB
    ReadOnly vpeB̌JF2 l[֑ΉB

  TCustomShellComboBox
    [[N̏CB
    Rs[^̃ACëʒûCB

  TCustomShellListView
    CũTuACe̗񋓃~XCB
    ׂẴJőõ\[go悤ɕύXB
      Sorted vpeB SortIndex, SortAscend vpeBɕύXB
      SortByIndex 葱̒ǉB
    TlCΉB
      ViewStyle  ViewStyleEx ɕύXB
      ThumbWidth, ThumbHeight vpeB̒ǉB
    zXgr[p~ OnGetImageIndex CxgJB
      |[g̏ڍׂƃTlC OnGetImageIndex CxgŐݒ肵ĂB
      gꍇALoadDetails, LoadThumbnail ⎩葱gčĐݒ̂ƁB
    DoubleBuffered vpeB̌JB
    L[_Ẽ}`ZNgΉB
    ReadOnly vpeB̌JF2 l[֑ΉB

2020/10/02
  pbgy[WύXB
  TCustomShellChangeNotifier
    FindFirstChangeNotification bv SHChangeNotify bvɕύXB

  TCustomShellTreeView, TCustomShellListView
    TShellChangeNotifier ύXɔ߁BOnChangeNotify CxgǉB
    OLE Drag and Drop Ή͉Ehbvj[̏o킩炸fOB
2021/03/08
  ShellTypes XVɑΉB

*)

unit ShellCtrls platform;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Classes, Vcl.Graphics, Vcl.Controls,
  Vcl.Forms, Vcl.Dialogs, Vcl.ComCtrls, ShellTypes, Winapi.CommCtrl, Winapi.ShlObj, Winapi.ActiveX,
  Vcl.StdCtrls, Vcl.ImgList;

const
{ SHCOLUMNID Structure }
  //Winapi.Propkey ɗ񋓂Ă邯ǖ`B
  PID_STG_NAME = 10;
  PID_STG_STORAGETYPE = 4;
  PID_STG_SIZE = 12;
  PID_STG_WRITETIME = 14;
  PID_STG_ATTRIBUTES = 13;

type
  TShellFolderCapability = (fcCanCopy, fcCanDelete, fcCanLink, fcCanMove, fcCanRename,
                      fcDropTarget, fcHasPropSheet);
  TShellFolderCapabilities = set of TShellFolderCapability;

  TShellFolderProperty = (fpCut, fpIsLink, fpReadOnly, fpShared, fpFileSystem,
                     fpFileSystemAncestor, fpRemovable, fpValidate);
  TShellFolderProperties = set of TShellFolderProperty;

  TShellObjectType = (otFolders, otNonFolders, otHidden);
  TShellObjectTypes = set of TShellObjectType;

  EInvalidPath = class(Exception);

  IShellCommandVerb = interface
    ['{7D2A7245-2376-4D33-8008-A130935A2E8B}']
    procedure ExecuteCommand(Verb: string; var Handled: Boolean);
    procedure CommandCompleted(Verb: string; Succeeded: Boolean);
  end;

  TShellFolder = class
  private
    FPIDL,
    FFullPIDL: PItemIDList;
    FParent: TShellFolder;
    FIShellFolder: IShellFolder;
    FIShellFolder2: IShellFolder2;
    FIShellDetails: IShellDetails;
    FDetailInterface: IInterface;
    FLevel: Integer;
    FViewHandle: THandle;
    function GetDetailInterface: IInterface;
    function GetShellDetails: IShellDetails;
    function GetShellFolder2: IShellFolder2;
  public
    constructor Create(AParent: TShellFolder; ID: PItemIDList; SF: IShellFolder); virtual;
    destructor Destroy; override;
    function Capabilities: TShellFolderCapabilities;
    function DisplayName: string;
    function ExecuteDefault: Integer;
    function ImageIndex(LargeIcon: Boolean): Integer;
    function IsFolder: Boolean;
    function ParentShellFolder: IShellFolder;
    function PathName: string;
    function Properties: TShellFolderProperties;
    function Rename(const NewName: WideString): Boolean;
    function SubFolders: Boolean;
    function DetailsOf(Index: Integer): string;
    function DetailsEx(ColumnID: SHCOLUMNID): TPropVariant; overload;
    function DetailsEx(Index: Integer): TPropVariant; overload;
    property AbsoluteID: PItemIDLIst read FFullPIDL;
    property Level: Integer read FLevel;
    property Parent: TShellFolder read FParent;
    property RelativeID: PItemIDList read FPIDL;
    property ShellFolder: IShellFolder read FIShellFolder;
    property ShellFolder2: IShellFolder2 read GetShellFolder2;
    property ShellDetails: IShellDetails read GetShellDetails;
    property ViewHandle: THandle read FViewHandle write FViewHandle;
  end;

  TEventSource = (
    esInterruptLevel,
    esShellLevel,
    esRecursiveInterrupt
    //SHCNRF_NewDelivery ͏Ɏw
  );
  TEventSources = set of TEventSource;

  TNotificationEvent = (
    neRenameItem,
    neCreate,
    neDelete,
    neMkdir,
    neRmdir,
    neMediaInserted,
    neMediaRemoved,
    neDriveRemoved,
    neDriveAdd,
    neNetShare,
    neNetUnshare,
    neAttributes,
    neUpdateDir,
    neUpdateItem,
    neServerDisconnect,
    neUpdateImage,
    neDriveAddGUI,
    neRenameFolder,
    neFreeSapce,
    neAssocChanged
  );
  TNotificationEvents = set of TNotificationEvent;

  TChangeNotifyEvent = procedure(Sender: TObject;
    Event: TNotificationEvent; PIDL1, PIDL2: PItemIDList) of object;

  TCustomShellChangeNotifier = class(TComponent)
  private
    FHandle: HWND;
    FRegistID: Cardinal;
    FRoot: TRoot;
    FSources: Integer;
    FEvents: Integer;
    FRecursive: Boolean;
    FOnChange: TChangeNotifyEvent;
    procedure SetRoot(Value: TRoot);
    function GetSources: TEventSources;
    procedure SetSources(Value: TEventSources);
    function GetEvents: TNotificationEvents;
    procedure SetEvents(Value: TNotificationEvents);
    procedure SetRecursive(Value: Boolean);
    function GetEnabled: Boolean;
    procedure SetEnabled(Value: Boolean);
  protected
    procedure WndProc(var Message: TMessage);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    function Start: Boolean;
    procedure Stop;
    property Root: TRoot read FRoot write SetRoot;
    property Sources: TEventSources read GetSources write SetSources;
    property Events: TNotificationEvents read GetEvents write SetEvents;
    property WatchSubTree: Boolean read FRecursive write SetRecursive;
    property Enabled: Boolean read GetEnabled write SetEnabled;
    property OnChange: TChangeNotifyEvent read FOnChange write FOnChange;
  end;

  TShellChangeNotifier = class(TCustomShellChangeNotifier)
  published
    property Root;
    property Sources;
    property Events;
    property WatchSubTree;
    property Enabled;
    property OnChange;
  end;

  TCustomShellComboBox = class;
  TCustomShellListView = class;

  TAddFolderEvent = procedure(Sender: TObject; AFolder: TShellFolder;
    var CanAdd: Boolean) of object;
  TGetImageIndexEvent = procedure(Sender: TObject; Index: Integer;
     var ImageIndex: Integer) of object;
  TSTVChangeNotifyEvent = procedure(Sender: TObject;
    Event: TNotificationEvent; ANode: TTreeNode) of object;
  TSLVChangeNotifyEvent = procedure(Sender: TObject;
    Event: TNotificationEvent; AItem: TListItem) of object;

{ TCustomShellTreeView }

  TCustomShellTreeView = class(TCustomTreeView, IShellCommandVerb)
  private
    FRoot,
    FOldRoot: TRoot;
    FRootFolder: TShellFolder;
    FObjectTypes: TShellObjectTypes;
    FImages: Integer;
    FLoadingRoot,
    FAutoContext,
    FUpdating: Boolean;
    FComboBox: TCustomShellComboBox;
    FListView: TCustomShellListView;
    FAutoRefresh,
    FImageListChanging,
    FUseShellImages: Boolean;
    FNotifier: TShellChangeNotifier;
    FOnAddFolder: TAddFolderEvent;
    FOnChangeNotify: TSTVChangeNotifyEvent;
    FSavePath: string;
    FNodeToMonitor: TTreeNode;
    function FolderExists(FindID: PItemIDList; InNode: TTreeNode): TTreeNode;
    function GetFolder(Index: Integer): TShellFolder;
    function GetPath: string;
    procedure SetComboBox(Value: TCustomShellComboBox);
    procedure SetListView(const Value: TCustomShellListView);
    procedure SetPath(const Value: string);
    procedure SetPathFromID(ID: PItemIDList);
    procedure SetRoot(const Value: TRoot);
    procedure SetUseShellImages(const Value: Boolean);
    procedure SetAutoRefresh(const Value: Boolean);
  protected
    function CanChange(Node: TTreeNode): Boolean; override;
    function CanExpand(Node: TTreeNode): Boolean; override;
    procedure CreateRoot;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure DoContextPopup(MousePos: TPoint; var Handled: Boolean); override;
    procedure Edit(const Item: TTVItem); override;
    procedure GetImageIndex(Node: TTreeNode); override;
    procedure GetSelectedIndex(Node: TTreeNode); override;
    procedure InitNode(NewNode: TTreeNode; ID: PItemIDList; ParentNode: TTreeNode);
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure Loaded; override;
    procedure Delete(Node: TTreeNode); override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure PopulateNode(Node: TTreeNode);
    procedure RootChanged;
    procedure SetObjectTypes(Value: TShellObjectTypes); virtual;
    procedure WMDestroy(var Message: TWMDestroy); virtual;
    procedure WndProc(var Message: TMessage); override;
    procedure ClearItems;
    procedure RefreshEvent(Sender: TObject; Event: TNotificationEvent; PIDL1, PIDL2: PItemIDList);
    //IShellCommandVerb
    procedure CommandCompleted(Verb: string; Succeeded: Boolean); virtual;
    procedure ExecuteCommand(Verb: string; var Handled: Boolean); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Refresh(Node: TTreeNode);
    function FindAbsoluteID(StartNode: TTreeNode; ID: PItemIDList; Wrap: Boolean): TTreeNode;
    function FindRelativeID(ParentNode: TTreeNode; ID: PItemIDList): TTreeNode;
    function SelectedFolder: TShellFolder;
    property AutoRefresh: Boolean read FAutoRefresh write SetAutoRefresh;
    property Folders[Index: Integer]: TShellFolder read GetFolder; default;
    property Items;
    property Path: string read GetPath write SetPath;
    property AutoContextMenus: Boolean read FAutoContext write FAutoContext default True;
    property ObjectTypes: TShellObjectTypes read FObjectTypes write SetObjectTypes;
    property Root: TRoot read FRoot write SetRoot;
    property ShellComboBox: TCustomShellComboBox read FComboBox write SetComboBox;
    property ShellListView: TCustomShellListView read FListView write SetListView;
    property UseShellImages: Boolean read FUseShellImages write SetUseShellImages;
    property OnAddFolder: TAddFolderEvent read FOnAddFolder write FOnAddFolder;
    property OnChangeNotify: TSTVChangeNotifyEvent read FOnChangeNotify write FOnChangeNotify;
  end;

{ TShellTreeView }

  TShellTreeView = class(TCustomShellTreeView)
  published
    property AutoContextMenus;
    property ObjectTypes;
    property Root;
    property ShellComboBox;
    property ShellListView;
    property UseShellImages;
    property OnAddFolder;
    property OnChangeNotify;
    property Align;
    property Anchors;
    property AutoRefresh;
    property BorderStyle;
    property ChangeDelay;
    property Color;
    property Ctl3D;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Font;
    property HideSelection;
    property Images;
    property Indent;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property RightClickSelect;
    property ShowButtons;
    property ShowHint;
    property ShowLines;
    property ShowRoot;
    property StateImages;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnClick;
    property OnEnter;
    property OnExit;
    property OnDragDrop;
    property OnDragOver;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnDblClick;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnChanging;
    property OnChange;
    property OnExpanding;
    property OnCollapsing;
    property OnCollapsed;
    property OnExpanded;
    property OnEditing;
    property OnEdited;
    property OnGetImageIndex;
    property OnGetSelectedIndex;
  end;

{ TCustomShellComboBox }

  TCustomShellComboBox = class(TCustomComboBoxEx)
  private
    FImages,
    FImageHeight,
    FImageWidth: Integer;
    FImageList: TCustomImageList;
    FOldRoot: TRoot;
    FRoot: TRoot;
    FRootFolder: TShellFolder;
    FTreeView: TCustomShellTreeView;
    FListView: TCustomShellListView;
    FObjectTypes: TShellObjectTypes;
    FUseShellImages,
    FUpdating: Boolean;
    FOnGetImageIndex: TGetImageIndexEvent;
    procedure ClearItems;
    function GetFolder(Index: Integer): TShellFolder;
    function GetPath: string;
    procedure SetPath(const Value: string);
    procedure SetPathFromID(ID: PItemIDList);
    procedure SetRoot(const Value: TRoot);
    procedure SetTreeView(Value: TCustomShellTreeView);
    procedure SetListView(Value: TCustomShellListView);
    procedure SetUseShellImages(const Value: Boolean);
    function GetShellImageIndex(AFolder: TShellFolder): Integer;
  protected
    procedure AddItems(Index: Integer; ParentFolder: TShellFolder);
    procedure Change; override;
    procedure Click; override;
    procedure CreateRoot;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    function IndexFromID(AbsoluteID: PItemIDList): Integer;
    procedure Init; virtual;
    function InitItem(ParentFolder: TShellFolder; ID: PItemIDList): TShellFolder;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure RootChanged;
    procedure TreeUpdate(NewPath: PItemIDList);
    procedure SetObjectTypes(Value: TShellObjectTypes); virtual;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property Items;
    property Path: string read GetPath write SetPath;
    property Folders[Index: Integer]: TShellFolder read GetFolder;
    property Root: TRoot read FRoot write SetRoot;
    property ObjectTypes: TShellObjectTypes read FObjectTypes write SetObjectTypes;
    property ShellTreeView: TCustomShellTreeView read FTreeView write SetTreeView;
    property ShellListView: TCustomShellListView read FListView write SetListView;
    property UseShellImages: Boolean read FUseShellImages write SetUseShellImages;
    property OnGetImageIndex: TGetImageIndexEvent read FOnGetImageIndex write FOnGetImageIndex;
  end;

{ TShellComboBox }

  TShellComboBox = class(TCustomShellComboBox)
  published
    property Images;
    property Root;
    property ShellTreeView;
    property ShellListView;
    property UseShellImages;
    property OnGetImageIndex;
    property Anchors;
    property BiDiMode;
    property Color;
    property Constraints;
    property Ctl3D;
    property DragCursor;
    property DragKind;
    property DragMode;
    property DropDownCount;
    property Enabled;
    property Font;
    property ImeMode;
    property ImeName;
    property MaxLength;
    property ParentBiDiMode;
    property ParentColor;
    property ParentCtl3D;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnChange;
    property OnClick;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnDropDown;
    property OnEndDock;
    property OnEndDrag;
    property OnEnter;
    property OnExit;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnStartDock;
    property OnStartDrag;
  end;

{ TCustomShellListView }

  TViewStyleEx = (vsIcon, vsSmallIcon, vsList, vsReport, vsThumbnail);

  TCustomShellListView = class(TCustomListView, IShellCommandVerb)
  private
    FOldRoot: TRoot;
    FRoot: TRoot;
    FRootFolder: TShellFolder;
    FAutoContext,
    FAutoRefresh,
    FAutoNavigate,
    FDropSource,
    FDropTarget: Boolean;
    FDropEffect: Longint;
    FSortIndex: Integer;
    FSortAscend: Boolean;
    FUpdating: Boolean;
    FObjectTypes: TShellObjectTypes;
    FLargeImages,
    FSmallImages: Integer;
    FOnAddFolder: TAddFolderEvent;
    FOnChangeNotify: TSLVChangeNotifyEvent;
    FTreeView: TCustomShellTreeView;
    FComboBox: TCustomShelLComboBox;
    FNotifier: TShellChangeNotifier;
    FOnEditing: TLVEditingEvent;
    FSettingRoot: Boolean;
    FSavePath: string;
    FViewStyleEx: TViewStyleEx;
    FThumbImags: TImageList;
    procedure EnumColumns;
    function GetFolder(Index: Integer): TShellFolder;
    procedure SetAutoRefresh(const Value: Boolean);
    procedure SetSortIndex(const Value: Integer);
    procedure SetSortAscend(const Value: Boolean);
    procedure SetTreeView(Value: TCustomShellTreeView);
    procedure SetComboBox(Value: TCustomShellComboBox);
    procedure TreeUpdate(NewRoot: PItemIDList);
    procedure SetPathFromID(ID: PItemIDList);
    procedure SynchPaths;
    function GetThumbWidth: Integer;
    procedure SetThumbWidth(const Value: Integer);
    function GetThumbHeight: Integer;
    procedure SetThumbHeight(const Value: Integer);
  protected
    procedure ClearItems;
    procedure CreateRoot;
    procedure CreateWnd; override;
    procedure DestroyWnd; override;
    procedure DblClick; override;
    procedure ColClick(Column: TListColumn); override;
    procedure DoContextPopup(MousePos: TPoint; var Handled: Boolean); override;
    procedure EditText;
    procedure Edit(const Item: TLVItem); override;
    procedure KeyDown(var Key: Word; Shift: TShiftState); override;
    procedure Loaded; override;
    procedure Notification(AComponent: TComponent; Operation: TOperation); override;
    procedure FillItem(Sender: TObject; Item: TListItem);
    procedure Delete(Item: TListItem); override;
    function CanAddFolder(AFolder: TShellFolder): Boolean; dynamic;
    procedure InitItem(Item: TListItem; ID: PItemIDList);
    procedure Populate; virtual;
    procedure RootChanged;
    procedure SetObjectTypes(Value: TShellObjectTypes);
    procedure SetRoot(const Value: TRoot);
    procedure SetViewStyleEx(Value: TViewStyleEx); virtual;
    procedure WndProc(var Message: TMessage); override;
    procedure SetSortArrow(Index: Integer; Ascend: Boolean);
    procedure RefreshEvent(Sender: TObject; Event: TNotificationEvent; PIDL1, PIDL2: PItemIDList);
    //IShellCommandVerb
    procedure CommandCompleted(Verb: string; Succeeded: Boolean);
    procedure ExecuteCommand(Verb: string; var Handled: Boolean);
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    procedure Back;
    procedure Refresh;
    function FindAbsoluteID(StartItem: TListItem; ID: PItemIDList; Wrap: Boolean): TListItem;
    function SelectedFolder: TShellFolder;
    procedure SortByIndex(Index: Integer; Ascend: Boolean);
    property Folders[Index: Integer]: TShellFolder read GetFolder; default;
    property RootFolder: TShellFolder read FRootFolder;
    property Items;
    property Columns;
    property AutoContextMenus: Boolean read FAutoContext write FAutoContext default True;
    property AutoRefresh: Boolean read FAutoRefresh write SetAutoRefresh default False;
    property AutoNavigate: Boolean read FAutoNavigate write FAutoNavigate default True;
    property DropSource: Boolean read FDropSource write FDropSource default False;
    property DropTarget: Boolean read FDropTarget write FDropTarget default False;
    property ObjectTypes: TShellObjectTypes read FObjectTypes write SetObjectTypes;
    property Root: TRoot read FRoot write SetRoot;
    property ShellTreeView: TCustomShellTreeView read FTreeView write SetTreeView;
    property ShellComboBox: TCustomShellComboBox read FComboBox write SetComboBox;
    property SortIndex: Integer read FSortIndex write SetSortIndex;
    property SortAscend: Boolean read FSortAscend write SetSortAscend;
    property OnAddFolder: TAddFolderEvent read FOnAddFolder write FOnAddFolder;
    property OnChangeNotify: TSLVChangeNotifyEvent read FOnChangeNotify write FOnChangeNotify;
    property OnEditing: TLVEditingEvent read FOnEditing write FOnEditing;
    property ViewStyleEx: TViewStyleEx read FViewStyleEx write SetViewStyleEx;
    property ThumbWidth: Integer read GetThumbWidth write SetThumbWidth default 96;
    property ThumbHeight: Integer read GetThumbHeight write SetThumbHeight default 96;
  end;

{ TShellListView }

  TShellListView = class(TCustomShellListView)
  published
    property AutoContextMenus;
    property AutoRefresh;
    property AutoNavigate;
    property DropSource;
    property DropTarget;
    property ObjectTypes;
    property Root;
    property ShellTreeView;
    property ShellComboBox;
    property SortIndex;
    property SortAscend;
    property OnAddFolder;
    property OnChangeNotify;
    property ViewStyleEx;
    property ThumbWidth;
    property ThumbHeight;
    property DoubleBuffered;
    property OnGetImageIndex;
    property Align;
    property Anchors;
    property BorderStyle;
    property Color;
    property ColumnClick;
    property OnClick;
    property OnDblClick;
    property Ctl3D;
    property DragMode;
    property ReadOnly default False;
    property Enabled;
    property Font;
    property GridLines;
    property HideSelection;
    property HotTrack;
    property IconOptions;
    property AllocBy;
    property MultiSelect;
    property RowSelect;
    property OnChange;
    property OnChanging;
    property OnColumnClick;
    property OnContextPopup;
    property OnEnter;
    property OnExit;
    property OnInsert;
    property OnDragDrop;
    property OnDragOver;
    property DragCursor;
    property OnStartDrag;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property ParentColor default False;
    property ParentFont;
    property ParentShowHint;
    property ShowHint;
    property PopupMenu;
    property ShowColumnHeaders;
    property TabOrder;
    property TabStop default True;
    property Visible;
    property OnKeyDown;
    property OnKeyPress;
    property OnKeyUp;
    property OnEditing;
  end;

procedure InvokeContextMenu(Owner: TWinControl; AFolder: TShellFolder; X, Y: Integer);

procedure Register;

implementation

uses
  ShellConsts, ShellUtils, Winapi.ShellAPI, System.Win.ComObj, Vcl.Menus, Vcl.Consts,
  System.Math;

var
  cmvProperties: PAnsiChar = 'properties';  { Do not localize }
  ICM: IContextMenu = nil;
  ICM2: IContextMenu2 = nil;
  DesktopFolder: TShellFolder = nil;
  CS: TRTLCriticalSection;
  WM_SHCHANGENOTIFY: Cardinal = 0;


{ PIDL manipulation }

procedure debug(Comp:TComponent; msg:string);
begin
  ShowMessage(Comp.Name + ':' + msg);
end;

function CreatePIDLList(ID: PItemIDList): TList;
var
  TempID: PItemIDList;
begin
  Result := TList.Create;
  TempID := ID;
  while TempID.mkid.cb <> 0 do
  begin
    TempID := CopyPIDL(TempID);
    Result.Insert(0, TempID); //0 = lowest level PIDL.
    StripLastID(TempID);
  end;
end;

procedure DestroyPIDLList(List: TList);
var
  i: Integer;
begin
  If List = nil then Exit;
  for i := 0 to List.Count - 1 do
    DisposePIDL(List[i]);
  List.Free;
end;

{ Miscellaneous }

procedure NoFolderDetails(AFolder: TShellFolder; HR: HResult);
begin
  Raise EInvalidPath.CreateFmt(SShellNoDetails, [AFolder.DisplayName, HR]);
end;

procedure CreateDesktopFolder;
begin
  if DesktopPIDL <> nil then
  begin
    DesktopFolder := TShellFolder.Create(nil, DesktopPIDL, DesktopShellFolder);
    DisposePIDL(DesktopPIDL);
  end;
end;

function IsElement(Element, Flag: Integer): Boolean;
begin
  Result := Element and Flag <> 0;
end;

function GetCaps(ParentFolder: IShellFolder; PIDL: PItemIDList): TShellFolderCapabilities;
var
  Flags: LongWord;
begin
  Result := [];
  Flags := SFGAO_CAPABILITYMASK;
  ParentFolder.GetAttributesOf(1, PIDL, Flags);
  if IsElement(SFGAO_CANCOPY, Flags) then Include(Result, fcCanCopy);
  if IsElement(SFGAO_CANDELETE, Flags) then Include(Result, fcCanDelete);
  if IsElement(SFGAO_CANLINK, Flags) then Include(Result, fcCanLink);
  if IsElement(SFGAO_CANMOVE, Flags) then Include(Result, fcCanMove);
  if IsElement(SFGAO_CANRENAME, Flags) then Include(Result, fcCanRename);
  if IsElement(SFGAO_DROPTARGET, Flags) then Include(Result, fcDropTarget);
  if IsElement(SFGAO_HASPROPSHEET, Flags) then Include(Result, fcHasPropSheet);
end;

function GetProperties(ParentFolder: IShellFolder; PIDL: PItemIDList): TShellFolderProperties;
var
  Flags: LongWord;
begin
  Result := [];
  if ParentFolder = nil then Exit;
  Flags := SFGAO_DISPLAYATTRMASK;
  ParentFolder.GetAttributesOf(1, PIDL, Flags);
  if IsElement(SFGAO_GHOSTED, Flags) then Include(Result, fpCut);
  if IsElement(SFGAO_LINK, Flags) then Include(Result, fpIsLink);
  if IsElement(SFGAO_READONLY, Flags) then Include(Result, fpReadOnly);
  if IsElement(SFGAO_SHARE, Flags) then Include(Result, fpShared);

  Flags := 0;
  ParentFolder.GetAttributesOf(1, PIDL, Flags);
  if IsElement(SFGAO_FILESYSTEM, Flags) then Include(Result, fpFileSystem);
  if IsElement(SFGAO_FILESYSANCESTOR, Flags) then Include(Result, fpFileSystemAncestor);
  if IsElement(SFGAO_REMOVABLE, Flags) then Include(Result, fpRemovable);
  if IsElement(SFGAO_VALIDATE, Flags) then Include(Result, fpValidate);
end;

function ObjectFlags(ObjectTypes: TShellObjectTypes): Integer;
begin
  Result := 0;
  if otFolders in ObjectTypes then Inc(Result, SHCONTF_FOLDERS);
  if otNonFolders in ObjectTypes then Inc(Result, SHCONTF_NONFOLDERS);
  if otHidden in ObjectTypes then Inc(Result, SHCONTF_INCLUDEHIDDEN);
end;

procedure InvokeContextMenu(Owner: TWinControl; AFolder: TShellFolder; X, Y: Integer);
var
  PIDL: PItemIDList;
  CM: IContextMenu;
  Menu: HMenu;
  ICI: TCMInvokeCommandInfo;
  P: TPoint;
  Command: LongBool;
  ICmd: Integer;
  ZVerb: array[0..255] of AnsiChar;
  Verb: string;
  Handled: Boolean;
  SCV: IShellCommandVerb;
  HR: HResult;
begin
  if AFolder = nil then Exit;
  PIDL := AFolder.RelativeID;
  AFolder.ParentShellFolder.GetUIObjectOf(Owner.Handle, 1, PIDL, IID_IContextMenu, nil, CM);
  if CM = nil then Exit;
  P.X := X;
  P.Y := Y;

  ClientToScreen(Owner.Handle, P);
  Menu := CreatePopupMenu;
  try
    CM.QueryContextMenu(Menu, 0, 1, $7FFF, CMF_EXPLORE or CMF_CANRENAME);
    CM.QueryInterface(IID_IContextMenu2, ICM2); //To handle submenus.
    try
      Command := TrackPopupMenu(Menu, TPM_LEFTALIGN or TPM_LEFTBUTTON or TPM_RIGHTBUTTON or
        TPM_RETURNCMD, P.X, P.Y, 0, Owner.Handle, nil);
    finally
      ICM2 := nil;
    end;

    if Command then
    begin
      ICmd := LongInt(Command) - 1;
      HR := CM.GetCommandString(ICmd, GCS_VERBA, nil, ZVerb, SizeOf(ZVerb));
      Verb := string(ZVerb);
      Handled := False;
      if Supports(Owner, IShellCommandVerb, SCV) then
      begin
        HR := 0;
        SCV.ExecuteCommand(Verb, Handled);
      end;

      if not Handled then
      begin
        FillChar(ICI, SizeOf(ICI), #0);
        with ICI do
        begin
          cbSize := SizeOf(ICI);
          hWND := Owner.Handle;
          lpVerb := MakeIntResourceA(ICmd);
          nShow := SW_SHOWNORMAL;
        end;
        HR := CM.InvokeCommand(ICI);
      end;

      if Assigned(SCV) then
        SCV.CommandCompleted(Verb, HR = S_OK);
    end;
  finally
    DestroyMenu(Menu);
  end;
end;

procedure DoContextMenuVerb(AFolder: TShellFolder; Verb: PAnsiChar);
var
  ICI: TCMInvokeCommandInfo;
  CM: IContextMenu;
  PIDL: PItemIDList;
begin
  if AFolder = nil then Exit;
  FillChar(ICI, SizeOf(ICI), #0);
  with ICI do
  begin
    cbSize := SizeOf(ICI);
    fMask := CMIC_MASK_ASYNCOK;
    hWND := 0;
    lpVerb := Verb;
    nShow := SW_SHOWNORMAL;
  end;
  PIDL := AFolder.RelativeID;
  AFolder.ParentShellFolder.GetUIObjectOf(0, 1, PIDL, IID_IContextMenu, nil, CM);
  CM.InvokeCommand(ICI);
end;

function GetIShellFolder(IFolder: IShellFolder; PIDL: PItemIDList;
  Handle: THandle = 0): IShellFolder;
var
  HR: HResult;
begin
  if Assigned(IFolder) then
  begin
    HR := IFolder.BindToObject(PIDL, nil, IID_IShellFolder, Result);
    if HR <> S_OK then
      HR := IFolder.GetUIObjectOf(Handle, 1, PIDL, IID_IShellFolder, nil, Result);
    if HR <> S_OK then
      IFolder.CreateViewObject(Handle, IID_IShellFolder, Result);
  end;
  if not Assigned(Result) then
    DesktopShellFolder.BindToObject(PIDL, nil, IID_IShellFolder, Result);
end;

function GetIShellDetails(IFolder: IShellFolder; PIDL: PItemIDList;
  Handle: THandle = 0): IShellDetails;
var
  HR: HResult;
begin
  if Assigned(IFolder) then
  begin
    HR := IFolder.BindToObject(PIDL, nil, IID_IShellDetails, Result);
    if HR <> S_OK then
      HR := IFolder.GetUIObjectOf(Handle, 1, PIDL, IID_IShellDetails, nil, Result);
    if HR <> S_OK then
      IFolder.CreateViewObject(Handle, IID_IShellDetails, Result);
  end;
  if not Assigned(Result) then
    DesktopShellFolder.BindToObject(PIDL, nil, IID_IShellDetails, Result);
end;

function GetIShellFolder2(IFolder: IShellFolder; PIDL: PItemIDList;
  Handle: THandle = 0): IShellFolder2;
var
  HR: HResult;
begin
  if (Win32MajorVersion >= 5) then
  begin
    if Assigned(IFolder) then
    begin
      HR := IFolder.QueryInterface(IID_IShellFolder2, Result);
      if HR <> S_OK then
        HR := IFolder.BindToObject(PIDL, nil, IID_IShellFolder2, Result);
      if HR <> S_OK then
        IFolder.GetUIObjectOf(Handle, 1, PIDL, IID_IShellFolder2, nil, Result);
    end;
    if not Assigned(Result) then
      DesktopShellFolder.BindToObject(PIDL, nil, IID_IShellFolder2, Result);
  end
  else
    Result := nil;
end;

function CreateRootFromPIDL(Value: PItemIDList): TShellFolder;
var
  SF: IShellFolder;
begin
  SF := GetIShellFolder(DesktopShellFolder, Value);
  if SF = nil then SF := DesktopShellFolder;
  //special case - Desktop folder can't bind to itself.
  Result := TShellFolder.Create(DesktopFolder, Value, SF);
end;

function CreateRootFolder(RootFolder: TShellFolder; OldRoot: TRoot;
  var NewRoot: TRoot): TShellFolder;
var
  NewPIDL: PItemIDList;
  ErrorMsg: string;
begin
  NewPIDL := RootIDList(NewRoot);
  if NewPIDL = nil then
  begin
    { TODO: Remove the next line? }
    // Result := RootFolder;
    ErrorMsg := Format(SErrorSettingPath, [NewRoot]);
    NewRoot := OldRoot;
    raise Exception.Create(ErrorMsg);
  end;

  Result := CreateRootFromPIDL(NewPIDL);
  if Assigned(RootFolder) then RootFolder.Free;
end;

procedure ExtractThumbnailImage(AFolder: TShellFolder; ABitmap: TBitmap);

  function ExtractThumbnail(AFolder: TShellFolder; ABitmap: TBitmap; AFlags: Cardinal = 0): Boolean;
  var
    HR: HResult;
    ExtractImage: IExtractImage;
    Path: PWideChar;
    Priority: Cardinal;
    ImageSize: TSize;
    ColorDepth: Cardinal;
    Flags: Cardinal;
    BitmapHnd: HBITMAP;
  begin
    with AFolder do
      HR := ParentShellFolder.GetUIObjectOf(0, 1, FPIDL, IID_IExtractImage, nil, ExtractImage);
    if HR = S_OK then
    begin
      case ABitmap.PixelFormat of //F[x͖włC݂ǔÔ
        pfDevice: ColorDepth := 24;
        pf1bit  : ColorDepth := 1;
        pf4bit  : ColorDepth := 4;
        pf8bit  : ColorDepth := 8;
        pf15bit : ColorDepth := 16;
        pf16bit : ColorDepth := 16;
        pf24bit : ColorDepth := 24;
        pf32bit : ColorDepth := 32;
        pfCustom: ColorDepth := 24;
      else
        ColorDepth := 24;
      end;
      Priority := 0;
      ImageSize.cx := ABitmap.Width;
      ImageSize.cy := ABitmap.Height;
      Flags := AFlags;
      Path := AllocMem(MAX_PATH);
      try
        ExtractImage.GetLocation(Path, MAX_PATH, Priority, ImageSize, ColorDepth, Flags);
        HR := ExtractImage.Extract(BitmapHnd);
        if HR = S_OK then
          ABitmap.Handle := BitmapHnd;
      finally
        FreeMem(Path);
      end;
    end;
    Result := HR = S_OK;
  end;

  function ExtractSystemIcon(AFolder: TShellFolder; AIcon: TIcon; Large: Boolean): Boolean;
  var
    Images: Integer;
    FileInfo: TSHFileInfo;
    IconHnd: HICON;
    Flags: Cardinal;
  begin
    Flags := SHGFI_SYSICONINDEX;
    if Large then
      Flags := Flags or SHGFI_LARGEICON
    else
      Flags := Flags or SHGFI_SMALLICON;
    Images := SHGetFileInfo('.', 0, FileInfo, SizeOf(FileInfo), Flags);
    IconHnd := ImageList_GetIcon(Images, AFolder.ImageIndex(True), 0);
    Result := IconHnd <> 0;
    if Result then
      AIcon.Handle := IconHnd;
  end;

var
  Bmp: TBitmap;
  Ico: TIcon;
  X, Y: Integer;
begin
  Bmp := TBitmap.Create;
  try
    Bmp.Width := ABitmap.Width;
    Bmp.Height := ABitmap.Height;
    if not ExtractThumbnail(AFolder, Bmp, IEIFLAG_SCREEN) then
    begin
      Ico := TIcon.Create;
      try
        if ExtractSystemIcon(AFolder, Ico, True) then
          Ico.AssignTo(Bmp);
      finally
        Ico.Free;
      end;
    end;

    //Vista ȍ~̏ꍇAœhԂ
    if CheckWin32Version(6, 0) then
    begin
      ABitmap.Canvas.Brush.Color := clNone;
      ABitmap.Canvas.FillRect(Rect(0, 0, ABitmap.Width, ABitmap.Height));
      ABitmap.Canvas.Refresh;
    end;

    X := Max(0, (ABitmap.Width - Bmp.Width) div 2);
    Y := Max(0, (ABitmap.Height - Bmp.Height) div 2);
    ABitmap.Canvas.Draw(X, Y, Bmp);
  finally
    Bmp.Free;
  end;
end;

{ TShellFolder }

constructor TShellFolder.Create(AParent: TShellFolder; ID: PItemIDList; SF: IShellFolder);
begin
  inherited Create;
  FLevel := 0;
  FIShellFolder := SF;
  FIShellFolder2 := nil;
  FIShellDetails := nil;
  FParent := AParent;
  FPIDL := CopyPIDL(ID);
  if FParent = nil then
  begin
    FParent := DesktopFolder;
    FFullPIDL := ConcatPIDLs(DesktopPIDL, FPIDL);
  end
  else
    FFullPIDL := ConcatPIDLs(AParent.FFullPIDL, FPIDL);
  while Assigned(AParent) do
  begin
    AParent := AParent.Parent;
    if Assigned(AParent) then Inc(FLevel);
  end;
end;

destructor TShellFolder.Destroy;
begin
  if Assigned(FPIDL) then
    DisposePIDL(FPIDL);
  if Assigned(FFullPIDL) then
    DisposePIDL(FFullPIDL);
  inherited Destroy;
end;

function TShellFolder.GetDetailInterface: IInterface;
begin
  if (not Assigned(FDetailInterface)) and Assigned(FIShellFolder) then
  begin
    FIShellDetails := GetIShellDetails(FIShellFolder, FFullPIDL, FViewHandle);
    if (not Assigned(FIShellDetails)) and (Win32MajorVersion >= 5) then
    begin
      FIShellFolder2 := GetIShellFolder2(FIShellFolder, FFullPIDL, FViewHandle);
      if not Assigned(FIShellFolder2) then // Hack!
       { Note: Although QueryInterface will not work in this instance,
         IShellFolder2 is indeed supported for this Folder if IShellDetails
         is not. In all tested cases, hard-casting the interface to
         IShellFolder2 has worked. Hopefully, Microsoft will fix this bug in
         a future release of ShellControls }
        FIShellFolder2 := IShellFolder2(FIShellFolder);
    end;
    if Assigned(FIShellFolder2) then
      Result := FIShellFolder2
    else
      Result := FIShellDetails;
    FDetailInterface := Result;
  end else
    Result := FDetailInterface;
end;

function TShellFolder.GetShellDetails: IShellDetails;
begin
  if not Assigned(FDetailInterface) then
    GetDetailInterface;
  Result := FIShellDetails;
end;

function TShellFolder.GetShellFolder2: IShellFolder2;
begin
  if not Assigned(FDetailInterface) then
    GetDetailInterface;
  Result := FIShellFolder2;
end;

function TShellFolder.DetailsOf(Index: Integer): string;

  procedure GetDetailsOf(AFolder: TShellFolder; var Details: TWin32FindData);
  var
    szPath: array[0..MAX_PATH] of Char;
    Path: string;
    Handle: THandle;
  begin
    FillChar(Details, SizeOf(Details), 0);
    FillChar(szPath,MAX_PATH,0);
    Path := AFolder.PathName;
    Handle := Winapi.Windows.FindFirstFile(PChar(Path), Details);
    try
      if Handle = INVALID_HANDLE_VALUE then
        NoFolderDetails(AFolder, GetLastError);
    finally
      Winapi.Windows.FindClose(Handle);
    end;
  end;

  function CalcFileSize(FindData: TWin32FindData): int64;
  begin
    Result := -1;
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
      Result := FindData.nFileSizeHigh * MAXDWORD + FindData.nFileSizeLow;
  end;

  function CalcModifiedDate(FindData: TWin32FindData): TDateTime;
  var
    LocalFileTime: TFileTime;
    Age: Integer;
  begin
    Result := -1;
    if (FindData.dwFileAttributes and FILE_ATTRIBUTE_DIRECTORY) = 0 then
    begin
      FileTimeToLocalFileTime(FindData.ftLastWriteTime, LocalFileTime);
      if FileTimeToDosDateTime(LocalFileTime, LongRec(Age).Hi, LongRec(Age).Lo) then
        Result := FileDateToDateTime(Age);
    end;
  end;

  function DefaultDetailColumn(FindData: TWin32FindData; Col: Integer): string;
  begin
    case Col of
      //1: Result := FindData.cFileName; // Name
      1: Result := IntToStr(CalcFileSize(FindData)); // Size
      2: Result := ExtractFileExt(FindData.cFileName); // Type
      3: Result := DateTimeToStr(CalcModifiedDate(FindData)); // Modified
      4: Result := IntToStr(FindData.dwFileAttributes);
    end;
  end;

  function FormatShellDetails(HR: HResult; PIDL: PItemIDList; SD: TShellDetails): string;
  begin
    if HR = S_OK then
      Result := StrRetToString(PIDL, SD.str)
    else
      Result := '';
  end;

  function FormatFileSize(const Bytes: Cardinal): string;
  const
    KB = 1024;
    MB = 1024 * KB;
    GB = 1024 * MB;
  begin
    if Bytes > GB then
      Result := FormatFloat('#.## ' + SGigabyteUnitStr, Bytes / GB)
    else if Bytes > MB then
      Result := FormatFloat('#.## ' + SMegabyteUnitStr, Bytes / MB)
    else if Bytes > KB then
      Result := FormatFloat('#.## ' + SKilobyteUnitStr, Bytes / KB)
    else
      Result := FormatFloat('#.## ' + SByteUnitStr, Bytes);
  end;

  function FormatLocalVariantTime(const VTime: Double): string;
  var
    TZ: TTimeZoneInformation;
    Hour: Integer;
    Min: Integer;
    Offset: TDateTime;
    SysTime: SYSTEMTIME;
    DateTime: TDateTime;
    DateTimeFormat: string;
  begin
    GetTimeZoneInformation(TZ);
    Hour := Abs(TZ.Bias) div 60;
    Min := Abs(TZ.Bias) mod 60;
    Offset := EncodeTime(Hour, Min, 0, 0);

    VariantTimeToSystemTime(VTime, SysTime);
    DateTime := SystemTimeToDateTime(SysTime) + Offset;

    with FormatSettings do
      DateTimeFormat := ShortDateFormat + ' ' + ShortTimeFormat;
    Result := FormatDateTime(DateTimeFormat, DateTime);
  end;

  function FormatPropVariant(HR: HResult; CID: SHCOLUMNID; PV: TPropVariant): string;
  begin
    Result := '';
    if HR = S_OK then
      case CID.pid of
        PID_STG_SIZE: Result := FormatFileSize(PV.ulVal);
      else
        case PV.vt of
          VT_BSTR: Result := PV.bstrVal;
          VT_UI8: Result := IntToStr(PV.lVal);
          VT_DATE: Result := FormatLocalVariantTime(TPropVariant(PV).date);
        end;
      end;
  end;

var
  SF2: IShellFolder2;
  ISD: IShellDetails;
  SD: TShellDetails;
  HR: HResult;

  PV: TPropVariant;
  ColumnID: SHCOLUMNID;

  FindData: TWin32FindData;
begin
  SF2 := Parent.ShellFolder2;

  if Assigned(SF2) then
  begin
    HR := SF2.GetDetailsOf(FPIDL, Index, SD);
    if HR = S_OK then
      Result := FormatShellDetails(HR, FPIDL, SD)
    else
    begin
      // Win7 ̃oOHCuł GetDetailsOf s邽 GetDetailsEx ł蒼B
      SF2.MapColumnToSCID(Index, ColumnID);
      VariantInit(OleVariant(PV));
      HR := SF2.GetDetailsEx(FPIDL, ColumnID, @PV);
      Result := FormatPropVariant(HR, ColumnID, PV);
    end;
  end
  else
  begin
    ISD := ShellDetails;
    if Assigned(ISD) then
    begin
      HR := ISD.GetDetailsOf(FPIDL, Index, SD);
      Result := FormatShellDetails(HR, FPIDL, SD);
    end
    else if (fpFileSystem in Properties) then
    begin
      GetDetailsOf(Self, FindData);
      Result := DefaultDetailColumn(FindData, Index);
    end;
  end;
end;

function TShellFolder.DetailsEx(ColumnID: SHCOLUMNID): TPropVariant;
var
  SF2: IShellFolder2;
  HR: HResult;
begin
  SF2 := Parent.ShellFolder2;
  if Assigned(SF2) then
  begin
    VariantInit(OleVariant(Result));
    HR := SF2.GetDetailsEx(FPIDL, ColumnID, @Result);
  end else
    HR := S_FALSE;
  if HR <> S_OK then
    NoFolderDetails(Self, HR);
end;

function TShellFolder.DetailsEx(Index: Integer): TPropVariant;
var
  SF2: IShellFolder2;
  ColumnID: SHCOLUMNID;
begin
  SF2 := Parent.ShellFolder2;
  if Assigned(SF2) then
  begin
    SF2.MapColumnToSCID(Index, ColumnID);
    Result := DetailsEx(ColumnID);
  end else
    NoFolderDetails(Self, S_FALSE);
end;

function TShellFolder.ParentShellFolder: IShellFolder;
begin
  if FParent <> nil then
    Result := FParent.ShellFolder
  else
    OLECheck(SHGetDesktopFolder(Result));
end;

function TShellFolder.Properties: TShellFolderProperties;
begin
  Result := GetProperties(ParentShellFolder, FPIDL);
end;

function TShellFolder.Capabilities: TShellFolderCapabilities;
begin
  Result := GetCaps(ParentShellFolder, FPIDL);
end;

function TShellFolder.SubFolders: Boolean;
begin
  Result := HasSubFolders(ParentShellFolder, FPIDL);
end;

function TShellFolder.IsFolder: Boolean;
begin
  Result := ShellUtils.IsFolder(ParentShellFolder, FPIDL);
end;

function TShellFolder.PathName: string;
begin
  Result := GetParseName(DesktopShellFolder, FFullPIDL);
end;

function TShellFolder.DisplayName: string;
var
  ParentFolder: IShellFolder;
begin
  if Assigned(Parent) then
    ParentFolder := ParentShellFolder
  else
    ParentFolder := DesktopShellFolder;
  Result := GetFolderName(ParentFolder, FPIDL);
end;

function TShellFolder.Rename(const NewName: WideString): Boolean;
var
  NewPIDL: PItemIDList;
begin
  Result := False;
  if not (fcCanRename in Capabilities) then Exit;

  Result := ParentShellFolder.SetNameOf(0, FPIDL, PWideChar(NewName), SHGDN_NORMAL, NewPIDL) = S_OK;
  if Result then
  begin
    DisposePIDL(FPIDL);
    DisposePIDL(FFullPIDL);
    FPIDL := NewPIDL;
    if (FParent <> nil) then
      FFullPIDL := ConcatPIDLs(FParent.FPIDL, NewPIDL)
    else
      FFullPIDL := CopyPIDL(NewPIDL);
  end
  else
    Raise Exception.Create(Format(SRenamedFailedError,[NewName]));
end;

function TShellFolder.ImageIndex(LargeIcon: Boolean): Integer;
begin
  Result := GetShellImage(AbsoluteID, LargeIcon, False);
end;

function TShellFolder.ExecuteDefault: Integer;
var
  SEI: TShellExecuteInfo;
begin
  FillChar(SEI, SizeOf(SEI), 0);
  with SEI do
  begin
    cbSize := SizeOf(SEI);
    wnd := Application.Handle;
    fMask := SEE_MASK_INVOKEIDLIST;
    lpIDList := AbsoluteID;
    nShow := SW_SHOW;
  end;
  Result := Integer(ShellExecuteEx(@SEI));
end;

{ TCustomShellChangeNotifier }

constructor TCustomShellChangeNotifier.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  if WM_SHCHANGENOTIFY = 0 then
    WM_SHCHANGENOTIFY := RegisterWindowMessage('ShellCtrls SHChangeNotify Message');
  FHandle := AllocateHWnd(WndProc);
  FRegistID := 0;
  FRoot := SRFDesktop;
  FSources := 0;
  FEvents := 0;
  FRecursive := True;
end;

procedure TCustomShellChangeNotifier.WndProc(var Message: TMessage);
var
  Lock: THandle;
  PIDLs: PAbsoluteIDs;
  EventID: Integer;
  Event: TNotificationEvent;
begin
  if Message.Msg = WM_SHCHANGENOTIFY then
  begin
    Lock := LockChangeNotify(Message.WParam, Message.LParam, PIDLs, EventID);
    try
      if Lock > 0 then
      begin
        case EventID of
          SHCNE_RENAMEITEM: Event := neRenameItem;
          SHCNE_CREATE: Event := neCreate;
          SHCNE_DELETE: Event := neDelete;
          SHCNE_MKDIR: Event := neMkdir;
          SHCNE_RMDIR: Event := neRmdir;
          SHCNE_MEDIAINSERTED: Event := neMediaInserted;
          SHCNE_MEDIAREMOVED: Event := neMediaRemoved;
          SHCNE_DRIVEREMOVED: Event := neDriveRemoved;
          SHCNE_DRIVEADD: Event := neDriveAdd;
          SHCNE_NETSHARE: Event := neNetShare;
          SHCNE_NETUNSHARE: Event := neNetUnshare;
          SHCNE_ATTRIBUTES: Event := neAttributes;
          SHCNE_UPDATEDIR: Event := neUpdateDir;
          SHCNE_UPDATEITEM: Event := neUpdateItem;
          SHCNE_SERVERDISCONNECT: Event := neServerDisconnect;
          SHCNE_UPDATEIMAGE: Event := neUpdateImage;
          SHCNE_DRIVEADDGUI: Event := neDriveAddGUI;
          SHCNE_RENAMEFOLDER: Event := neRenameFolder;
          SHCNE_FREESPACE: Event := neFreeSapce;
          SHCNE_ASSOCCHANGED: Event := neAssocChanged;
        else
          Exit;
        end;
        if Assigned(FOnChange) then
          FOnChange(Self, Event, PIDLs^.Item1, PIDLs^.Item2);
      end;
    finally
      UnlockChangeNotify(Lock);
    end;
  end
  else
    Message.Result := DefWindowProc(FHandle, Message.Msg, Message.WParam, Message.LParam);
end;

function TCustomShellChangeNotifier.Start: Boolean;
var
  Entry: TSHChangeNotifyEntry;
begin
  Stop;
  if not (csDesigning in ComponentState) then
  begin
    Entry.pidl := RootIDList(FRoot);
    Entry.fRecursive := FRecursive;
    FRegistID := SHChangeNotifyRegister(FHandle, FSources, FEvents, WM_SHCHANGENOTIFY, 1, Entry);
  end;
  Result := FRegistID <> 0;
end;

procedure TCustomShellChangeNotifier.Stop;
begin
  if Enabled then
    SHChangeNotifyDeregister(FRegistID);
  FRegistID := 0;
end;

procedure TCustomShellChangeNotifier.SetRoot(Value: TRoot);
begin
  if not SameText(FRoot, Value) then
  begin
    FRoot := Value;
    if Enabled then
      Start;
  end;
end;

function TCustomShellChangeNotifier.GetSources: TEventSources;
begin
  Result := [];
  if (FSources and SHCNRF_InterruptLevel) <> 0 then Include(Result, esInterruptLevel);
  if (FSources and SHCNRF_ShellLevel) <> 0 then Include(Result, esShellLevel);
  if (FSources and SHCNRF_RecursiveInterrupt) <> 0 then Include(Result, esRecursiveInterrupt);
end;

procedure TCustomShellChangeNotifier.SetSources(Value: TEventSources);
var
  SHCNRF: Integer;
begin
  SHCNRF := SHCNRF_NewDelivery;
  if esInterruptLevel in Value then SHCNRF := SHCNRF or SHCNRF_InterruptLevel;
  if esShellLevel in Value then SHCNRF := SHCNRF or SHCNRF_ShellLevel;
  if esRecursiveInterrupt in Value then SHCNRF := SHCNRF or SHCNRF_RecursiveInterrupt;
  if SHCNRF <> FSources then
  begin
    FSources := SHCNRF;
    if Enabled then
      Start;
  end;
end;

function TCustomShellChangeNotifier.GetEvents: TNotificationEvents;
begin
  Result := [];
  if (FEvents and SHCNE_RENAMEITEM) <> 0 then Include(Result, neRenameItem);
  if (FEvents and SHCNE_CREATE) <> 0 then Include(Result, neCreate);
  if (FEvents and SHCNE_DELETE) <> 0 then Include(Result, neDelete);
  if (FEvents and SHCNE_MKDIR) <> 0 then Include(Result, neMkdir);
  if (FEvents and SHCNE_RMDIR) <> 0 then Include(Result, neRmdir);
  if (FEvents and SHCNE_MEDIAINSERTED) <> 0 then Include(Result, neMediaInserted);
  if (FEvents and SHCNE_MEDIAREMOVED) <> 0 then Include(Result, neMediaRemoved);
  if (FEvents and SHCNE_DRIVEREMOVED) <> 0 then Include(Result, neDriveRemoved);
  if (FEvents and SHCNE_DRIVEADD) <> 0 then Include(Result, neDriveAdd);
  if (FEvents and SHCNE_NETSHARE) <> 0 then Include(Result, neNetShare);
  if (FEvents and SHCNE_NETUNSHARE) <> 0 then Include(Result, neNetUnshare);
  if (FEvents and SHCNE_ATTRIBUTES) <> 0 then Include(Result, neAttributes);
  if (FEvents and SHCNE_UPDATEDIR) <> 0 then Include(Result, neUpdateDir);
  if (FEvents and SHCNE_UPDATEITEM) <> 0 then Include(Result, neUpdateItem);
  if (FEvents and SHCNE_SERVERDISCONNECT) <> 0 then Include(Result, neServerDisconnect);
  if (FEvents and SHCNE_UPDATEIMAGE) <> 0 then Include(Result, neUpdateImage);
  if (FEvents and SHCNE_DRIVEADDGUI) <> 0 then Include(Result, neDriveAddGUI);
  if (FEvents and SHCNE_RENAMEFOLDER) <> 0 then Include(Result, neRenameFolder);
  if (FEvents and SHCNE_FREESPACE) <> 0 then Include(Result, neFreeSapce);
  if (FEvents and SHCNE_ASSOCCHANGED) <> 0 then Include(Result, neAssocChanged);
end;

procedure TCustomShellChangeNotifier.SetEvents(Value: TNotificationEvents);
var
  SHCNE: Integer;
begin
  SHCNE := 0;
  if neRenameItem in Value then SHCNE := SHCNE or SHCNE_RENAMEITEM;
  if neCreate in Value then SHCNE := SHCNE or SHCNE_CREATE;
  if neDelete in Value then SHCNE := SHCNE or SHCNE_DELETE;
  if neMkdir in Value then SHCNE := SHCNE or SHCNE_MKDIR;
  if neRmdir in Value then SHCNE := SHCNE or SHCNE_RMDIR;
  if neMediaInserted in Value then SHCNE := SHCNE or SHCNE_MEDIAINSERTED;
  if neMediaRemoved in Value then SHCNE := SHCNE or SHCNE_MEDIAREMOVED;
  if neDriveRemoved in Value then SHCNE := SHCNE or SHCNE_DRIVEREMOVED;
  if neDriveAdd in Value then SHCNE := SHCNE or SHCNE_DRIVEADD;
  if neNetShare in Value then SHCNE := SHCNE or SHCNE_NETSHARE;
  if neNetUnshare in Value then SHCNE := SHCNE or SHCNE_NETUNSHARE;
  if neAttributes in Value then SHCNE := SHCNE or SHCNE_ATTRIBUTES;
  if neUpdateDir in Value then SHCNE := SHCNE or SHCNE_UPDATEDIR;
  if neUpdateItem in Value then SHCNE := SHCNE or SHCNE_UPDATEITEM;
  if neServerDisconnect in Value then SHCNE := SHCNE or SHCNE_SERVERDISCONNECT;
  if neUpdateImage in Value then SHCNE := SHCNE or SHCNE_UPDATEIMAGE;
  if neDriveAddGUI in Value then SHCNE := SHCNE or SHCNE_DRIVEADDGUI;
  if neRenameFolder in Value then SHCNE := SHCNE or SHCNE_RENAMEFOLDER;
  if neFreeSapce in Value then SHCNE := SHCNE or SHCNE_FREESPACE;
  if neAssocChanged in Value then SHCNE := SHCNE or SHCNE_ASSOCCHANGED;
  if SHCNE <> FEvents then
  begin
    FEvents := SHCNE;
    if Enabled then
      Start;
  end;
end;

procedure TCustomShellChangeNotifier.SetRecursive(Value: Boolean);
begin
  if Value <> FRecursive then
  begin
    FRecursive := Value;
    if Enabled then
      Start;
  end;
end;

function TCustomShellChangeNotifier.GetEnabled: Boolean;
begin
  Result := FRegistID > 0;
end;

procedure TCustomShellChangeNotifier.SetEnabled(Value: Boolean);
begin
  if Value <> Enabled then
  begin
    if Value then
      Start
    else
      Stop;
  end;
end;

destructor TCustomShellChangeNotifier.Destroy;
begin
  Stop;
  DeallocateHWnd(FHandle);

  inherited Destroy;
end;


{ TCustomShellTreeView }

constructor TCustomShellTreeView.Create(AOwner: TComponent);
var
  FileInfo: TSHFileInfo;
begin
  inherited Create(AOwner);
  FRootFolder := nil;
  ShowRoot := False;
  FObjectTypes := [otFolders];
  RightClickSelect := True;
  FAutoContext := True;
  FUpdating := False;
  FComboBox := nil;
  FListView := nil;
  FImageListChanging := False;
  FUseShellImages := True;
  FImages := SHGetFileInfo('.',     { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  FNotifier := TShellChangeNotifier.Create(Self);
  with FNotifier do
  begin
    FComponentStyle := FNotifier.FComponentStyle + [csSubComponent];
    Sources := [esShellLevel, esRecursiveInterrupt];
    Events := [neRenameItem, neCreate, neDelete, neMkdir, neRmdir, neMediaInserted, neMediaRemoved,
      neDriveRemoved, neDriveAdd, neUpdateDir, neUpdateItem, neRenameFolder];
    OnChange := RefreshEvent;
  end;
  FRoot := SRFDesktop;
  FLoadingRoot := False;
  ReadOnly := False;
end;

procedure TCustomShellTreeView.ClearItems;
var
  i: Integer;
begin
  if not HandleAllocated or (Items.Count = 0) then
    Exit;
  Items.BeginUpdate;
  try
    for i := 0 to Items.Count - 1 do
    begin
      if Assigned(Folders[i]) then
        Folders[i].Free;
      Items[i].Data := nil;
    end;
    Items.Clear;
  finally
    Items.EndUpdate;
  end;
end;

procedure TCustomShellTreeView.CreateWnd;
begin
  inherited CreateWnd;
  if (Items.Count > 0) then
    ClearItems;
  if not Assigned(Images) then SetUseShellImages(FUseShellImages);
  { TODO: What is the Items.Count test for here? }
  if not FLoadingRoot then
    CreateRoot;
end;

destructor TCustomShellTreeView.Destroy;
begin
  ClearItems;
  FRootFolder.Free;
  FNotifier.Free;
  inherited;
end;

procedure TCustomShellTreeView.DestroyWnd;
begin
  ClearItems;
  inherited DestroyWnd;
end;

procedure TCustomShellTreeView.CommandCompleted(Verb: string; Succeeded: Boolean);
var
  Fldr: TShellFolder;
begin
  if not Succeeded then Exit;
  if Assigned(Selected) then
  begin
    if SameText(Verb, SCmdVerbDelete) then
    begin
      Fldr := TShellFolder(Selected.Data);
      if not FileExists(Fldr.PathName) then
      begin
        Selected.Data := nil;
        Selected.Delete;
        FreeAndNil(Fldr);
      end;
    end
    else if SameText(Verb, SCmdVerbPaste) then
      Refresh(Selected)
    else if SameText(Verb, SCmdVerbOpen) then
      SetCurrentDirectory(PChar(FSavePath));
  end;
end;

procedure TCustomShellTreeView.ExecuteCommand(Verb: string; var Handled: Boolean);
var
  szPath: array[0..MAX_PATH] of Char;
begin
  if SameText(Verb, SCmdVerbRename) and Assigned(Selected) then
  begin
    Selected.EditText;
    Handled := True;
  end
  else if SameText(Verb, SCmdVerbOpen) then
  begin
    GetCurrentDirectory(MAX_PATH, szPath);
    FSavePath := StrPas(szPath);
    StrPCopy(szPath, ExtractFilePath(TShellFolder(Selected.Data).PathName));
    SetCurrentDirectory(szPath);
  end;
end;

function TreeSortFunc(Node1, Node2: TTreeNode; Param: Integer): Integer; stdcall;
begin
  Result := SmallInt(TShellFolder(Node1.Data).ParentShellFolder.CompareIDs(
       0, TShellFolder(Node1.Data).RelativeID, TShellFolder(Node2.Data).RelativeID));
end;

procedure TCustomShellTreeView.InitNode(NewNode: TTreeNode; ID: PItemIDList; ParentNode: TTreeNode);
var
  CanAdd: Boolean;
  NewFolder: IShellFolder;
  AFolder: TShellFolder;
begin
  AFolder := TShellFolder(ParentNode.Data);
  NewFolder := GetIShellFolder(AFolder.ShellFolder, ID);
  NewNode.Data := TShellFolder.Create(AFolder, ID, NewFolder);
  with TShellFolder(NewNode.Data) do
  begin
    NewNode.Text := DisplayName;
    if FUseShellImages and not Assigned(Images) then
    begin
      NewNode.ImageIndex := GetShellImage(AbsoluteID, False, False);
      NewNode.SelectedIndex := GetShellImage(AbsoluteID, False, True);
    end;
    if NewNode.SelectedIndex = 0 then NewNode.SelectedIndex := NewNode.ImageIndex;
    NewNode.HasChildren := SubFolders;
    if fpShared in Properties then NewNode.OverlayIndex := 0;
    if (otNonFolders in ObjectTypes) and (ShellFolder <> nil) then
      NewNode.HasChildren := HasSubItems(ShellFolder, ObjectFlags(FObjectTypes));
  end;

  CanAdd := True;
  if Assigned(FOnAddFolder) then FOnAddFolder(Self, TShellFolder(NewNode.Data), CanAdd);
  if not CanAdd then
    NewNode.Delete;
end;

procedure TCustomShellTreeView.PopulateNode(Node: TTreeNode);
var
  Current: TShellFolder;
  ID: PItemIDList;
  EnumList: IEnumIDList;
  NewNode: TTreeNode;
  NumIDs: LongWord;
  SaveCursor: TCursor;
  HR: HResult;
begin
  SaveCursor := Screen.Cursor;
  Screen.Cursor := crHourglass;
  Items.BeginUpdate;
  try
    Current := TShellFolder(Node.Data);
    try
      HR := Current.ShellFolder.EnumObjects(Application.Handle,
                     ObjectFlags(FObjectTypes) + SHCONTF_NAVIGATION_ENUM, //Cȕꏊ񋓁B
                     EnumList);
      if HR <> 0 then Exit;
    except on E:Exception do end;

    while EnumList.Next(1, ID, NumIDs) = S_OK do
    begin
      NewNode := Items.AddChild(Node, '');
      InitNode(NewNode, ID, Node);
    end;

    if not IsLibrary(Current.FFullPIDL) then  //Cȕꏊ̓\[gȂB
      Node.CustomSort(@TreeSortFunc, 0);
  finally
    Items.EndUpdate;
    Screen.Cursor := SaveCursor;
  end;
end;

procedure TCustomShellTreeView.SetObjectTypes(Value: TShellObjectTypes);
begin
  if Value <> FObjectTypes then
  begin
    FObjectTypes := Value;
    RootChanged;
  end;
end;

procedure TCustomShellTreeView.CreateRoot;
var
  RootNode: TTreeNode;
  ErrorMsg: string;
begin
  if (csLoading in ComponentState) then Exit;
  try
    FRootFolder := CreateRootFolder(FRootFolder, FOldRoot, FRoot);
    ErrorMsg := '';
  except
    on E: Exception do ErrorMsg := E.Message;
  end;

  if Assigned(FRootFolder) then
  begin
    FLoadingRoot := True;
    try
      if Items.Count > 0 then
        ClearItems;
      RootNode := Items.Add(nil, '');
      with RootNode do
      begin
        Data := TShellFolder.Create(nil, FRootFolder.AbsoluteID, FRootFolder.ShellFolder);

        Text := GetFolderName(DesktopShellFolder, TShellFolder(Data).AbsoluteID);

        if FUseShellImages and not Assigned(Images) then
        begin
          ImageIndex := GetShellImage(TShellFolder(Data).AbsoluteID, False, False);
          SelectedIndex := GetShellImage(TShellFolder(Data).AbsoluteID, False, True);
        end;
        HasChildren := TShellFolder(Data).SubFolders;
      end;
      RootNode.Expand(False);
      Selected := RootNode;

      FNotifier.Root := FRoot;
    finally
      FLoadingRoot := False;
    end;
  end;
  if ErrorMsg <> '' then
    Raise Exception.Create(ErrorMsg);
end;

function TCustomShellTreeView.CanExpand(Node: TTreeNode): Boolean;
var
  Fldr: TShellFolder;
begin
  Result := True;
  Fldr := TShellFolder(Node.Data);
  if (csDesigning in ComponentState) and (Node.Level > 0) then Exit;
  if Assigned(OnExpanding) then OnExpanding(Self, Node, Result);
  if Result then
    if Fldr.IsFolder and (Node.HasChildren) and (Node.Count = 0) then
      PopulateNode(Node)
    else if not Fldr.IsFolder then
    begin
      ShellExecute(Handle, nil, PChar(Fldr.PathName), nil,
        PChar(ExtractFilePath(Fldr.PathName)), 0);
    end;
  Node.HasChildren := Node.Count > 0;
end;

procedure TCustomShellTreeView.KeyDown(var Key: Word; Shift: TShiftState);
begin
  inherited;
  if Selected = nil then Exit;
  case Key of
    VK_RETURN:
      if ssAlt in Shift then
      begin
        DoContextMenuVerb(SelectedFolder, cmvProperties);
        Key := 0;
      end;
    VK_F5: Refresh(Selected);
    VK_F2: if not ReadOnly then Selected.EditText;
  end;
end;

procedure TCustomShellTreeView.Edit(const Item: TTVItem);
var
  S: string;
  Node: TTreeNode;
begin
  with Item do
    if pszText <> nil then
    begin
      S := pszText;
      Node := Items.GetNode(Item.hItem);
      if Assigned(OnEdited) then OnEdited(Self, Node, S);
      if (Node <> nil) and TShellFolder(Node.Data).Rename(S) then
        Node.Text := S;
    end;
end;

function TCustomShellTreeView.FindAbsoluteID(StartNode: TTreeNode; ID: PItemIDList;
  Wrap: Boolean): TTreeNode;
var
  StartIndex, i: Integer;
  Node: TTreeNode;
begin
  Result := nil;
  if Assigned(StartNode) then
    StartIndex := StartNode.Index
  else
    StartIndex := 0;
  for i := StartIndex to Items.Count - 1 do
  begin
    Node := Items.Item[i];
    if SameAbsoluteID(TShellFolder(Node.Data).AbsoluteID, ID) then
    begin
      Result := Node;
      Exit;
    end;
  end;
  if Wrap then
    for i := 0 to StartIndex - 1 do
    begin
      Node := Items.Item[i];
      if SameAbsoluteID(TShellFolder(Node.Data).AbsoluteID, ID) then
      begin
        Result := Node;
        Exit;
      end;
    end;
end;

function TCustomShellTreeView.FindRelativeID(ParentNode: TTreeNode; ID: PItemIDList): TTreeNode;
begin
  Result := ParentNode.GetFirstChild;
  while (Result <> nil) do
  begin
    if SameRelativeID(TShellFolder(ParentNode.Data).ShellFolder,
      TShellFolder(Result.Data).RelativeID, ID) then Exit;
    Result := ParentNode.GetNextChild(Result);
  end;
end;

procedure TCustomShellTreeView.Delete(Node: TTreeNode);
begin
  if Assigned(Node.Data) then
  begin
    TShellFolder(Node.Data).Free;
    Node.Data := nil;
  end;
  inherited Delete(Node);
end;

procedure TCustomShellTreeView.RootChanged;
begin
  if FUpdating then Exit;
  FUpdating := True;
  try
    CreateRoot;
    if Assigned(FComboBox) then
      FComboBox.SetRoot(FRoot);
    if Assigned(FListView) then
      FListView.SetRoot(FRoot);
  finally
    FUpdating := False;
  end;
end;

function TCustomShellTreeView.FolderExists(FindID: PItemIDList; InNode: TTreeNode): TTreeNode;
var
  ALevel: Integer;
begin
  Result := nil;
  ALevel := InNode.Level;
  repeat
    if DesktopShellFolder.CompareIDs(
      0,
      FindID,
      TShellFolder(InNode.Data).AbsoluteID) = 0 then
    begin
      Result := InNode;
      Exit;
    end else
      InNode := InNode.GetNext;
  until (InNode = nil) or (InNode.Level <= ALevel);
end;

procedure TCustomShellTreeView.RefreshEvent(Sender: TObject;
  Event: TNotificationEvent; PIDL1, PIDL2: PItemIDList);
var
  Node: TTreeNode;
  ParentID: PItemIDList;
begin
  case Event of
    neRenameItem, neRenameFolder:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
      begin
        TShellFolder(Node.Data).Free;
        InitNode(Node, ExtractRelativeID(PIDL2), Node.Parent);
      end;
    end;
    neCreate, neMkdir:
    begin
      ParentID := CopyPIDL(PIDL1);
      StripLastID(ParentID);
      Node := FindAbsoluteID(Selected, ParentID, True);
      if Assigned(Node) then
      begin
        Node := Items.AddChild(Node, '');
        InitNode(Node, ExtractRelativeID(PIDL1), Node.Parent);
      end;
      DisposePIDL(ParentID);
    end;
    neDelete, neRmdir:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
      begin
        if Node.HasChildren then
          Node.DeleteChildren;
        Node.Delete;
      end;
    end;
    neMediaInserted, neMediaRemoved,
    neDriveRemoved, neDriveAdd:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
      begin
        TShellFolder(Node.Data).Free;
        InitNode(Node, ExtractRelativeID(PIDL1), Node.Parent);
      end;
    end;
    neNetShare:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
        Node.OverlayIndex := 0;
    end;
    neNetUnshare:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
        Node.OverlayIndex := -1;
    end;
    neAttributes:
    begin
      Node := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Node) then
      begin
        TShellFolder(Node.Data).Free;
        InitNode(Node, ExtractRelativeID(PIDL1), Node.Parent);
      end;
    end;
    neUpdateDir: Node := FindAbsoluteID(Selected, PIDL1, True);
    neUpdateItem: Node := FindAbsoluteID(Selected, PIDL1, True);
    neServerDisconnect: Node := FindAbsoluteID(Selected, PIDL1, True);
    neUpdateImage: Node := nil;
    neDriveAddGUI: Node := nil;
    neFreeSapce: Node := FindAbsoluteID(Selected, PIDL1, True);
    neAssocChanged: Node := nil;
  else
    Node := nil;
  end;
  if Assigned(FOnChangeNotify) then
    FOnChangeNotify(Self, Event, Node);
end;

procedure TCustomShellTreeView.Refresh(Node: TTreeNode);
var
  NewNode, OldNode, Temp: TTreeNode;
  OldFolder, NewFolder: TShellFolder;
  ThisLevel: Integer;
  SaveCursor: TCursor;
  TopID, SelID: PItemIDList;
  ParentFolder: TShellFolder;
begin
  if TShellFolder(Node.Data).ShellFolder = nil then Exit;
  SaveCursor := Screen.Cursor;
  ParentFolder := nil;
  //Need absolute PIDL to search for top item once tree is rebuilt.
  TopID := CopyPIDL(TShellFolder(TopItem.Data).RelativeID);
  if TShellFolder(TopItem.Data).Parent <> nil then
    TopID := ConcatPIDLs(TShellFolder(TopItem.Data).Parent.AbsoluteID, TopID);
  //Same thing for SelID
  SelID := nil;
  if (Selected <> nil) and (Selected.Data <> nil) then
  begin
    SelID := CopyPIDL(TShellFolder(Selected.Data).RelativeID);
    if TShellFolder(Selected.Data).Parent <> nil then
      SelID := ConcatPIDLs(TShellFolder(Selected.Data).Parent.AbsoluteID, SelID);
  end;

  Items.BeginUpdate;
  try
    Screen.Cursor := crHourglass;
    OldFolder := Node.Data;
    NewNode := Items.Insert(Node, '');
    if Node.Parent <> nil then
      ParentFolder := TShellFolder(Node.Parent.Data);
    NewNode.Data := TShellFolder.Create(ParentFolder,
                                   OldFolder.RelativeID,
                                   OldFolder.ShellFolder);
    PopulateNode(NewNode);
    with NewNode do
    begin
      NewFolder := Data;
      ImageIndex := GetShellImage(NewFolder.AbsoluteID, False, False);
      SelectedIndex := GetShellImage(NewFolder.AbsoluteID, False, True);
      HasChildren := NewFolder.SubFolders;
      Text := NewFolder.DisplayName;
    end;

    ThisLevel := Node.Level;
    OldNode := Node;
    repeat
      Temp := FolderExists(TShellFolder(OldNode.Data).AbsoluteID, NewNode);
      if (Temp <> nil) and OldNode.Expanded then
        Temp.Expand(False);
      OldNode := OldNode.GetNext;
    until (OldNode = nil) or (OldNode.Level = ThisLevel);

    if Assigned(Node.Data) then
    begin
      TShellFolder(Node.Data).Free;
      Node.Data := nil;
    end;
    Node.Delete;
    if SelID <> nil then
    begin
      Temp := FolderExists(SelID, Items[0]);
      Selected := Temp;
    end;
    Temp := FolderExists(TopID, Items[0]);
    TopItem := Temp;
  finally
    Items.EndUpdate;
    DisposePIDL(TopID);
    if SelID <> nil then DisposePIDL(SelID);
    Screen.Cursor := SaveCursor;
  end;
end;

procedure TCustomShellTreeView.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FComboBox) then
      FComboBox := nil
    else if (AComponent = FListView) then
      FListView := nil;
  end;
end;

function TCustomShellTreeView.CanChange(Node: TTreeNode): Boolean;
var
  Fldr: TShellFolder;
  StayFresh: Boolean;
begin
  Result := inherited CanChange(Node);
  if Result and (not FUpdating) and Assigned(Node) then
  begin
    Fldr := TShellFolder(Node.Data);
    StayFresh := FAutoRefresh;
    AutoRefresh := False;
    if not Fldr.IsFolder then
      Fldr := Fldr.Parent;
    FUpdating := True;
    try
      if Assigned(FComboBox) then
        FComboBox.TreeUpdate(Fldr.AbsoluteID);
      if Assigned(FListView) then
        FListView.TreeUpdate(Fldr.AbsoluteID);
    finally
      FUpdating := False;
    end;
    FNodeToMonitor := Node;
    try
      AutoRefresh := StayFresh;
    finally
      FNodeToMonitor := nil;
    end;
  end;
end;

function TCustomShellTreeView.GetFolder(Index: Integer): TShellFolder;
begin
  Result := TShellFolder(Items[Index].Data);
end;

function TCustomShellTreeView.SelectedFolder: TShellFolder;
begin
  Result := nil;
  if Selected <> nil then Result := TShellFolder(Selected.Data);
end;

function TCustomShellTreeView.GetPath: string;
begin
  if SelectedFolder <> nil then
    Result := SelectedFolder.PathName
  else
    Result := '';
end;

procedure TCustomShellTreeView.SetPath(const Value: string);
var
  NewPIDL: PItemIDList;
begin
  try
    NewPIDL := ParseDisplayName(DesktopShellFolder, Value);
    try
      SetPathFromID(NewPIDL);
    finally
      DisposePIDL(NewPIDL);
    end;
  except
    on EOleSysError do
      raise EInvalidPath.CreateFmt(SErrorSettingPath, [Value]);
  end;
end;

procedure TCustomShellTreeView.SetPathFromID(ID: PItemIDList);
var
  I: Integer;
  Pidls: TList;
  Temp, Node: TTreeNode;
begin
  if FUpdating or (csLoading in ComponentState)
    or ((SelectedFolder <> nil) and SameAbsoluteID(SelectedFolder.AbsoluteID, ID)) then Exit;
  FUpdating := True;
  Items.BeginUpdate;
  try
    Pidls := CreatePIDLList(ID);
    try
      Node := Items[0];
      for I := 0 to Pidls.Count-1 do
      begin
        Temp := FolderExists(Pidls[I], Node);
        if Temp <> nil then
        begin
          Node := Temp;
          Node.Expand(False);
        end;
      end;
      Node := FolderExists(ID, Node);
      Selected := Node;
      if Assigned(Node) then
      begin
        if Assigned(FListView) then
          FListView.TreeUpdate(TShellFolder(Node.Data).AbsoluteID);
        if Assigned(FComboBox) then
          FComboBox.TreeUpdate(TShellFolder(Node.Data).AbsoluteID);
      end;
    finally
      DestroyPIDLList(Pidls);
    end;
  finally
    Items.EndUpdate;
    FUpdating := False;
  end;
end;

procedure TCustomShellTreeView.SetRoot(const Value: TRoot);
begin
  if not SameText(FRoot, Value) then
  begin
    FOldRoot := FRoot;
    FRoot := Value;
    RootChanged;
  end;
end;

procedure TCustomShellTreeView.GetImageIndex(Node: TTreeNode);
begin
  if Assigned(Images) then
    inherited GetImageIndex(Node);
end;

procedure TCustomShellTreeView.GetSelectedIndex(Node: TTreeNode);
begin
  if Assigned(Images) then
    inherited GetSelectedIndex(Node);
end;

procedure TCustomShellTreeView.WndProc(var Message: TMessage);
var
  ImageListHandle: THandle;
begin
  case Message.Msg of
    WM_INITMENUPOPUP,
    WM_DRAWITEM,
    WM_MENUCHAR,
    WM_MEASUREITEM:
      if Assigned(ICM2) then
      begin
        ICM2.HandleMenuMsg(Message.Msg, Message.wParam, Message.lParam);
        Message.Result := 0;
      end;

    TVM_SETIMAGELIST:
      if not FImageListChanging then
      begin
        FImageListChanging := True;
        try
          if not Assigned(Images) then
            if FUseShellImages then
              ImageListHandle := FImages
            else
              ImageListHandle := 0
          else
            ImageListHandle := Images.Handle;

          SendMessage(Self.Handle, TVM_SETIMAGELIST, TVSIL_NORMAL, ImageListHandle);
          //RootChanged;
        finally
          FImageListChanging := False;
        end;
      end
      else
        inherited;
  else
    inherited WndProc(Message);
  end;
end;

procedure TCustomShellTreeView.SetUseShellImages(const Value: Boolean);
var
  ImageListHandle: THandle;
begin
  FUseShellImages := Value;
  if not Assigned(Images) then
    if FUseShellImages then
      ImageListHandle := FImages
    else
      ImageListHandle := 0
  else
    ImageListHandle := Images.Handle;
  SendMessage(Handle, TVM_SETIMAGELIST, TVSIL_NORMAL, ImageListHandle);
end;

procedure TCustomShellTreeView.WMDestroy(var Message: TWMDestroy);
begin
  ClearItems;
  inherited;
end;

procedure TCustomShellTreeView.Loaded;
begin
  inherited Loaded;
  CreateRoot;
end;

procedure TCustomShellTreeView.DoContextPopup(MousePos: TPoint;
  var Handled: Boolean);
begin
  if AutoContextMenus and not (Assigned(PopupMenu) and PopupMenu.AutoPopup) then
    InvokeContextMenu(Self, SelectedFolder, MousePos.X, MousePos.Y)
  else
    inherited;
end;

procedure TCustomShellTreeView.SetComboBox(Value: TCustomShellComboBox);
begin
  if Value = FComboBox then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FTreeView := Self;
  end else
    if FComboBox <> nil then
      FComboBox.FTreeView := nil;

  if FComboBox <> nil then
    FComboBox.FreeNotification(Self);
  FComboBox := Value;
end;

procedure TCustomShellTreeView.SetListView(const Value: TCustomShellListView);
begin
  if Value = FListView then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FTreeView := Self;
  end else
    if FListView <> nil then
      FListView.FTreeView := nil;

  if FListView <> nil then
    FListView.FreeNotification(Self);
  FListView := Value;
end;

procedure TCustomShellTreeView.SetAutoRefresh(const Value: Boolean);
begin
  if Value <> FAutoRefresh then
  begin
    FAutoRefresh := Value;
    FNotifier.Enabled := not (csDesigning in ComponentState) and FAutoRefresh;
  end;
end;

{ TCustomShellComboBox }

var
  CompareFolder: TShellFolder = nil;  //\[gpB

constructor TCustomShellComboBox.Create(AOwner: TComponent);
var
  FileInfo: TSHFileInfo;
begin
  inherited Create(AOwner);
  FRootFolder := nil;
  FImages := SHGetFileInfo('.',    { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  ImageList_GetIconSize(FImages, FImageWidth, FImageHeight);
  FUpdating := False;
  Style := csExDropDown;
  FObjectTypes := [otFolders];
  FRoot := SRFDesktop;
  FUseShellImages := True;
end;

procedure TCustomShellComboBox.ClearItems;
var
  I: Integer;
begin
  ItemsEx.BeginUpdate;
  try
    for I := 0 to ItemsEx.Count-1 do
    begin
      if Assigned(Folders[i]) then
        Folders[I].Free;
      ItemsEx[I].Data := nil;
    end;
    ItemsEx.Clear;
  finally
    ItemsEx.EndUpdate;
  end;
end;

procedure TCustomShellComboBox.CreateRoot;
var
  AFolder: TShellFolder;
  Text: string;
  ImageIndex: Integer;
begin
  if (csLoading in ComponentState) then Exit;
  ItemsEx.BeginUpdate;
  try
    ClearItems;
    FRootFolder := CreateRootFolder(FRootFolder, FOldRoot, FRoot);
    AFolder := TShellFolder.Create(nil, FRootFolder.AbsoluteID, FRootFolder.ShellFolder);
    Text := AFolder.DisplayName;

    ImageIndex := GetShellImageIndex(AFolder);
    ItemsEx.AddItem(Text, ImageIndex, ImageIndex, -1, 0, AFolder);
    Init;
    ItemIndex := 0;
    if FUseShellImages then // Force image update
    begin
      SetUseShellImages(False);
      SetUseShellImages(True);
    end;
  finally
    ItemsEx.EndUpdate;
  end;    
end;

procedure TCustomShellComboBox.CreateWnd;
begin
  inherited CreateWnd;
  if FImages <> 0 then
    SendMessage(Handle, CBEM_SETIMAGELIST, 0, FImages);
  SetUseShellImages(FUseShellImages);
  if ItemsEx.Count = 0 then
    CreateRoot;
end;

procedure TCustomShellComboBox.DestroyWnd;
begin
  ClearItems;
  inherited DestroyWnd;
end;

procedure TCustomShellComboBox.SetObjectTypes(Value: TShellObjectTypes);
begin
  if Value <> FObjectTypes then
  begin
    FObjectTypes := Value;
    RootChanged;
  end;
end;

procedure TCustomShellComboBox.TreeUpdate(NewPath: PItemIDList);
begin
  if FUpdating or ((ItemIndex > -1)
    and SameAbsoluteID(Folders[ItemIndex].AbsoluteID, NewPath)) then Exit;
  FUpdating := True;
  try
    SetPathFromID(NewPath);
  finally
    FUpdating := False;
  end;
end;

procedure TCustomShellComboBox.SetTreeView(Value: TCustomShellTreeView);
begin
  if Value = FTreeView then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FComboBox := Self;
  end else
    if FTreeView <> nil then
      FTreeView.FComboBox := nil;

  if FTreeView <> nil then
    FTreeView.FreeNotification(Self);
  FTreeView := Value;
end;

procedure TCustomShellComboBox.SetListView(Value: TCustomShellListView);
begin
  if Value = FListView then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FComboBox := Self;
  end else
    if FListView <> nil then
      FListView.FComboBox := nil;

  if FListView <> nil then
    FListView.FreeNotification(Self);
  FListView := Value;
end;

procedure TCustomShellComboBox.Notification(AComponent: TComponent;
  Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FTreeView) then
      FTreeView := nil
    else if (AComponent = FListView) then
      FListView := nil
    else if (AComponent = FImageList) then
      FImageList := nil;
  end;    
end;

function TCustomShellComboBox.GetFolder(Index: Integer): TShellFolder;
begin
  if Index > ItemsEx.Count - 1 then
    Index := ItemsEx.Count - 1;
  Result := TShellFolder(ItemsEx[Index].Data);
end;

function TCustomShellComboBox.InitItem(ParentFolder: TShellFolder; ID: PItemIDList): TShellFolder;
var
  SF: IShellFolder;
begin
  SF := GetIShellFolder(ParentFolder.ShellFolder, ID);
  Result := TShellFolder.Create(ParentFolder, ID, SF);
end;

function ComboSortFunc(Item1, Item2: Pointer): Integer;
begin
  Result := 0;
  if CompareFolder = nil then Exit;
  Result := SmallInt(CompareFolder.ShellFolder.CompareIDs(0,
    PItemIDList(Item1), PItemIDList(Item2)));
end;

procedure TCustomShellComboBox.AddItems(Index: Integer; ParentFolder: TShellFolder);
var
  EnumList: IEnumIDList;
  ID: PItemIDList;
  ImageIndex: Integer;
  Item: TComboExItem;
  NumIDs: Integer;
  List: TList;
  AFolder: TShellFolder;
begin
  OLECheck(ParentFolder.ShellFolder.EnumObjects(0, ObjectFlags(FObjectTypes), EnumList));
  CompareFolder := ParentFolder;
  List := nil;
  ItemsEx.BeginUpdate;
  try
    List := TList.Create;
    while EnumList.Next(1, ID, LongWord(NumIDs)) = S_OK do
      List.Add(ID);
    List.Sort(ComboSortFunc);

    for NumIDs := 0 to List.Count-1 do
    begin
      AFolder := InitItem(ParentFolder, List[NumIDs]);
      Item := ItemsEx.Insert(Index+NumIDs+1);
      Item.Caption := AFolder.DisplayName;
      Item.Data := AFolder;
      Item.Indent := AFolder.Level;
      Item.ImageIndex := GetShellImageIndex(AFolder);
      Item.SelectedImageIndex := Item.ImageIndex;

      if Assigned(FOnGetImageIndex) and (Assigned(FImageList) or FUseShellImages) then
      begin
        ImageIndex := ItemsEx[NumIDs+1].ImageIndex;
        FOnGetImageIndex(Self, NumIDs+1, ImageIndex);
        ItemsEx[NumIDs+1].ImageIndex := ImageIndex;
      end;
    end;

  finally
    CompareFolder := nil;
    List.Free;
    ItemsEx.EndUpdate;
  end;
end;

procedure TCustomShellComboBox.Init;
var
  MyComputer: PItemIDList;
  Index: Integer;
begin
  //show desktop contents, expand My Computer if at desktop.
  //!!!otherwise expand the root.
  ItemsEx.BeginUpdate;
  try
    AddItems(0, FRootFolder);

    if Root = SRFDesktop then
    begin
      SHGetFolderLocation(0, CSIDL_DRIVES, 0, 0, MyComputer);
      try
        Index := IndexFromID(MyComputer);
        if Index <> -1 then
          AddItems(Index, Folders[Index]);
      finally
        DisposePIDL(MyComputer);
      end;
    end;
  finally
    ItemsEx.EndUpdate;
  end;    
end;

function TCustomShellComboBox.IndexFromID(AbsoluteID: PItemIDList): Integer;
begin
  Result := ItemsEx.Count-1;
  while Result >= 0 do
  begin
    if DesktopShellFolder.CompareIDs(
      0,
      AbsoluteID,
      Folders[Result].AbsoluteID) = 0 then Exit;
    Dec(Result);
  end;
end;

procedure TCustomShellComboBox.SetRoot(const Value: TRoot);
begin
  if not SameText(FRoot, Value) then
  begin
    FOldRoot := FRoot;
    FRoot := Value;
    RootChanged;
  end;
end;

procedure TCustomShellComboBox.RootChanged;
begin
  FUpdating := True;
  try
    ClearItems;
    CreateRoot;
    if Assigned(FTreeView) then
      FTreeView.SetRoot(FRoot);
    if Assigned(FListView) then
      FListView.SetRoot(FRoot);
  finally
    FUpdating := False;
  end;
end;

function TCustomShellComboBox.GetPath: string;
var
  Folder: TShellFolder;
begin
  Result := '';
  if ItemIndex > -1 then
  begin
    Folder := Folders[ItemIndex];
    if Assigned(Folder) then
      Result := Folder.PathName
    else
      Result := '';  
  end;
end;

procedure TCustomShellComboBox.SetPath(const Value: string);
var
  NewPIDL: PItemIDList;
begin
  try
    NewPIDL := ParseDisplayName(DesktopShellFolder, Value);
    try
      SetPathFromID(NewPIDL);
    finally
      DisposePIDL(NewPIDL);
    end;
  except on EOleSysError do
    raise EInvalidPath.CreateFmt(SErrorSettingPath, [Value]);
  end;
end;

procedure TCustomShellComboBox.SetPathFromID(ID: PItemIDList);
var
  Pidls: TList;
  I, Item, Temp: Integer;
  AFolder: TShellFolder;
  RelID: PItemIDList;

  procedure InsertItemObject(Position: Integer; Text: string; AFolder: TShellFolder);
  var
    Item: TComboExItem;
  begin
    Item := ItemsEx.Insert(Position);
    Item.Caption := Text;
    Item.Indent := AFolder.Level;
    Item.Data := AFolder;
    if AFolder = nil then
      Item.Data := AFolder;
    Item.ImageIndex := GetShellImageIndex(AFolder);
  end;

begin
  Item := -1;
  ItemsEx.BeginUpdate;
  try
    CreateRoot;
    Pidls := CreatePIDLList(ID);
    try
      I := Pidls.Count-1;
      while I >= 0 do
      begin
        Item := IndexFromID(Pidls[I]);
        if Item <> -1 then Break;
        Dec(I);
      end;

      if I < 0 then Exit;

      while I < Pidls.Count-1 do
      begin
        Inc(I);
        RelID := ExtractRelativeID(Pidls[I]);
        AFolder := InitItem(Folders[Item], RelID);
        InsertItemObject(Item+1, AFolder.DisplayName, AFolder);
        Inc(Item);
      end;

      Temp := IndexFromID(ID);
      if Temp < 0 then
      begin
        RelID := ExtractRelativeID(ID);
        AFolder := InitItem(Folders[Item], RelID);
        Temp := Item + 1;
        InsertItemObject(Item+1, AFolder.DisplayName, AFolder);
      end;
      ItemIndex := Temp;
    finally
      DestroyPIDLList(Pidls);
    end;
  finally
    ItemsEx.EndUpdate;
  end;
end;

function TCustomShellComboBox.GetShellImageIndex(
  AFolder: TShellFolder): Integer;
begin
  if FUseShellImages then
    Result := GetShellImage(AFolder.AbsoluteID, False, False)
  else
    Result := -1;
end;

procedure TCustomShellComboBox.SetUseShellImages(const Value: Boolean);
var
  ImageListHandle: THandle;
begin
  FUseShellImages := Value;
  if not Assigned(Images) then
    if FUseShellImages then
      ImageListHandle := FImages
    else
      ImageListHandle := 0
  else
    ImageListHandle := Images.Handle;
  SendMessage(Handle, CBEM_SETIMAGELIST, 0, ImageListHandle);
  
  if FUseShellImages and not Assigned(FImageList) then
    ImageList_GetIconSize(FImages, FImageWidth, FImageHeight)
  else
    if not Assigned(FImageList) then
    begin
      FImageWidth := 16;
      FImageHeight := 16;
    end
    else
    begin
      FImageWidth := FImageList.Width;
      FImageHeight := FImageList.Height;
    end;
end;

destructor TCustomShellComboBox.Destroy;
var
  i: Integer;
begin
  for i := 0 to ItemsEx.Count - 1 do
    if Assigned(ItemsEx[i].Data) then
      TShellFolder(ItemsEx[i].Data).Free; //ClearItems ƃ[[NB
  FRootFolder.Free;
  if Assigned(FImageList) then
    FImageList.Free;
  inherited Destroy;
end;

procedure TCustomShellComboBox.Loaded;
begin
  inherited Loaded;
  CreateRoot;
end;

type
  TAccessItemUpdateCount = class(TComboExItems);

procedure TCustomShellComboBox.Change;
var
  Node: TShellFolder;
begin
  if TAccessItemUpdateCount(ItemsEx).UpdateCount > 0 then Exit;

  inherited Change;
  if (ItemIndex > -1) and (not FUpdating) and (not DroppedDown) then
  begin
    FUpdating := True;
    try
      Node := Folders[ItemIndex];
      if Assigned(Node) then
      begin
        if Assigned(FTreeView) then
          FTreeView.SetPathFromID(Node.AbsoluteID);
        if Assigned(FListView) then
          FListView.TreeUpdate(Node.AbsoluteID);
      end;
    finally
      FUpdating := False;
    end;
  end;
end;

procedure TCustomShellComboBox.Click;
var
  Temp: PItemIDList;
begin
  FUpdating := True;
  try
    Temp := CopyPIDL(Folders[ItemIndex].AbsoluteID);
    //Folder will be destroyed when removing the lower level ShellFolders.
    try
      SetPathFromID(Temp);
      inherited;
    finally
     DisposePIDL(Temp);
    end;
  finally
    FUpdating := False;
  end;    
end;

{ TCustomShellListView }

constructor TCustomShellListView.Create(AOwner: TComponent);
var
  FileInfo: TSHFileInfo;
begin
  inherited Create(AOwner);
  FRootFolder := nil;
  FSortIndex := 0;
  FSortAscend := True;
  FObjectTypes := [otFolders, otNonFolders];
  FAutoContext := True;
  FAutoNavigate := True;
  FAutoRefresh := False;
  FDropSource := False;
  FDropTarget := False;
  FDropEffect := DROPEFFECT_NONE;
  FTreeView := nil;
  FComboBox := nil;
  FNotifier := TShellChangeNotifier.Create(Self);
  with FNotifier do
  begin
    FComponentStyle := FNotifier.FComponentStyle + [csSubComponent];
    Sources := [esShellLevel, esRecursiveInterrupt];
    Events := [neRenameItem, neCreate, neDelete, neMkdir, neRmdir, neMediaInserted, neMediaRemoved,
      neDriveRemoved, neDriveAdd, neNetShare, neNetUnshare, neAttributes, neUpdateDir, neUpdateItem,
      neServerDisconnect, neUpdateImage, neRenameFolder, neFreeSapce, neAssocChanged];
    OnChange := RefreshEvent;
  end;
  FUpdating := False;
  FSettingRoot := False;
  FSmallImages := SHGetFileInfo('.', { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_SMALLICON);
  FLargeImages := SHGetFileInfo('.', { Do not localize }
    0, FileInfo, SizeOf(FileInfo), SHGFI_SYSICONINDEX or SHGFI_LARGEICON);
  FRoot := SRFDesktop;
  HideSelection := False;
  FViewStyleEx := TViewStyleEx(ViewStyle);
  FThumbImags :=TImageList.Create(Self);
  FThumbImags.ColorDepth := cd32Bit;  //TlC32bitJ[炵
  FThumbImags.Width := 96;
  FThumbImags.Height := 96;
  ReadOnly := False;
  OnGetImageIndex := FillItem;
end;

destructor TCustomShellListView.Destroy;
begin
  ClearItems;
  FreeAndNil(FRootFolder);
  FThumbImags.Free;
  inherited Destroy;
end;

procedure TCustomShellListView.ClearItems;
var
  i: Integer;
begin
  for i := 0 to Items.Count - 1 do
  begin
    if Assigned(Folders[i]) then
      Folders[i].Free;
    Items[i].Data := nil;
  end;
  Items.Clear;
end;

procedure TCustomShellListView.CommandCompleted(Verb: string;
  Succeeded: Boolean);
begin
  if not Succeeded then Exit;
  if SameText(Verb, SCmdVerbDelete) or SameText(Verb, SCmdVerbPaste) then
    Refresh
  else if SameText(Verb, SCmdVerbOpen) then
    SetCurrentDirectory(PChar(FSavePath));
end;

procedure TCustomShellListView.ExecuteCommand(Verb: string;
  var Handled: Boolean);
var
  szPath: array[0..MAX_PATH] of Char;
begin
  if SameText(Verb, SCmdVerbRename) then
  begin
    EditText;
    Handled := True;
  end
  else if SameText(Verb, SCmdVerbOpen) then
  begin
    GetCurrentDirectory(MAX_PATH, szPath);
    FSavePath := StrPas(szPath);
    StrPCopy(szPath, ExtractFilePath(Folders[Selected.Index].PathName));
    SetCurrentDirectory(szPath);
  end;
end;

procedure TCustomShellListView.CreateWnd;
begin
  inherited CreateWnd;
  if HandleAllocated then
  begin
    if FSmallImages <> 0 then
      SendMessage(Handle, LVM_SETIMAGELIST, LVSIL_SMALL, FSmallImages);
    if FLargeImages <> 0 then
      SendMessage(Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, FLargeImages);
  end;
  if FRootFolder = nil then
  begin
    CreateRoot;
    RootChanged;
  end
  else
    Refresh;
end;

procedure TCustomShellListView.DestroyWnd;
begin
  RevokeDragDrop(Handle);
  ClearItems;
  inherited DestroyWnd;
end;

procedure TCustomShellListView.SetObjectTypes(Value: TShellObjectTypes);
begin
  if Value <> FObjectTypes then
  begin
    FObjectTypes := Value;
    if not (csLoading in ComponentState) then
      RootChanged;
  end;
end;

procedure TCustomShellListView.RootChanged;
var
  StayFresh: Boolean;
begin
  if FUpdating then Exit;

  FUpdating := True;
  try
    StayFresh := FAutoRefresh;
    AutoRefresh := False;
    if ViewStyleEx = vsReport then
      EnumColumns;
    SynchPaths;
    Populate;
    AutoRefresh := StayFresh;
  finally
    FUpdating := False;
  end;
end;

procedure TCustomShellListView.SetSortArrow(Index: Integer; Ascend: Boolean);
var
  Hnd: THandle;
  Item: THDItem;
begin
  Hnd := ListView_GetHeader(Handle);

  if FSortIndex in [0..Columns.Count - 1] then
  begin
    Item.Mask := HDI_FORMAT;
    Header_GetItem(Hnd, FSortIndex, Item);
    Item.fmt := Item.fmt and not HDF_SORTUP;
    Item.fmt := Item.fmt and not HDF_SORTDOWN;
    Header_SetItem(Hnd, FSortIndex, Item);
  end;

  FSortIndex := Index;
  FSortAscend := Ascend;

  if FSortIndex in [0..Columns.Count - 1] then
  begin
    Item.Mask := HDI_FORMAT;
    Header_GetItem(Hnd, FSortIndex, Item);
    if FSortAscend then
      Item.fmt := Item.fmt or HDF_SORTUP
    else
      Item.fmt := Item.fmt or HDF_SORTDOWN;
    Header_SetItem(Hnd, FSortIndex, Item);
  end;
end;

function ListAscendingSortFunc(Item1, Item2: TListItem; Param: Integer): Integer; stdcall;
const
  R: array[Boolean] of Byte = (0, 1);
var
  SF1, SF2: TShellFolder;
  PV1, PV2: TPropVariant;
begin
  Result := 0;
  if (Item1 = nil) or (Item2 = nil) then Exit;

  SF1 := TShellFolder(Item1.Data);
  SF2 := TShellFolder(Item2.Data);
  Result := R[SF2.IsFolder] - R[SF1.IsFolder];
  if (Result = 0) and (SF1.ParentShellFolder <> nil) then
  case Param of
    0: Result := Smallint(SF1.ParentShellFolder.CompareIDs(0, SF1.RelativeID, SF2.RelativeID));
  else
    PV1 := SF1.DetailsEx(Param);
    PV2 := SF2.DetailsEx(Param);
    case PV1.vt of
      VT_BSTR: Result := CompareText(PV1.bstrVal, PV2.bstrVal);
      VT_UI8: Result := CompareValue(PV1.lVal, PV2.lVal);
      VT_DATE: Result := CompareValue(PV1.date, PV2.date);
    end;
  end;
end;

function ListDescendingSortFunc(Item1, Item2: TListItem; Param: Integer): Integer; stdcall;
const
  R: array[Boolean] of Byte = (0, 1);
var
  SF1, SF2: TShellFolder;
  PV1, PV2: TPropVariant;
begin
  Result := 0;
  if (Item1 = nil) or (Item2 = nil) then Exit;

  SF1 := TShellFolder(Item1.Data);
  SF2 := TShellFolder(Item2.Data);
  Result := R[SF2.IsFolder] - R[SF1.IsFolder];
  if (Result = 0) and (SF1.ParentShellFolder <> nil) then
  case Param of
    0: Result := Smallint(SF1.ParentShellFolder.CompareIDs(0, SF2.RelativeID, SF1.RelativeID));
  else
    PV1 := SF1.DetailsEx(Param);
    PV2 := SF2.DetailsEx(Param);
    case PV1.vt of
      VT_BSTR: Result := CompareText(PV2.bstrVal, PV1.bstrVal);
      VT_UI8: Result := CompareValue(PV2.lVal, PV1.lVal);
      VT_DATE: Result := CompareValue(PV2.date, PV1.date);
    end;
  end;
end;

procedure TCustomShellListView.SortByIndex(Index: Integer; Ascend: Boolean);
begin
  Items.BeginUpdate;
  try
    if Ascend then
      CustomSort(@ListAscendingSortFunc, Index)
    else
      CustomSort(@ListDescendingSortFunc, Index);
    SetSortArrow(Index, Ascend);
  finally
    Items.EndUpdate;
  end;
end;

function TCustomShellListView.CanAddFolder(AFolder: TShellFolder): Boolean;
begin
  Result := True;
  if Assigned(FOnAddFolder) then
    FOnAddFolder(Self, AFolder, Result);
end;

procedure TCustomShellListView.InitItem(Item: TListItem; ID: PItemIDList);
var
  NewFolder: IShellFolder;
begin
  NewFolder := GetIShellFolder(FRootFolder.ShellFolder, ID);
  Item.Data := TShellFolder.Create(FRootFolder, ID, NewFolder);

  with TShellFolder(Item.Data) do
  begin
    Item.Caption := DisplayName;
    if ViewStyleEx <> vsThumbnail then
      Item.ImageIndex := ImageIndex(ViewStyleEx = vsIcon)
    else
      Item.ImageIndex := -1;
  end;

  if not CanAddFolder(TShellFolder(Item.Data)) then
    Item.Delete;
end;

procedure TCustomShellListView.Populate;
var
  ID: PItemIDList;
  EnumList: IEnumIDList;
  NumIDs: LongWord;
  SaveCursor: TCursor;
  HR: HResult;
  NewItem: TListItem;
begin
  if (csLoading in ComponentState) and not HandleAllocated then Exit;
  Items.BeginUpdate;
  try
    ClearItems;
    FThumbImags.Clear;
    SaveCursor := Screen.Cursor;
    try
      Screen.Cursor := crHourglass;
      HR := FRootFolder.ShellFolder.EnumObjects(Application.Handle,
        ObjectFlags(FObjectTypes) + SHCONTF_NAVIGATION_ENUM, EnumList);

      if HR <> 0 then Exit;

      while EnumList.Next(1, ID, NumIDs) = S_OK do
      begin
        NewItem := Items.Add;
        InitItem(NewItem, ID);
      end;

      if not IsLibrary(FRootFolder.FFullPIDL) and (FSortIndex in [0..Columns.Count - 1]) then
        SortByIndex(FSortIndex, FSortAscend);
    finally
      Screen.Cursor := SaveCursor;
    end;
  finally
    Items.EndUpdate;
  end;
end;

procedure TCustomShellListView.Notification(AComponent: TComponent; Operation: TOperation);
begin
  inherited Notification(AComponent, Operation);
  if (Operation = opRemove) then
  begin
    if (AComponent = FTreeView) then
      FTreeView := nil
    else if (AComponent = FComboBox) then
      FComboBox := nil;
  end;
end;

procedure TCustomShellListView.DblClick;
begin
  if FAutoNavigate and (Selected <> nil) then
    with Folders[Selected.Index] do
      if IsFolder then
        SetPathFromID(AbsoluteID)
      else
        ExecuteDefault;
  inherited DblClick;
end;

procedure TCustomShellListView.ColClick(Column: TListColumn);
var
  Ascending: Boolean;
begin
  if FSortIndex = Column.Index then
    Ascending := not FSortAscend
  else
    Ascending := True;
  SortByIndex(Column.Index, Ascending);
  inherited ColClick(Column);
end;

procedure TCustomShellListView.EditText;
begin
  if Selected <> nil then
    ListView_EditLabel(Handle, Selected.Index);
end;

procedure TCustomShellListView.Edit(const Item: TLVItem);
var
  s: string;
begin
  with Item do
  begin
    if iItem >= Items.Count then Exit;
    if pszText <> nil then
    begin
      s := pszText;
      Folders[iItem].Rename(s);
      ListView_RedrawItems(Handle, iItem, iItem);
    end;
  end;
end;

procedure TCustomShellListView.SetAutoRefresh(const Value: Boolean);
begin
  if Value <> FAutoRefresh then
  begin
    FAutoRefresh := Value;
    FNotifier.Enabled := not (csDesigning in ComponentState) and FAutoRefresh;
  end;
end;

procedure TCustomShellListView.SetRoot(const Value: TRoot);
begin
  if not SameText(Value, FRoot) then
  begin
    FOldRoot := FRoot;
    FRoot := Value;
    CreateRoot;
    FSettingRoot := True;
    RootChanged;
  end;
end;

function TCustomShellListView.SelectedFolder: TShellFolder;
begin
  Result := nil;
  if Selected <> nil then Result := Folders[Selected.Index];
end;

function TCustomShellListView.GetFolder(Index: Integer): TShellFolder;
begin
  Result := TShellFolder(Items[Index].Data);
end;

procedure TCustomShellListView.FillItem(Sender: TObject; Item: TListItem);
var
  SaveCursor: TCursor;
  i: Integer;
  Bmp: TBitmap;
begin
  SaveCursor := Screen.Cursor;
  try
    Screen.Cursor := crAppStart;
    case ViewStyleEx of
      vsReport:
        if Item.SubItems.Count = 0 then
        begin
          for i := 1 to Columns.Count - 1 do
            Item.SubItems.Add(Folders[Item.Index].DetailsOf(i));
        end;
      vsThumbnail:
        if Item.ImageIndex < 0 then
        begin
          Bmp := TBitmap.Create;
          try
            Bmp.Width := FThumbImags.Width;
            Bmp.Height := FThumbImags.Height;
            ExtractThumbnailImage(Folders[Item.Index], Bmp);
            Item.ImageIndex := FThumbImags.Add(Bmp, nil);
          finally
            Bmp.Free;
          end;
        end;
    end;
  finally
    Screen.Cursor := SaveCursor;
  end;
end;

procedure TCustomShellListView.Delete(Item: TListItem);
begin
  if Assigned(Item.Data) then
  begin
    TShellFolder(Item.Data).Free;
    Item.Data := nil;
  end;
  inherited Delete(Item);
end;

procedure TCustomShellListView.SetSortIndex(const Value: Integer);
begin
  if FSortIndex <> Value then
    if FSortIndex in [0..Columns.Count - 1] then
      SortByIndex(Value, FSortAscend)
    else
    begin
      Populate;
      FSortIndex := Value;
    end;
end;

procedure TCustomShellListView.SetSortAscend(const Value: Boolean);
begin
  if FSortAscend <> Value then
    SortByIndex(FSortIndex, Value);
end;

procedure TCustomShellListView.Loaded;
begin
  inherited Loaded;
  Populate;
  if csLoading in ComponentState then
    inherited Loaded;
  FNotifier.Enabled := not (csDesigning in ComponentState) and FAutoRefresh;
end;

procedure TCustomShellListView.DoContextPopup(MousePos: TPoint;
  var Handled: Boolean);
begin
  if FAutoContext and (SelectedFolder <> nil) then
  begin
    InvokeContextMenu(Self, SelectedFolder, MousePos.X, MousePos.Y);
    Handled := True;
  end else
    inherited;
end;

procedure TCustomShellListView.Back;
var
  RootPIDL: PItemIDList;
begin
  RootPIDL := CopyPIDL(FRootFolder.AbsoluteID);
  try
    StripLastID(RootPIDL);
    SetPathFromID(RootPIDL);
  finally
    DisposePIDL(RootPIDL);
  end;
end;

{
The method I outlined previously works for me (just tested for Printers):

 - Start with the required IShellFolder interface
 - See if it supports IShellDetails
 - If not, use FShellFolder.CreateViewObject to get IShellDetails
 - If it is a normal file folder (SFGAO_FILESYSTEM) you know what to do
 - If not, call IShellDetails.GetDetailsOf on the virtual folder until
   it returns the same column name twice (gives you the column types,
   names, and count).  Use nil for the first parameter.
 - For each virtual file, call IShellDetails.GetDetailsOf the number of
   columns times passing in the PItemIDList this time to get details.

> Furthermore, I have not yet found a way to determine that a PIDL I
> happen to have is a virtual folder, or a specific virtual folder. Still
> looking for suggestions there as well.

  You can tell a normal folder using IShellFolder.GetAttributesOf and
checking for SFGAO_FILESYSTEM.  This returns false for printers, scheduled
tasks, etc.
}
procedure TCustomShellListView.EnumColumns;
var
  ColNames: TStringList;

  function AddColumn(SD: TShellDetails): Boolean;
  var
    PIDL: PItemIDList;
    ColName: string;

    function ColumnIsUnique(const Name: string): Boolean;
    var
      i: Integer;
    begin
      for i := 0 to ColNames.Count - 1 do
        if SameText(ColNames[i], Name) then
        begin
          Result := False;
          Exit;
        end;
      Result := True;
    end;

  begin
    PIDL := nil;
    ColName := StrRetToString(PIDL, SD.Str);
    if ColName <> '' then
    begin
      Result := ColumnIsUnique(ColName);
      if Result then
        with Columns.Add do
        begin
          Caption := ColName;
          case SD.fmt of
            LVCFMT_CENTER: Alignment := taCenter;
            LVCFMT_LEFT: Alignment := taLeftJustify;
            LVCFMT_RIGHT: Alignment := taRightJustify;
          end;
          Width := SD.cxChar * Canvas.TextWidth('X');
          ColNames.Add(ColName);
        end;
    end
    else
      Result := True;
  end;

  procedure AddDefaultColumn(const ACaption: string; const AAlignment: TAlignment;
    AWidth: Integer);
  begin
    with Columns.Add do
    begin
      Caption := ACaption;
      Alignment := AAlignment;
      Width := AWidth * Canvas.TextWidth('X');
    end;
  end;

  procedure AddDefaultColumns(const ColCount: Integer = 1);
  begin
    if ColCount > 0 then
      AddDefaultColumn(SShellDefaultNameStr, taLeftJustify, 25);
    if ColCount > 1 then
      AddDefaultColumn(SShellDefaultSizeStr, taRightJustify, 10);
    if ColCount > 2 then
      AddDefaultColumn(SShellDefaultTypeStr, taLeftJustify, 10);
    if ColCount > 3 then
      AddDefaultColumn(SShellDefaultModifiedStr, taLeftJustify, 14);
  end;

var
  Col: Integer;
  SD: TShellDetails;
  PIDL: PItemIDList;
  SF2: IShellFolder2;
  ISD: IShellDetails;
  ColFlags: LongWord;
  Default: Boolean;
begin
  if (FRootFolder = nil) or (FRootFolder.ShellFolder = nil) then Exit;
  ColNames := TStringList.Create;
  try
    Columns.BeginUpdate;
    try
      Columns.Clear;
      Col := 0;
      PIDL := nil;
      Default := False;
      FillChar(SD, SizeOf(SD), 0);

      FRootFolder.ViewHandle := Self.Handle;
      SF2 := FRootFolder.ShellFolder2;
      if Assigned(SF2) then // Have IShellFolder2 interface
      begin
        try
          while SF2.GetDetailsOf(PIDL, Col, SD) = S_OK do
          begin
            SF2.GetDefaultColumnState(Col, ColFlags);
            Default := Default or Boolean(ColFlags and SHCOLSTATE_ONBYDEFAULT);
            if Default and not Boolean(ColFlags and SHCOLSTATE_ONBYDEFAULT) then Exit;
            AddColumn(SD);
            Inc(Col);
          end;
        finally
          DisposePIDL(PIDL);
        end;
      end
      else
      begin
        ISD := FRootFolder.ShellDetails;
        if Assigned(ISD) then
        begin
          while (ISD.GetDetailsOf(nil, Col, SD) = S_OK) do
          begin
            if (AddColumn(SD)) then
              Inc(Col)
            else
              Break;
          end;
        end
        else
        begin
          if (fpFileSystem in FRootFolder.Properties) then
            AddDefaultColumns(4)
          else
            AddDefaultColumns(1);
        end;
      end;
      SetSortArrow(FSortIndex, FSortAscend);
    finally
      Columns.EndUpdate;
    end;
  finally
    ColNames.Free;
  end;
end;

procedure TCustomShellListView.KeyDown(var Key: Word; Shift: TShiftState);
var
  Item: TListItem;
begin
  inherited;
  if FAutoNavigate then
    case Key of
      VK_RETURN:
        if ssAlt in Shift then
        begin
          DoContextMenuVerb(SelectedFolder, cmvProperties);
          Key := 0;
        end
        else if SelCount > 0 then
          if SelectedFolder.IsFolder then
            SetPathFromID(SelectedFolder.AbsoluteID)
          else
          begin
            Item := Selected;
            while Assigned(Item) do
            begin
              Folders[Item.Index].ExecuteDefault;
              Item := GetNextItem(Item, sdAll, [isSelected]);
            end;
          end;
      VK_BACK: if not IsEditing then Back;
      VK_F5: Refresh;
      VK_F2: if not ReadOnly and Assigned(Selected) then Selected.EditCaption;
    end;
end;

procedure TCustomShellListView.SetViewStyleEx(Value: TViewStyleEx);
var
  Selects: array of Integer;
  i: Integer;
  Item: TListItem;
begin
  if Value = FViewStyleEx then Exit;
  FViewStyleEx := Value;

  if SelCount > 0 then
  begin
    SetLength(Selects, SelCount);
    i := 0;
    Item := Selected;
    while Assigned(Item) do
    begin
      Selects[i] := Item.Index;
      Inc(i);
      Item := GetNextItem(Item, sdAll, [isSelected]);
    end;
  end;

  case FViewStyleEx of
    vsIcon:
    begin
      ViewStyle := TViewStyle(vsIcon);
      if FLargeImages <> 0 then
        SendMessage(Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, FLargeImages);
    end;
    vsReport:
    begin
      ViewStyle := TViewStyle(vsReport);
      if not (csLoading in ComponentState) then
        EnumColumns;
    end;
    vsThumbnail:
    begin
      ViewStyle := TViewStyle(vsIcon);
      if FThumbImags.Handle <> 0 then
        SendMessage(Handle, LVM_SETIMAGELIST, LVSIL_NORMAL, FThumbImags.Handle);
    end;
  else
    ViewStyle := TViewStyle(FViewStyleEx);
  end;
  Refresh;

  if Length(Selects) > 0 then
  begin
    for i := 0 to Length(Selects) - 1 do
      Items[Selects[i]].Selected := True;
  end;
end;

procedure TCustomShellListView.SetTreeView(Value: TCustomShellTreeView);
begin
  if Value = FTreeView then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FListView := Self;
  end else
    if FTreeView <> nil then
      FTreeView.FListView := nil;

  if FTreeView <> nil then
    FTreeView.FreeNotification(Self);
  FTreeView := Value;
end;

procedure TCustomShellListView.SetComboBox(Value: TCustomShellComboBox);
begin
  if Value = FComboBox then Exit;
  if Value <> nil then
  begin
    Value.Root := Root;
    Value.FListView := Self;
  end else
    if FComboBox <> nil then
      FComboBox.FListView := nil;

  if FComboBox <> nil then
    FComboBox.FreeNotification(Self);
  FComboBox := Value;
end;

procedure TCustomShellListView.TreeUpdate(NewRoot: PItemIDList);
begin
  if FUpdating or (Assigned(FRootFolder)
     and SameAbsoluteID(FRootFolder.AbsoluteID, NewRoot)) then Exit;
  SetPathFromID(NewRoot);
end;

procedure TCustomShellListView.WndProc(var Message: TMessage);
begin
  inherited;
  with Message do
    case Msg of
      //to handle submenus of context menus.
      WM_INITMENUPOPUP, WM_DRAWITEM, WM_MENUCHAR, WM_MEASUREITEM:
        if Assigned(ICM2) then
        begin
          ICM2.HandleMenuMsg(Msg, wParam, lParam);
          Result := 0;
        end;
      WM_NOTIFY:
        //J̖
        if PNMHdr(LParam).code = HDN_ENDTRACK then
          SetSortArrow(FSortIndex, FSortAscend);
    end;
end;

function TCustomShellListView.FindAbsoluteID(StartItem: TListItem; ID: PItemIDList;
  Wrap: Boolean): TListItem;
var
  StartIndex, i: Integer;
  Item: TListItem;
begin
  Result := nil;
  if Assigned(StartItem) then
    StartIndex := StartItem.Index
  else
    StartIndex := 0;
  for i := StartIndex to Items.Count - 1 do
  begin
    Item := Items.Item[i];
    if SameAbsoluteID(TShellFolder(Item.Data).AbsoluteID, ID) then
    begin
      Result := Item;
      Exit;
    end;
  end;
  if Wrap then
    for i := 0 to StartIndex - 1 do
    begin
      Item := Items.Item[i];
      if SameAbsoluteID(TShellFolder(Item.Data).AbsoluteID, ID) then
      begin
        Result := Item;
        Exit;
      end;
    end;
end;

procedure TCustomShellListView.RefreshEvent(Sender: TObject;
  Event: TNotificationEvent; PIDL1, PIDL2: PItemIDList);
var
  Item: TListItem;
  ParentID: PItemIDList;
begin
  case Event of
    neRenameItem, neRenameFolder:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
      begin
        TShellFolder(Item.Data).Free;
        InitItem(Item, ExtractRelativeID(PIDL2));
      end;
    end;
    neCreate, neMkdir:
    begin
      ParentID := CopyPIDL(PIDL1);
      StripLastID(ParentID);
      if SameAbsoluteID(RootFolder.AbsoluteID, ParentID) then
      begin
        Item := Items.Add;
        InitItem(Item, ExtractRelativeID(PIDL1));
      end
      else
        Item := nil;
      DisposePIDL(ParentID);
    end;
    neDelete, neRmdir:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
        Delete(Item);
        //! Item.Delete; ƃr[XVȂB
    end;
    neMediaInserted, neMediaRemoved,
    neDriveRemoved, neDriveAdd:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
      begin
        TShellFolder(Item.Data).Free;
        InitItem(Item, ExtractRelativeID(PIDL1));
      end;
    end;
    neNetShare:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
        Item.OverlayIndex := 0;
    end;
    neNetUnshare:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
        Item.OverlayIndex := -1;
    end;
    neAttributes:
    begin
      Item := FindAbsoluteID(Selected, PIDL1, True);
      if Assigned(Item) then
      begin
        TShellFolder(Item.Data).Free;
        InitItem(Item, ExtractRelativeID(PIDL1));
      end;
    end;
    neUpdateDir: Item := FindAbsoluteID(Selected, PIDL1, True);
    neUpdateItem: Item := FindAbsoluteID(Selected, PIDL1, True);
    neServerDisconnect: Item := FindAbsoluteID(Selected, PIDL1, True);
    neUpdateImage: Item := nil;
    neDriveAddGUI: Item := nil;
    neFreeSapce: Item := FindAbsoluteID(Selected, PIDL1, True);
    neAssocChanged: Item := nil;
  else
    Item := nil;
  end;
  if Assigned(FOnChangeNotify) then
    FOnChangeNotify(Self, Event, Item);
end;

procedure TCustomShellListView.Refresh;
var
  RootPIDL: PItemIDList;
begin
  RootPIDL := CopyPIDL(FRootFolder.AbsoluteID);
  try
    FreeAndNil(FRootFolder);
    SetPathFromID(RootPIDL);
  finally
    DisposePIDL(RootPIDL);
  end;
end;

procedure TCustomShellListView.SetPathFromID(ID: PItemIDList);
begin
  if FUpdating then Exit;

  if Assigned(FRootFolder) then
    if SameAbsoluteID(FRootFolder.AbsoluteID, ID) then
      Exit // Note! Exits routine
    else
      FRootFolder.Free;

  FSettingRoot := False;
  FRootFolder := CreateRootFromPIDL(ID);
  RootChanged;
end;

procedure TCustomShellListView.CreateRoot;
begin
  FRootFolder := CreateRootFolder(FRootFolder, FOldRoot, FRoot);
  FNotifier.Root := FRoot;
end;

procedure TCustomShellListView.SynchPaths;
begin
  try
    if FSettingRoot then
    begin
      if Assigned(FTreeView) then
        FTreeView.SetRoot(FRoot);
      if Assigned(FComboBox) then
        FComboBox.SetRoot(FRoot);
    end
    else
    begin
      if Assigned(FTreeView) then
        FTreeView.SetPathFromID(FRootFolder.AbsoluteID);
      if Assigned(FComboBox) then
        FComboBox.TreeUpdate(FRootFolder.AbsoluteID);
    end;
  finally
    FSettingRoot := False;
  end;
end;

function TCustomShellListView.GetThumbWidth: Integer;
begin
  Result := FThumbImags.Width;
end;

procedure TCustomShellListView.SetThumbWidth(const Value: Integer);
begin
  if FThumbImags.Width = Value then Exit;
  FThumbImags.Width := Value;
end;

function TCustomShellListView.GetThumbHeight: Integer;
begin
  Result := FThumbImags.Height;
end;

procedure TCustomShellListView.SetThumbHeight(const Value: Integer);
begin
  if FThumbImags.Height = Value then Exit;
  FThumbImags.Height := Value;
end;

procedure Register;
begin
  RegisterComponents(SPalletePage, [TShellTreeView, TShellComboBox, TShellListView,
    TShellChangeNotifier]);
end;

initialization
  CreateDesktopFolder;
  InitializeCriticalSection(CS);
  OleInitialize(nil);

finalization
  if Assigned(DesktopFolder) then
    DesktopFolder.Free;
  DeleteCriticalSection(CS);
  OleUninitialize;

end.
