(* ShellTypes

2020/10/02 ShellUtils 番ATRoot ֘A֐ǉBTRootFolder g[i₽瑝jB
2021/03/11 TRoot ֘A֐̉AǉBSHChangeNotification_Lock ̏CǉB

	VFl[Xy[X` *)

unit ShellTypes platform;

interface

uses
  System.TypInfo, Winapi.Windows, System.SysUtils, Winapi.ShlObj;

type
  TRoot = type string;

  TRootFolder = (
    //CSIDL `B
    rfDesktop, rfInternet, rfPrograms, rfControlPanel, rfPrinters, rfPersonal, rfFavorites,
    rfStartup, rfRecent, rfSendTo, rfRecycleBin, rfStartMenu, rfMyMusic, rfMyVideos,
    rfDesktopDirectory, rfMyComputer, rfNetwork, nfNetHood, rfFonts, rfTemplates, rfCommonStartMenu,
    rfCommonPrograms, rfCommonStartup, rfCommonDesktopDirectory, rfAppData, rfPrintHood,
    rfLocalAppData, rfAltStartup, rfCommonAltStartup, rfCommonFavorites, rfInternetCache, rfCookies,
    rfHistory, rfCommonAppdata, rfWindows, rfSystem, rfProgramFiles, rfMyPictures, rfProfile,
    rfSystemX86, rfProgramFilesX86, rfProgramFilesCommon, rfProgramFilesCommonX86,
    rfCommonTemplates, rfCommonDocuments, rfCommonAdmintools, rfAdmintools, rfConnections,
    rfCommonMusic, rfCommonPictures, rfCommonVideo, rfResources, rfResourcesLocalized,
    rfCommonOEMLinks, rfCdburnArea, rfComputersNearMe,
    //CSIDL `B
    rfSyncManagerFolder, rfSyncSetupFolder, rfConflictFolder, rfSyncResultsFolder, rfLocalAppDataLow,
    rfProgramFilesX64, rfProgramFilesCommonX64, rfUserProgramFiles, rfUserProgramFilesCommon,
    rfRingtones, rfPublicRingtones, rfUserProfiles, rfPlaylists, rfSamplePlaylists, rfSampleMusic,
    rfSamplePictures, rfSampleVideos, rfPhotoAlbums, rfPublic, rfChangeRemovePrograms,
    rfAppUpdates, rfAddNewPrograms, rfDownloads, rfPublicDownloads, rfSavedSearches, rfQuickLaunch,
    rfContacts, rfSidebarParts, rfSidebarDefaultParts, rfPublicGameTasks, rfGameTasks, rfSavedGames,
    rfGames, rfSearchMAPI, rfSearchCSC, rfLinks, rfUsersFiles, rfUsersLibraries, rfSearchHome,
    rfOriginalImages, rfDocumentsLibrary, rfMusicLibrary, rfPicturesLibrary, rfVideosLibrary,
    rfRecordedTVLibrary, rfHomeGroup, rfDeviceMetadataStore, rfLibraries, rfPublicLibraries,
    rfUserPinned, rfImplicitAppShortcuts, rfAccountPictures, rfApplicationShortcuts, rfAppsFolder,
    rfCameraRoll, rfHomeGroupCurrentUser, rfPublicUserTiles, rfRoamedTileImages, rfRoamingTiles,
    rfScreenshots, rfSearchHistory, rfSearchTemplates, rfSkyDrive, rfSkyDriveCameraRoll,
    rfSkyDriveDocuments, rfSkyDrivePictures
  );
  TRootCSIDLs = rfDesktop..rfComputersNearMe;
  TRootKFIDs = rfSyncManagerFolder..rfSkyDrivePictures;

const
  nRootCSIDL: array[TRootCSIDLs] of Integer = (
    CSIDL_DESKTOP, CSIDL_INTERNET, CSIDL_PROGRAMS, CSIDL_CONTROLS, CSIDL_PRINTERS, CSIDL_PERSONAL,
    CSIDL_FAVORITES, CSIDL_STARTUP, CSIDL_RECENT, CSIDL_SENDTO, CSIDL_BITBUCKET, CSIDL_STARTMENU,
    CSIDL_MYMUSIC, CSIDL_MYVIDEO, CSIDL_DESKTOPDIRECTORY, CSIDL_DRIVES, CSIDL_NETWORK, CSIDL_NETHOOD,
    CSIDL_FONTS, CSIDL_TEMPLATES, CSIDL_COMMON_STARTMENU, CSIDL_COMMON_PROGRAMS,
    CSIDL_COMMON_STARTUP, CSIDL_COMMON_DESKTOPDIRECTORY, CSIDL_APPDATA, CSIDL_PRINTHOOD,
    CSIDL_LOCAL_APPDATA, CSIDL_ALTSTARTUP, CSIDL_COMMON_ALTSTARTUP, CSIDL_COMMON_FAVORITES,
    CSIDL_INTERNET_CACHE, CSIDL_COOKIES, CSIDL_HISTORY, CSIDL_COMMON_APPDATA, CSIDL_WINDOWS,
    CSIDL_SYSTEM, CSIDL_PROGRAM_FILES, CSIDL_MYPICTURES, CSIDL_PROFILE, CSIDL_SYSTEMX86,
    CSIDL_PROGRAM_FILESX86, CSIDL_PROGRAM_FILES_COMMON, CSIDL_PROGRAM_FILES_COMMONX86,
    CSIDL_COMMON_TEMPLATES, CSIDL_COMMON_DOCUMENTS, CSIDL_COMMON_ADMINTOOLS, CSIDL_ADMINTOOLS,
    CSIDL_CONNECTIONS, CSIDL_COMMON_MUSIC, CSIDL_COMMON_PICTURES, CSIDL_COMMON_VIDEO,
    CSIDL_RESOURCES, CSIDL_RESOURCES_LOCALIZED, CSIDL_COMMON_OEM_LINKS, CSIDL_CDBURN_AREA,
    CSIDL_COMPUTERSNEARME
  );

  nRootKFID: array[TRootKFIDs] of TGUID = (
    '{43668BF8-C14E-49B2-97C9-747784D784B7}', //FOLDERID_SyncManagerFolder
    '{0F214138-B1D3-4A90-BBA9-27CBC0C5389A}', //FOLDERID_SyncSetupFolder
    '{4BFEFB45-347D-4006-A5BE-AC0CB0567192}', //FOLDERID_ConflictFolde
    '{289A9A43-BE44-4057-A41B-587A76D7E7F9}', //FOLDERID_SyncResultsFolder
    '{A520A1A4-1780-4FF6-BD18-167343C5AF16}', //FOLDERID_LocalAppDataLow
    '{6D809377-6AF0-444B-8957-A3773F02200E}', //FOLDERID_ProgramFilesX64
    '{6365D5A7-0F0D-45E5-87F6-0DA56B6A4F7D}', //FOLDERID_ProgramFilesCommonX64
    '{5CD7AEE2-2219-4A67-B85D-6C9CE15660CB}', //FOLDERID_UserProgramFiles
    '{BCBD3057-CA5C-4622-B42D-BC56DB0AE516}', //FOLDERID_UserProgramFilesCommon
    '{C870044B-F49E-4126-A9C3-B52A1FF411E8}', //FOLDERID_Ringtones
    '{E555AB60-153B-4D17-9F04-A5FE99FC15EC}', //FOLDERID_PublicRingtones
    '{0762D272-C50A-4BB0-A382-697DCD729B80}', //FOLDERID_UserProfiles
    '{DE92C1C7-837F-4F69-A3BB-86E631204A23}', //FOLDERID_Playlists
    '{15CA69B3-30EE-49C1-ACE1-6B5EC372AFB5}', //FOLDERID_SamplePlaylists
    '{B250C668-F57D-4EE1-A63C-290EE7D1AA1F}', //FOLDERID_SampleMusic
    '{C4900540-2379-4C75-844B-64E6FAF8716B}', //FOLDERID_SamplePictures
    '{859EAD94-2E85-48AD-A71A-0969CB56A6CD}', //FOLDERID_SampleVideos
    '{69D2CF90-FC33-4FB7-9A0C-EBB0F0FCB43C}', //FOLDERID_PhotoAlbums
    '{DFDF76A2-C82A-4D63-906A-5644AC457385}', //FOLDERID_Public
    '{DF7266AC-9274-4867-8D55-3BD661DE872D}', //FOLDERID_ChangeRemovePrograms
    '{A305CE99-F527-492B-8B1A-7E76FA98D6E4}', //FOLDERID_AppUpdates
    '{DE61D971-5EBC-4F02-A3A9-6C82895E5C04}', //FOLDERID_AddNewPrograms
    '{374DE290-123F-4565-9164-39C4925E467B}', //FOLDERID_Downloads
    '{374DE290-123F-4565-9164-39C4925E467B}', //FOLDERID_PublicDownload
    '{7D1D3A04-DEBB-4115-95CF-2F29DA2920DA}', //FOLDERID_SavedSearches
    '{52A4F021-7B75-48A9-9F6B-4B87A210BC8F}', //FOLDERID_QuickLaunch
    '{56784854-C6CB-462B-8169-88E350ACB882}', //FOLDERID_Contacts
    '{A75D362E-50FC-4FB7-AC2C-A8BEAA314493}', //FOLDERID_SidebarParts
    '{7B396E54-9EC5-4300-BE0A-2482EBAE1A26}', //FOLDERID_SidebarDefaultParts
    '{DEBF2536-E1A8-4C59-B6A2-414586476AEA}', //FOLDERID_PublicGameTasks
    '{054FAE61-4DD8-4787-80B6-090220C4B700}', //FOLDERID_GameTasks
    '{4C5C32FF-BB9D-43B0-B5B4-2D72E54EAAA4}', //FOLDERID_SavedGames
    '{CAC52C1A-B53D-4EDC-92D7-6B2E8AC19434}', //FOLDERID_Games
    '{98EC0E18-2098-4D44-8644-66979315A281}', //FOLDERID_SEARCH_MAPI
    '{EE32E446-31CA-4ABA-814F-A5EBD2FD6D5E}', //FOLDERID_SEARCH_CSC
    '{BFB9D5E0-C6A9-404C-B2B2-AE6DB6AF4968}', //FOLDERID_Links
    '{F3CE0F7C-4901-4ACC-8648-D5D44B04EF8F}', //FOLDERID_UsersFiles
    '{A302545D-DEFF-464B-ABE8-61C8648D939B}', //FOLDERID_UsersLibraries
    '{190337D1-B8CA-4121-A639-6D472D16972A}', //FOLDERID_SearchHome
    '{2C36C0AA-5812-4B87-BFD0-4CD0DFB19B39}', //FOLDERID_OriginalImages
    '{7B0DB17D-9CD2-4A93-9733-46CC89022E7C}', //FOLDERID_DocumentsLibrary
    '{2112AB0A-C86A-4FFE-A368-0DE96E47012E}', //FOLDERID_MusicLibrary
    '{A990AE9F-A03B-4E80-94BC-9912D7504104}', //FOLDERID_PicturesLibrary
    '{491E922F-5643-4AF4-A7EB-4E7A138D8174}', //FOLDERID_VideosLibrary
    '{1A6FDBA2-F42D-4358-A798-B74D745926C5}', //FOLDERID_RecordedTVLibrary
    '{52528A6B-B9E3-4ADD-B60D-588C2DBA842D}', //FOLDERID_HomeGroup
    '{5CE4A5E9-E4EB-479D-B89F-130C02886155}', //FOLDERID_DeviceMetadataStore
    '{1B3EA5DC-B587-4786-B4EF-BD1DC332AEAE}', //FOLDERID_Libraries
    '{48daf80b-e6cf-4f4e-b800-0e69d84ee384}', //FOLDERID_PublicLibraries
    '{9E3995AB-1F9C-4F13-B827-48B24B6C7174}', //FOLDERID_UserPinned
    '{BCB5256F-79F6-4CEE-B725-DC34E402FD46}', //FOLDERID_ImplicitAppShortcut
    '{008ca0b1-55b4-4c56-b8a8-4de4b299d3be}', //FOLDERID_AccountPictures
    '{A3918781-E5F2-4890-B3D9-A7E54332328C}', //FOLDERID_ApplicationShortcuts
    '{1e87508d-89c2-42f0-8a7e-645a0f50ca58}', //FOLDERID_AppsFolder
    '{AB5FB87B-7CE2-4F83-915D-550846C9537B}', //FOLDERID_CameraRoll
    '{9B74B6A3-0DFD-4f11-9E78-5F7800F2E772}', //FOLDERID_HomeGroupCurrentUser
    '{0482af6c-08f1-4c34-8c90-e17ec98b1e17}', //FOLDERID_PublicUserTiles
    '{AAA8D5A5-F1D6-4259-BAA8-78E7EF60835E}', //FOLDERID_RoamedTileImages
    '{00BCFC5A-ED94-4e48-96A1-3F6217F21990}', //FOLDERID_RoamingTiles
    '{b7bede81-df94-4682-a7d8-57a52620b86f}', //FOLDERID_Screenshots
    '{0D4C3DB6-03A3-462F-A0E6-08924C41B5D4}', //FOLDERID_SearchHistory
    '{7E636BFE-DFA9-4D5E-B456-D7B39851D8A9}', //FOLDERID_SearchTemplates
    '{A52BBA46-E9E1-435f-B3D9-28DAA648C0F6}', //FOLDERID_SkyDrive
    '{767E6811-49CB-4273-87C2-20F355E1085B}', //FOLDERID_SkyDriveCameraRoll
    '{24D89E24-2F19-4534-9DDE-6A6671FBB8FE}', //FOLDERID_SkyDriveDocuments
    '{339719B5-8C47-4894-94C2-D8F77ADD44A6}'  //FOLDERID_SkyDrivePicture
  );

var
  DesktopShellFolder: IShellFolder = nil;
  ShellLibrary: IShellLibrary = nil;

function StrRetToString(PIDL: PItemIDList; StrRet: TStrRet; Flag: string = ''): string;
function RootIDList(Root: TRoot): PItemIDList;
function RootSHItem(Root: TRoot): IShellItem;
function RootIDName(PIDL: PItemIDList): TRoot;
function RootSHName(Item: IShellItem): TRoot;
function IsValidRootName(Root: TRoot): Boolean;

//SHChangeNotification_Lock,pppidl ̐錾CƉB
//ł SHChangeNotification_Unlock ǉĖOςB
type
  TAbsoluteIDs = packed record
    Item1: PItemIDList;
    Item2: PItemIDList;
  end;
  PAbsoluteIDs = ^TAbsoluteIDs;

function LockChangeNotify(hChange: THandle; dwProcId: DWORD; out pppidl: PAbsoluteIDs;
  out plEvent: LONG): THandle; stdcall; external 'shell32.dll' name 'SHChangeNotification_Lock';
function UnlockChangeNotify(hLock: THandle): BOOL; stdcall;
  external 'shell32.dll' name 'SHChangeNotification_Unlock';

implementation

uses
  Winapi.ActiveX, System.Win.ComObj;

function StrRetToString(PIDL: PItemIDList; StrRet: TStrRet; Flag: string = ''): string;
var
  P: PAnsiChar;
begin
  case StrRet.uType of
    STRRET_CSTR:
      SetString(Result, StrRet.cStr, lStrLenA(StrRet.cStr));
    STRRET_OFFSET:
    begin
      P := @PIDL.mkid.abID[StrRet.uOffset - SizeOf(PIDL.mkid.cb)];
      SetString(Result, P, PIDL.mkid.cb - StrRet.uOffset);
    end;
    STRRET_WSTR:
      if Assigned(StrRet.pOleStr) then
        Result := StrRet.pOleStr
      else
        Result := '';
  end;
  { This is a hack bug fix to get around Windows Shell Controls returning
    spurious "?"s in date/time detail fields }
  if (Length(Result) > 1) and (Result[1] = '?') and CharInSet(Result[2], ['0'..'9']) then
    Result := StringReplace(Result, '?', '', [rfReplaceAll]);
end;

function GetCSIDLType(const Value: string): TRootFolder;
begin
{$R+}
  Result := TRootCSIDLs(GetEnumValue(TypeInfo(TRootFolder), Value))
{$R-}
end;

function GetKFIDType(const Value: string): TRootFolder;
begin
{$R+}
  Result := TRootKFIDs(GetEnumValue(TypeInfo(TRootFolder), Value))
{$R-}
end;

function RootIDList(Root: TRoot): PItemIDList;
var
  P: PWideChar;
  NumChars,
  Flags: LongWord;
begin
  Result := nil;
  case GetEnumValue(TypeInfo(TRootFolder), Root) of
    Ord(rfDesktop)..Ord(rfComputersNearMe):
      SHGetFolderLocation(0, nRootCSIDL[GetCSIDLType(Root)], 0, 0, Result);
    Ord(rfSyncManagerFolder)..Ord(rfSkyDrivePictures):
      SHGetKnownFolderIDList(nRootKFID[GetKFIDType(Root)], 0, 0, Result);
  else
    if Length(Root) > 0 then
    begin
      if Root[Length(Root)] = ':' then
        Root := Root + '\';
      NumChars := Length(Root);
      Flags := 0;
      P := StringToOleStr(Root);
      try
        DesktopShellFolder.ParseDisplayName(0, nil, P, NumChars, Result, Flags);
      finally
        SysFreeString(P);
      end;
    end;
  end;
end;

function RootSHItem(Root: TRoot): IShellItem;
var
  PIDL: PItemIDList;
begin
  PIDL := RootIDList(Root);
  try
    SHCreateShellItem(nil, nil, PIDL, Result);
  finally
    if Assigned(PIDL) then
      CoTaskMemFree(PIDL);
  end;
end;

function RootIDName(PIDL: PItemIDList): TRoot;
var
  StrRet: TStrRet;
  RootID: PItemIDList;
  Folder: TRootFolder;
  Root: string;
begin
  DesktopShellFolder.GetDisplayNameOf(PIDL, SHGDN_FORPARSING, StrRet);
  Result := StrRetToString(PIDL, StrRet);

  for Folder := Low(Folder) to High(Folder) do
  begin
    Root := GetEnumName(TypeInfo(TRootFolder), Ord(Folder));
    RootID := RootIDList(Root);
    if DesktopShellFolder.CompareIDs(0, PIDL, RootID) = 0 then
    begin
      Result := Root;
      Break;
    end;
  end;
end;

function RootSHName(Item: IShellItem): TRoot;
var
  PersistID: IPersistIDList;
  PIDL: PItemIDList;
begin
  //SHGetIDListFromObject  Vista ȍ~ɂȂ̂ŉ肭ǂB
  Result := '';
  if Succeeded(Item.QueryInterface(IID_IPersistIDList, PersistID)) then
  begin
    PersistID.GetIDList(PIDL);
    try
      Result := RootIDName(PIDL);
    finally
      if Assigned(PIDL) then
        CoTaskMemFree(PIDL);
    end;
  end;
end;

function IsValidRootName(Root: TRoot): Boolean;
var
  PIDL: PItemIDList;
begin
  PIDL := RootIDList(Root);
  try
    Result := Assigned(PIDL);
  finally
    if Assigned(PIDL) then
      CoTaskMemFree(PIDL);
  end;
end;

initialization
  OleInitialize(nil);
  OleCheck(SHGetDesktopFolder(DesktopShellFolder));
  if CheckWin32Version(6, 1) then
    OleCheck(SHCreateLibrary(IID_IShellLibrary, Pointer(ShellLibrary)));

finalization
  OleUninitialize;

end.
