(*	TVBRegexp

Ver, 1.00 2006/04/19 ^B
Ver, 1.01 2006/11/21 UsesRegexp ǉB
Ver, 1.02 2010/04/05 Delphi2010 ΉB
Ver, 1.03 2011/12/16 [[N̏CB
Ver, 1.04 2013/02/16 K\gpɕʂĂȂoȌCB

VBScript.Regexp gpK\CuB
ڍׂ MSDN QƁB

K\ňvB
TMache
  property
    FirstIndex;	v̐擪ʒu([X^[g̃oCgP)B
    Length;		v̒(oCg)B
    Value;		vB

K\ňṽRNVB
TMaches
  property
    Count;		v̐B
    Items;		vB

K\B
TVBRegexp
  property
    Usable;		K\gp\Bs[hI[B
    UsesRegexp;	K\gpB
    Global;		ŜɓKpB
    IgnoreCase;	啶ʂȂB
    Pattern;	p^[B
  method
    Execute;	B
    Replace;	uB
    Test;		B

ӎ
TMRegExp jbgJu܂@vɁB

	VBScript Regular Expression Library*)

unit VBRegexp;

interface

uses
  Windows, SysUtils, Classes, ComObj, ActiveX;

type
  TMache = class
    FirstIndex: Integer;
    Length: Integer;
    Value: string;
  end;

  TMaches = class
  private
    { Private 錾 }
    FMachesList : TList;
    function GetCount: Integer;
    function GetItem(Index: Integer): TMache;
  public
    { Public 錾 }
    constructor Create;
    procedure Add(Value: TMache);
    destructor Destroy; override;
    property Count: Integer read GetCount;
    property Items[Index: Integer]: TMache read GetItem;
  end;

  TVBRegexp = class(TComponent)
  private
    { Private 錾 }
    FUsable: Boolean;
    FUsesRegexp: Boolean;
    FGlobal: Boolean;
    FIgnoreCase: Boolean;
    FPattern: string;
    FRegexpErrorMessage: string;
    FRegexpObject: Variant;
    procedure SetGlobal(Value: Boolean);
    procedure SetIgnoreCase(Value: Boolean);
    procedure SetPattern(Value: string);
  protected
    { Protected 錾 }
    function RegExecute(const S: string): TMaches;
    function StrExecute(const S: string): TMaches;
    function RegReplace(const S, Substr: string): string;
    function StrReplace(const S, Substr: string): string;
    function RegTest(const S: string): Boolean;
    function StrTest(const S: string): Boolean;
  public
    { Public 錾 }
    constructor Create(AOwner: TComponent); override;
    function Execute(const S: string): TMaches;
    function Replace(const S, Substr: string): string;
    function Test(const S: string): Boolean;
    destructor Destroy; override;
    property Usable: Boolean read FUsable;
  published
    { Published 錾 }
    property UsesRegexp: Boolean read FUsesRegexp write FUsesRegexp default True;
    property Global: Boolean read FGlobal write SetGlobal default True;
    property IgnoreCase: Boolean read FIgnoreCase write SetIgnoreCase default False;
    property Pattern: string read FPattern write SetPattern;
  end;

procedure Register;

implementation

{ TMaches }

constructor TMaches.Create;
begin
  inherited;

  FMachesList := TList.Create;
end;

function TMaches.GetCount: Integer;
begin
  Result := FMachesList.Count;
end;

function TMaches.GetItem(Index: Integer): TMache;
begin
  Result := TMache(FMachesList.Items[Index]);
end;

procedure TMaches.Add(Value: TMache);
begin
  FMachesList.Add(Value);
end;

destructor TMaches.Destroy;
var
  i: Integer;
begin
  for i:= 0 to FMachesList.Count - 1 do
    TMache(FMachesList.Items[i]).Free;
  FMachesList.Free;

  inherited;
end;

{ TVBRegexp }

constructor TVBRegexp.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);

  FUsable := True;
  FUsesRegexp := True;
  FGlobal := True;
  FIgnoreCase := False;
  FPattern := '';
  FRegexpErrorMessage := '';
  CoInitialize(nil);
  try
    FRegexpObject := CreateOleObject('VBScript.RegExp');
    FRegexpObject.Global := FGlobal;
    FRegexpObject.IgnoreCase := FIgnoreCase;
    FRegexpObject.Pattern := FPattern;
  except
    on E: Exception do
    begin
      FUsable := False;
      FUsesRegexp := False;
      FRegexpErrorMessage := E.Message;
    end;
  end;
end;

procedure TVBRegexp.SetGlobal(Value: Boolean);
begin
  if Value = FGlobal then Exit;

  FGlobal := Value;
  if FUsable then
    FRegexpObject.Global := FGlobal;
end;

procedure TVBRegexp.SetIgnoreCase(Value: Boolean);
begin
  if Value = FIgnoreCase then Exit;

  FIgnoreCase := Value;
  if FUsable then
    FRegexpObject.IgnoreCase := FIgnoreCase;
end;

procedure TVBRegexp.SetPattern(Value: string);
begin
  if Value = FPattern then Exit;

  FPattern := Value;
  if FUsable then
    FRegexpObject.Pattern := FPattern;
end;

function TVBRegexp.RegExecute(const S: string): TMaches;
var
  MachesObject, MacheObject: Variant;
  Mache: TMache;
  i: Integer;
begin
  Result := TMaches.Create;
  try
    try
      MachesObject := FRegexpObject.Execute(S);
      for i := 0 to MachesObject.Count - 1 do
      begin
        MacheObject := MachesObject.Item[i];
        Mache := TMache.Create;
        //VBScript.Regexp ̓[n܂镶Ԃ悤B
        with Mache do
        begin
          Value := MacheObject.Value;
          FirstIndex := MacheObject.FirstIndex;
          Length := System.Length(Value);
        end;
        Result.Add(Mache);
        VarClear(MacheObject);
      end;
    finally
      VarClear(MachesObject);
    end;
  except
    on E: Exception do raise Exception.Create(E.Message);
  end;
end;

function TVBRegexp.StrExecute(const S: string): TMaches;
var
  Substr, Temp: string;
  Hed, i: Integer;
  Mache: TMache;
begin
  Result := TMaches.Create;
  if IgnoreCase then
  begin
    Substr := UpperCase(Pattern);
    Temp := UpperCase(S);
  end
  else
  begin
    Substr := Pattern;
    Temp := S;
  end;
  Hed := 0;
  i := AnsiPos(Substr, Temp);
  while i > 0 do
  begin
    Mache := TMache.Create;
    with Mache do begin
      Value := Pattern;
      FirstIndex := Hed + i - 1;
      Length := System.Length(AnsiString(Value));
    end;
    Result.Add(Mache);
    Temp := Copy(Temp, i + Length(AnsiString(Substr)), Length(AnsiString(Temp)));
    Hed := Mache.FirstIndex + Length(AnsiString(Substr));
    i := AnsiPos(Pattern, Temp);
  end;
end;

function TVBRegexp.Execute(const S: string): TMaches;
begin
  //! Result := TMaches.Create;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegExecute(S)
    else
      raise Exception.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrExecute(S);
  end;
end;

function TVBRegexp.RegReplace(const S, Substr: string): string;
begin
  Result := S;
  try
    Result := FRegexpObject.Replace(S, Substr);
  except
    On E: Exception do raise Exception.Create(E.Message);
  end;
end;

function TVBRegexp.StrReplace(const S, Substr: string): string;
var
  Flags: TReplaceFlags;
begin
  Flags := [];
  if Global then
    Include(Flags, rfReplaceAll);
  if IgnoreCase then
    Include(Flags, rfIgnoreCase);
  Result := StringReplace(S, Pattern, Substr, Flags);
end;

function TVBRegexp.Replace(const S, Substr: string): string;
begin
  Result := S;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegReplace(S, Substr)
    else
      raise Exception.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrReplace(S, Substr);
  end;
end;

function TVBRegexp.RegTest(const S: string): Boolean;
begin
  //! Result := False;
  try
    Result := FRegexpObject.Test(S);
  except
    On E: Exception do raise Exception.Create(E.Message);
  end;
end;

function TVBRegexp.StrTest(const S: string): Boolean;
var
  Substr, Temp: string;
begin
  if IgnoreCase then
  begin
    Substr := UpperCase(Pattern);
    Temp := UpperCase(S);
  end
  else
  begin
    Substr := Pattern;
    Temp := S;
  end;
  Result := AnsiPos(Substr, Temp) > 0;
end;

function TVBRegexp.Test(const S: string): Boolean;
begin
  //! Result := False;
  if FUsesRegexp then
  begin
    if FUsable then
      Result := RegTest(S)
    else
      raise Exception.Create(FRegexpErrorMessage);
  end
  else
  begin
    Result := StrTest(S);
  end;
end;

destructor TVBRegexp.Destroy;
begin
  VarClear(FRegexpObject);
  CoUninitialize;

  inherited Destroy;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TVBRegexp]);
end;

end.
