unit POL_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs;

type
  TMainForm = class(TForm)
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
    procedure ApplicationIdleAtWait(Sender: TObject; var Done: Boolean);
    procedure ApplicationIdleAtAbend(Sender: TObject; var Done: Boolean);
    procedure OpenProperty(FileName: string);
    procedure WMDropFiles(Var Msg: TWMDropFiles); message WM_DROPFILES;
  protected
    { Protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  WndInfo, Winapi.ShellAPI, ShellLink;

procedure TMainForm.ApplicationIdleAtWait(Sender: TObject; var Done: Boolean);
var
  Wnd: HWND;
begin
  //vpeB̏I҂B
  Wnd := FindWindowIn(GetCurrentProcessId, 'StubWindow32', '*');
  Done := Wnd = 0;
  if Done then
    Close;
end;

procedure TMainForm.ApplicationIdleAtAbend(Sender: TObject; var Done: Boolean);
begin
  Close;
end;

procedure TMainForm.OpenProperty(FileName: string);
var
  Target: string;
  Info: TShellExecuteInfo;
  Wnd: HWND;
begin
  Application.ShowMainForm := False;
  Hide;

  Target := GetLinkTarget(FileName);
  if not FileExists(Target) then
    Target := FileName;
  FillChar(Info, SizeOf(TShellExecuteInfo), 0);
  with Info do
  begin
    cbSize := SizeOf(TShellExecuteInfo);
    fMask := SEE_MASK_INVOKEIDLIST;
    wnd := Handle;
    lpVerb := 'properties';
    nShow := SW_SHOWNORMAL;
    lpFile := PChar(Target);
  end;
  if ShellExecuteEx(@Info) then
  begin
    //vpeB̋N҂B32bit, 64bit ɃvpeB̃NX StubWindow32B
    repeat
      Wnd := FindWindowIn(GetCurrentProcessId, 'StubWindow32', '*');
      if Wnd > 0 then
        Application.OnIdle := ApplicationIdleAtWait
      else
        Sleep(100);
    until Wnd > 0;
  end
  else
    Application.OnIdle := ApplicationIdleAtAbend;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  if ParamCount > 0 then
  begin
    OpenProperty(ParamStr(1));

    for i := 2 to ParamCount do	//Ԗڈȍ~̃t@C͕ʃvZXŎsB
    begin
      ShellExecute(Handle, 'open',
        PChar(ParamStr(0)), PChar(AnsiQuotedStr(ParamStr(i), '"')), '', SW_SHOWNORMAL);
    end;
  end;
end;

procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  //t@Chbv󂯓B
  Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

procedure TMainForm.WMDropFiles(Var Msg: TWMDropFiles);
var
  FileName: array[0..MAX_PATH] of Char;
  i: Integer;
begin
  //t@ChbvB
  DragQueryFile(Msg.Drop, 0, FileName, SizeOf(FileName));
  try
    OpenProperty(FileName);

    for i := 1 to DragQueryFile(Msg.Drop, $FFFFFFFF, nil, 0) - 1 do
    begin
      DragQueryFile(Msg.Drop, i, FileName, SizeOf(FileName));
      ShellExecute(Handle, 'open',
        PChar(ParamStr(0)), PChar(AnsiQuotedStr(FileName, '"')), '', SW_SHOWNORMAL);
    end;
  finally
    DragFinish(Msg.Drop);
  end;
end;

end.
