unit STF_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.DdeMan, System.ImageList, Vcl.ImgList,
  Vcl.PlatformDefaultStyleActnCtrls, System.Actions, Vcl.ActnList, Vcl.ActnMan, Vcl.Menus,
  Vcl.ToolWin, Vcl.ActnCtrls, Vcl.ComCtrls, ShellCtrls, Vcl.ExtCtrls, Vcl.Grids, TextGrid, VBRegexp;

type
  TMainForm = class(TForm)
    DdeServerConv: TDdeServerConv;
    ShellImages: TImageList;
    ActionImages: TImageList;
    ActionManager: TActionManager;
    OpenTargetAct: TAction;
    CopyAct: TAction;
    MoveAct: TAction;
    MklnkAct: TAction;
    MksymlnkAct: TAction;
    MkdirAct: TAction;
    ChdirAct: TAction;
    CdRootAct: TAction;
    CdHomeAct: TAction;
    CdSourceAct: TAction;
    CdTargetAct: TAction;
    ResetAct: TAction;
    UndoAct: TAction;
    ReplaceAct: TAction;
    ActionToolBar: TActionToolBar;
    ExecuteMenu: TPopupMenu;
    MkdirMnu: TMenuItem;
    ExecuteN1Menu: TMenuItem;
    CopyMnu: TMenuItem;
    MoveMnu: TMenuItem;
    MklnkMnu: TMenuItem;
    MksymlnkMnu: TMenuItem;
    FolderView: TShellTreeView;
    Splitter: TSplitter;
    NameGrid: TTextGrid;
    StatusBar: TStatusBar;
    Regexp: TVBRegexp;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure DdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
    procedure OpenTargetActExecute(Sender: TObject);
    procedure SendActsUpdate(Sender: TObject);
    procedure SendActsExecute(Sender: TObject);
    procedure MklnkActExecute(Sender: TObject);
    procedure MksymlnkActExecute(Sender: TObject);
    procedure MkdirActUpdate(Sender: TObject);
    procedure MkdirActExecute(Sender: TObject);
    procedure ChdirActExecute(Sender: TObject);
    procedure CdRootActExecute(Sender: TObject);
    procedure CdHomeActExecute(Sender: TObject);
    procedure CdSourceActUpdate(Sender: TObject);
    procedure CdSourceActExecute(Sender: TObject);
    procedure CdTargetActUpdate(Sender: TObject);
    procedure CdTargetActExecute(Sender: TObject);
    procedure EditActsUpdate(Sender: TObject);
    procedure ResetActExecute(Sender: TObject);
    procedure UndoActExecute(Sender: TObject);
    procedure ReplaceActExecute(Sender: TObject);
    procedure FolderViewAddFolder(Sender: TObject; AFolder: TShellFolder; var CanAdd: Boolean);
    procedure FolderViewChange(Sender: TObject; Node: TTreeNode);
    procedure NameGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
      State: TGridDrawState);
    procedure NameGridSelectCell(Sender: TObject; ACol, ARow: Integer; var CanSelect: Boolean);
  protected
    { protected 錾 }
    procedure CreateParams(var Params: TCreateParams); override;
  private
    { Private 錾 }
    FSources: TStringList;
    FLastTarget: string;
    FModified: Boolean;
    FSelStart: Integer;
    procedure SetLastTarget(Value: string);
    procedure ReadOption;
    procedure WriteOption;
    procedure InitGrid;
    procedure InitStatus;
    procedure WMDropFiles(var Message: TWMDropFiles); message WM_DROPFILES;
    procedure WMCopyData(var Message: TWMCopyData); message WM_COPYDATA;
    procedure OverWriteQuery(Files: TStrings);
    function SendCopyData(Operation: NativeUInt; Files: TStrings): NativeUInt;
    procedure ChangeDirectory(Path: string);
    procedure EditCancel(ARow: Integer);
    function FindRow: Boolean;
    procedure ReplaceRow;
  public
    { Public 錾 }
    procedure FindFile;
    procedure ReplaceFile;
    procedure ReplaceAllFile;
    procedure FindStop;
    property LastTarget: string read FLastTarget write SetLastTarget;
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
  STF_Replace,
  System.UITypes, Vcl.Consts, AppData, Winapi.ShellAPI, Winapi.CommCtrl, ShellTypes, ShellUtils,
  Winapi.ShlObj, Vcl.FileCtrl, ShellLink, System.IOUtils, WndInfo, System.Win.ComObj;

const
  FO_MKLNK = 5;
  FO_MKSYMLNK = 6;

resourcestring
  SWarningMsg = ' ͂łɑ݂܂B' + #10#13 + '㏑܂H';
  SItemsCount = '%d';
  SMkdirDigCaption = 'VtH_̍쐬';
  SMkdirDigPrompts = 'tH_';

var
  RecycleBin,
  ControlPanel: string;

procedure TMainForm.SetLastTarget(Value: string);
begin
  if Value = FLastTarget then Exit;

  FLastTarget := Value;
  FModified := True;
end;

procedure TMainForm.ReadOption;
var
  IniFile: TAppIniFile;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\RightOn\SendToFolder.ini'));
  try
    FLastTarget := IniFile.ReadString('LastTarget', 'Folder', FolderView.Folders[0].PathName);
  finally
    IniFile.Free;
  end;
  FModified := False;
end;

procedure TMainForm.WriteOption;
var
  IniFile: TAppIniFile;
begin
  IniFile := TAppIniFile.Create(AppDataName('ShaggyDog\RightOn\SendToFolder.ini'));
  try
    IniFile.WriteString('LastTarget', 'Folder', FLastTarget);
  finally
    IniFile.Free;
  end;
end;

procedure TMainForm.InitGrid;
var
  i: Integer;
begin
  NameGrid.RowCount := FSources.Count;
  for i := 0 to FSources.Count - 1 do
  begin
    NameGrid.Cells[1, i] := ExtractFileName(FSources.Strings[i]);
    //! NameGridDrawCell(Self, 1, i, NameGrid.CellRect(1, i), []);
  end;
  if FSources.Count > 0 then
  begin
    with NameGrid do
    begin
      Col := 1;
      Row := 0;
      if Assigned(InplaceEditor) then
      begin
        InplaceEditor.SelStart := 0;
        InplaceEditor.SelLength := 0;
      end;
      Repaint;
    end;
  end;
  StatusBar.Panels.Items[0].Text := Format(SItemsCount, [FSources.Count]);
end;

procedure TMainForm.InitStatus;
var
  TextWidth: Integer;
begin
  with StatusBar do
  begin
    TextWidth := Width - Panels.Items[0].Width - Height * 2;
    Panels.Items[1].Text := MinimizeName(FolderView.Path, Canvas, TextWidth);
  end;
end;

procedure TMainForm.FormCreate(Sender: TObject);
var
  i: Integer;
begin
  ReadOption;
  FSources := TStringList.Create;
  FSources.Sorted := True;
  FSelStart := -1;

  CopyAct.Tag := FO_COPY;
  MoveAct.Tag := FO_MOVE;
  ShellImages.Handle := TreeView_GetImageList(FolderView.Handle, TVSIL_NORMAL);
  MksymlnkAct.Visible := TOSVersion.Check(6);
  if MksymlnkAct.Visible then
    ChangeWindowMessageFilter(WM_COPYDATA, MSGFLT_ADD);

  for i := 1 to ParamCount do
    FSources.Add(ParamStr(i));
  InitGrid;
  FolderView.Path := GetSpecialFolderPath(CSIDL_DRIVES);	//}CRs[^JB
  FolderView.Selected.Expand(False);
  CdTargetAct.Caption := MinimizeName(LastTarget, Canvas, 128);

  Self.Enabled := True;
end;

procedure TMainForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  //t@Chbv󂯓B
  Params.ExStyle := Params.EXStyle or WS_EX_ACCEPTFILES;
end;

procedure TMainForm.WMDropFiles(var Message: TWMDropFiles);
var
  i: Integer;
  FileName: array[0..MAX_PATH] of Char;
begin
  //t@ChbvB
  FSources.Clear;
  try
    for i := 0 to DragQueryFile(Message.Drop, $FFFFFFFF, nil, 0) - 1 do
    begin
      DragQueryFile(Message.Drop, i, FileName, SizeOf(FileName));
      FSources.Add(FileName);
    end;
    InitGrid;
  finally
    DragFinish(Message.Drop);
  end;
end;

procedure TMainForm.WMCopyData(var Message: TWMCopyData);
var
  List: TStrings;
  i: Integer;
  ErrorCode: HRESULT;
begin
  with Message do
    if (CopyDataStruct.dwData = FO_MKLNK) or (CopyDataStruct.dwData = FO_MKSYMLNK) then
    begin
      List := TStringList.Create;
      try
        List.NameValueSeparator := '>';
        List.Text := PChar(Message.CopyDataStruct.lpData);

        //ꉞAEBhEɔfB
        FSources.Clear;
        for i := 0 to List.Count - 1 do
          FSources.Add(List.Names[i]);
        InitGrid;
        FolderView.Path := ExtractFileDir(List.ValueFromIndex[0]);
        FolderView.Selected.Expand(False);

        case CopyDataStruct.dwData of
          FO_MKLNK:
          begin
            for i := 0 to List.Count - 1 do
            begin
              ErrorCode := MakeLink(List.ValueFromIndex[i], List.Names[i]);
              if ErrorCode <> S_OK then
              begin
                MessageDlg(SysErrorMessage(ErrorCode), mtError, [mbOk], 0);
                Break;
              end;
            end;
          end;
          FO_MKSYMLNK:
          begin
            for i := 0 to List.Count - 1 do
            begin
              ErrorCode := MakeSymlink(List.ValueFromIndex[i], List.Names[i]);
              if ErrorCode <> S_OK then
              begin
                MessageDlg(SysErrorMessage(ErrorCode), mtError, [mbOk], 0);
                Break;
              end;
            end;
          end;
        end;
      finally
        List.Free;
      end;
      Close;
    end;
end;

procedure TMainForm.FormResize(Sender: TObject);
begin
  if NameGrid.ColWidths[1] < MainForm.ClientWidth then
    NameGrid.ColWidths[1] := MainForm.ClientWidth;
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  if FModified then
    WriteOption;
  FSources.Free;
end;

procedure TMainForm.DdeServerConvExecuteMacro(Sender: TObject; Msg: TStrings);
begin
  FSources.Assign(Msg);
  InitGrid;
end;

procedure TMainForm.OpenTargetActExecute(Sender: TObject);
begin
  ShellExecute(Handle, nil, PChar(FolderView.Path), '', '', SW_SHOWDEFAULT);
end;

procedure TMainForm.SendActsUpdate(Sender: TObject);
var
  Dir: Boolean;
begin
  with TShellFolder(FolderView.Selected.Data) do
    Dir := IsDirectory(ParentShellFolder, RelativeID);
  TAction(Sender).Enabled := Dir and (FSources.Count > 0);
end;

procedure TMainForm.SendActsExecute(Sender: TObject);
var
  i: Integer;
  FromList, ToList: string;
  FileOpStruct: TSHFileOpStruct;
begin
  FromList := '';
  ToList := '';
  for i := 0 to NameGrid.RowCount - 1 do
  begin
    FromList := FromList + FSources.Strings[i] + #0;
    ToList := ToList + TPath.Combine(FolderView.Path, NameGrid.Cells[1, i]) + #0;
  end;

  with FileOpStruct do
  begin
    wnd := Handle;
    wFunc := TComponent(Sender).Tag;
    pFrom := PChar(FromList + #0);
    pTo := PChar(ToList + #0);
    fFlags := FOF_NOCONFIRMMKDIR or FOF_MULTIDESTFILES;
    fAnyOperationsAborted := False;
    hNameMappings := nil;
    lpszProgressTitle := nil;
  end;
  SHFileOperation(FileOpStruct);

  LastTarget := FolderView.Path;
  Close;
end;

procedure TMainForm.OverWriteQuery(Files: TStrings);
var
  Buttons: TMsgDlgButtons;
  OverWrite, i: Integer;
  FileName: string;
begin
  if Files.Count > 1 then
    Buttons := mbYesAllNoAllCancel
  else
    Buttons := mbYesNo;
  OverWrite := 0;
  for i := Files.Count - 1 downto 0 do
  begin
    FileName := Files.ValueFromIndex[i];
    if FileExists(FileName) then
    begin
      case OverWrite of
        mrYesToAll: TFile.Delete(FileName);
        mrNoToAll: Files.Delete(i); //V{bNN͏㏑łȂ̂ŏĂB
      else
        OverWrite := MessageDlg(ExtractFileName(FileName) + SWarningMsg, mtWarning, Buttons, 0);
        case OverWrite of
          mrYes, mrYesToAll: TFile.Delete(FileName);
          mrNo, mrNoToAll: Files.Delete(i);
          mrCancel:
          begin
            Files.Clear;
            Break;
          end;
        end;
      end;
    end;
  end;
end;

function TMainForm.SendCopyData(Operation: NativeUInt; Files: TStrings): NativeUInt;
var
  Info: TShellExecuteInfo;
  Wnd: HWND;
  Struct: TCopyDataStruct;
begin
  FillChar(Info, SizeOf(TShellExecuteInfo), 0);
  with Info do
  begin
    cbSize := SizeOf(Info);
    fMask := SEE_MASK_NOASYNC or SEE_MASK_WAITFORINPUTIDLE or SEE_MASK_NOCLOSEPROCESS;
    lpVerb := 'runas';
    lpFile := PChar(ParamStr(0));
    nShow := SW_SHOWNORMAL;
  end;
  if ShellExecuteEx(@Info) then
  begin
    Application.ShowMainForm := False;
    Hide;

    //runas ŋNꍇ WaitForInputIdle 삵ȂBUAC _CAÔH
    while True do
    begin
      Wnd := FindWindowIn(GetProcessId(Info.hProcess), 'TMainForm', 'Send To Folder');  //WindowsXP SP1 ȍ~B
      if (Wnd > 0) and IsWindowEnabled(Wnd) then
      begin
        Struct.dwData := Operation;
        Struct.cbData := (Length(Files.Text) + 1) * SizeOf(Char);
        Struct.lpData := PChar(Files.Text);
        SendMessage(Wnd, WM_COPYDATA, WPARAM(Self.Handle), LPARAM(@Struct));

        Break;
      end
      else
        Sleep(100);
    end;
    CloseHandle(Info.hProcess);
  end;
  Result := Info.hInstApp;
end;

procedure TMainForm.MklnkActExecute(Sender: TObject);
var
  ErrorCode: HRESULT;
  List: TStrings;
  i: Integer;
  FileName: string;
begin
  ErrorCode := S_OK;

  List := TStringList.Create;
  try
    List.NameValueSeparator := '>';
    for i := 0 to NameGrid.RowCount - 1 do
    begin
      FileName := TPath.Combine(FolderView.Path, NameGrid.Cells[1, i]);
      if not SameText('.lnk', ExtractFileExt(FileName)) then
        FileName := FileName + '.lnk';
      List.Add(FSources.Strings[i] + '>' + FileName);
    end;
    OverWriteQuery(List);

    for i := List.Count - 1 downto 0 do
    begin
      ErrorCode := MakeLink(List.ValueFromIndex[i], List.Names[i]);
      case ErrorCode of
        S_OK: List.Delete(i);
        E_ACCESSDENIED: {Ďs\}; //ANZXۂ܂B
      else
        List.Clear;
        Break;
      end;
    end;

    if TOSVersion.Check(6) and (List.Count > 0) then
    begin
      if SendCopyData(FO_MKLNK, List) > 32 then
        ErrorCode := S_OK
      else
        ErrorCode := GetLastError;
    end;
  finally
    List.Free;
  end;

  case ErrorCode of
    S_OK,
    ERROR_CANCELLED: ; //[U[ɂB
  else
    MessageDlg(SysErrorMessage(ErrorCode), mtError, [mbOk], 0);
  end;
  LastTarget := FolderView.Path;
  Close;
end;

procedure TMainForm.MksymlnkActExecute(Sender: TObject);
var
  ErrorCode: HRESULT;
  List: TStrings;
  i: Integer;
begin
  ErrorCode := S_OK;

  List := TStringList.Create;
  try
    List.NameValueSeparator := '>';
    for i := 0 to FSources.Count - 1 do
      List.Add(FSources.Strings[i] + '>' + TPath.Combine(FolderView.Path, NameGrid.Cells[1, i]));
    OverWriteQuery(List);

    for i := List.Count - 1 downto 0 do
    begin
      ErrorCode := MakeSymlink(List.ValueFromIndex[i], List.Names[i]);
      case ErrorCode of
        S_OK: List.Delete(i);
        ERROR_PRIVILEGE_NOT_HELD: {Ďs\}; //NCAg͗vꂽۗLĂ܂B
      else
        List.Clear;
        Break;
      end;
    end;

    if TOSVersion.Check(6) and (List.Count > 0) then
    begin
      if SendCopyData(FO_MKSYMLNK, List) > 32 then
        ErrorCode := S_OK
      else
        ErrorCode := GetLastError;
    end;
  finally
    List.Free;
  end;

  case ErrorCode of
    S_OK,
    ERROR_CANCELLED: ; //[U[ɂB
  else
    MessageDlg(SysErrorMessage(ErrorCode), mtError, [mbOk], 0);
  end;
  LastTarget := FolderView.Path;
  Close;
end;

procedure TMainForm.MkdirActUpdate(Sender: TObject);
begin
  with FolderView.SelectedFolder do
    MkdirAct.Enabled := IsDirectory(ParentShellFolder, RelativeID);
end;

procedure TMainForm.MkdirActExecute(Sender: TObject);
var
  NewFolder, NewPath: string;
  Operation: IFileOperation;
  Item: IShellItem;
begin
  if InputQuery(SMkdirDigCaption, SMkdirDigPrompts, NewFolder) then
  begin
    NewPath := TPath.Combine(FolderView.Path, NewFolder);
    if TOSVersion.Check(6) then
    begin
      //UAC ΍B
      Operation := CreateComObject(CLSID_FileOperation) as IFileOperation;
      SHCreateItemFromIDList(FolderView.SelectedFolder.AbsoluteID, IID_IShellItem, Item);
      Operation.NewItem(Item, FILE_ATTRIBUTE_DIRECTORY, PWChar(NewFolder), '', nil);
      OleCheck(Operation.PerformOperations);
    end
    else
      MkDir(NewPath);
    //! Application.ProcessMessages;
    FolderView.Refresh(FolderView.Selected);
    FolderView.Path := NewPath;
  end;
end;

procedure TMainForm.ChdirActExecute(Sender: TObject);
var
  Pt: TPoint;
  Item: TControl;
begin
  //c[{^̈ʒuhbv_E{^̌B
  Pt := ActionToolBar.ScreenToClient(Mouse.CursorPos);
  Item := ActionToolBar.ControlAtPos(Pt, True);
  if Item is TCustomActionControl then
  begin
    Pt.X := Item.Left + Item.Width - 4; //Item.Width - Item.Height  = 12;
    Pt.Y := Item.Top + Item.Height div 2;

    Item := ActionToolBar.ControlAtPos(Pt, True);
    if Item is TCustomDropDownButton then
      TCustomDropDownButton(Item).DropDownClick;
  end;
end;

procedure TMainForm.ChangeDirectory(Path: string);
begin
  FolderView.Path := Path;
  Application.ProcessMessages;
  FolderView.Selected.Expand(False);
end;

procedure TMainForm.CdRootActExecute(Sender: TObject);
begin
  FolderView.Selected := FolderView.Items.Item[0];
end;

procedure TMainForm.CdHomeActExecute(Sender: TObject);
begin
  ChangeDirectory(GetSpecialFolderPath(CSIDL_PROFILE));
end;

procedure TMainForm.CdSourceActUpdate(Sender: TObject);
begin
  CdSourceAct.Enabled := FSources.Count > 0;
  if CdSourceAct.Enabled then
    CdSourceAct.Caption := MinimizeName(ExtractFileDir(FSources.Strings[0]), Canvas, 128)
  else
    CdSourceAct.Caption := srNone;
end;

procedure TMainForm.CdSourceActExecute(Sender: TObject);
begin
  ChangeDirectory(ExtractFileDir(FSources.Strings[0]));
end;

procedure TMainForm.CdTargetActUpdate(Sender: TObject);
begin
  CdTargetAct.Enabled := LastTarget <> '';
end;

procedure TMainForm.CdTargetActExecute(Sender: TObject);
begin
  ChangeDirectory(LastTarget);
end;

procedure TMainForm.EditCancel(ARow: Integer);
begin
  NameGrid.Cells[1, ARow] := ExtractFileName(FSources.Strings[ARow]);
end;

procedure TMainForm.EditActsUpdate(Sender: TObject);
begin
  TAction(Sender).Enabled := FSources.Count > 0;
end;

procedure TMainForm.ResetActExecute(Sender: TObject);
var
  i: Integer;
begin
  for i := 0 to NameGrid.RowCount - 1 do
    EditCancel(i);
end;

procedure TMainForm.UndoActExecute(Sender: TObject);
begin
  EditCancel(NameGrid.Row);
end;

function TMainForm.FindRow: Boolean;

  function FindPrevRow: Boolean;
  var
    i, j, Index: Integer;
    Maches: TMaches;
  begin
    Result := False;
    for i := NameGrid.Row downto 0 do
    begin
      Maches := Regexp.Execute(NameGrid.Cells[1, i]);
      try
        if Maches.Count > 0 then
        begin
          if i <> NameGrid.Row then
          begin
            NameGrid.Row := i;
            Application.ProcessMessages;
            NameGrid.InplaceEditor.SelStart := Length(NameGrid.InplaceEditor.Text);
            NameGrid.InplaceEditor.SelLength := 0;
          end;
          Index := NameGrid.InplaceEditor.SelStart;

          for j := Maches.Count - 1 downto 0 do
          begin
            if Maches.Items[j].FirstIndex >= Index then Continue;

            NameGrid.InplaceEditor.SelStart := Maches.Items[j].FirstIndex;
            NameGrid.InplaceEditor.SelLength := Maches.Items[j].Length;
            Result := True;
            Exit;
          end;
        end;
      finally
        Maches.Free;
      end;
    end;
  end;

  function FindNextRow: Boolean;
  var
    i, j, Index: Integer;
    Maches: TMaches;
  begin
    Result := False;
    for i := NameGrid.Row to NameGrid.RowCount - 1 do
    begin
      Maches := Regexp.Execute(NameGrid.Cells[1, i]);
      try
        if Maches.Count > 0 then
        begin
          if i <> NameGrid.Row then
          begin
            NameGrid.Row := i;
            Application.ProcessMessages;
            NameGrid.InplaceEditor.SelStart := 0;
            NameGrid.InplaceEditor.SelLength := 0;
          end;
          Index := NameGrid.InplaceEditor.SelStart + NameGrid.InplaceEditor.SelLength;

          for j := 0 to Maches.Count - 1 do
          begin
            if Maches.Items[j].FirstIndex < Index then Continue;

            NameGrid.InplaceEditor.SelStart := Maches.Items[j].FirstIndex;
            NameGrid.InplaceEditor.SelLength := Maches.Items[j].Length;
            Result := True;
            Exit;
          end;
        end;
      finally
        Maches.Free;
      end;
    end;
  end;

begin
  with Regexp do
  begin
    Pattern := ReplaceDialog.FindEdt.Text;
    if ReplaceDialog.WholeWordChk.Checked then
    begin
      if ReplaceDialog.UsesRegexpChk.Checked then
        Pattern := '\b' + Pattern + '\b'
      else
        Pattern := ' ' + Pattern + ' ';
    end;
    IgnoreCase := not ReplaceDialog.MatchCaseChk.Checked;
    UsesRegexp := ReplaceDialog.UsesRegexpChk.Checked;
  end;
  case ReplaceDialog.DirectionGrp.ItemIndex of
    0: Result := FindPrevRow;
    1: Result := FindNextRow;
  else
    Result := False;
  end;
end;

procedure TMainForm.FindFile;
begin
  if FindRow then
    StatusBar.Panels.Items[1].Text := ''
  else
  begin
    MessageBeep(MB_ICONHAND);
    StatusBar.Panels.Items[1].Text := Format(STextNotFound, [ReplaceDialog.FindEdt.Text]);
  end;
end;

procedure TMainForm.ReplaceRow;
var
  FileName, FileBase, FileExt: string;
begin
  if ReplaceDialog.ReplaceRdo.Checked then
  begin
    with NameGrid do
      InplaceEditor.SelText := Regexp.Replace(InplaceEditor.SelText, ReplaceDialog.ReplaceEdt.Text);
  end
  else
  begin
    FileName := NameGrid.InplaceEditor.Text;
    FileBase := ChangeFileExt(FileName, '');
    FileExt := ExtractFileExt(FileName);
    case ReplaceDialog.PositionCbx.ItemIndex of
      0: FileName := ReplaceDialog.Serial + FileBase + FileExt;
      1: FileName := FileBase + ReplaceDialog.Serial + FileExt;
    end;
    NameGrid.InplaceEditor.Text := FileName;
    NameGrid.InplaceEditor.SelStart := Length(NameGrid.InplaceEditor.Text);
  end;
end;

procedure TMainForm.ReplaceFile;
begin
  ReplaceRow;
  FindFile;
end;

procedure TMainForm.ReplaceAllFile;
begin
  while FindRow do
    ReplaceRow;
end;

procedure TMainForm.FindStop;
begin
  InitStatus;
end;

procedure TMainForm.ReplaceActExecute(Sender: TObject);
begin
  ReplaceDialog.Show;
end;

procedure TMainForm.FolderViewAddFolder(Sender: TObject; AFolder: TShellFolder;
  var CanAdd: Boolean);
begin
  //S~ƃRg[plc[ɒǉȂB
  CanAdd := (AFolder.PathName <> RecycleBin) and (AFolder.PathName <> ControlPanel);
end;

procedure TMainForm.FolderViewChange(Sender: TObject; Node: TTreeNode);
begin
  Node.MakeVisible;
  InitStatus;
end;

procedure TMainForm.NameGridDrawCell(Sender: TObject; ACol, ARow: Integer; Rect: TRect;
  State: TGridDrawState);
var
  PIDL: PItemIDList;
begin
  if FSources.Count = 0 then Exit;

  case ACol of
    0:
    begin
      PIDL := ParseDisplayName(DesktopShellFolder, FSources.Strings[ARow]);
      try
        with Sender as TTextGrid do
          ShellImages.Draw(Canvas, Rect.Left - 1, Rect.Top - 1, GetShellImage(PIDL, False, False));
      finally
        DisposePIDL(PIDL);
      end;
    end;
    1:
    begin
      if FSelStart >= 0 then
      begin
        NameGrid.InplaceEditor.SelStart := FSelStart;
        FSelStart := -1;
      end;
    end;
  end;
end;

procedure TMainForm.NameGridSelectCell(Sender: TObject; ACol, ARow: Integer;
  var CanSelect: Boolean);
begin
  FSelStart := NameGrid.InplaceEditor.SelStart;
end;

initialization
  RecycleBin := GetSpecialFolderPath(CSIDL_BITBUCKET);
  ControlPanel := ExtractFileDir(GetSpecialFolderPath(CSIDL_CONTROLS)); //Win7 ::{...}\0 ɂȂ

end.
