unit STF_Replace;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, NumEdits;

type
  TReplaceDialog = class(TForm)
    FindButton: TButton;
    ReplaceButton: TButton;
    ReplaceAllButton: TButton;
    CancelButton: TButton;
    FindLbl: TLabel;
    FindEdt: TEdit;
    ModePanel: TPanel;
    ReplaceRdo: TRadioButton;
    ReplaceEdt: TEdit;
    SequenceRdo: TRadioButton;
    PositionCbx: TComboBox;
    OrderLbl: TLabel;
    OrderEdt: TNumericEdit;
    LengthLbl: TLabel;
    LengthEdt: TNumericEdit;
    WholeWordChk: TCheckBox;
    MatchCaseChk: TCheckBox;
    UsesRegexpChk: TCheckBox;
    DirectionGrp: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FindButtonClick(Sender: TObject);
    procedure ReplaceButtonClick(Sender: TObject);
    procedure ReplaceAllButtonClick(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
    procedure EdtsChange(Sender: TObject);
    procedure ModeRdoClick(Sender: TObject);
  private
    { Private 錾 }
    procedure UpdateButtons;
    function GetSerial: string;
    procedure CMShowingChanged(var Message: TMessage); message CM_SHOWINGCHANGED;
  public
    { Public 錾 }
    property Serial: string read GetSerial;
  end;

var
  ReplaceDialog: TReplaceDialog;

implementation

{$R *.dfm}

uses
  STF_Main;

procedure TReplaceDialog.UpdateButtons;
var
  Selectable: Boolean;
begin
  FindButton.Enabled := FindEdt.Text <> '';
  if ReplaceRdo.Checked then
    Selectable := FindButton.Enabled and (ReplaceEdt.Text <> '')
  else
    Selectable := FindButton.Enabled and OrderEdt.IsInteger and LengthEdt.IsInteger;
  ReplaceButton.Enabled := Selectable;
  ReplaceAllButton.Enabled := Selectable;
end;

function TReplaceDialog.GetSerial: string;
begin
  Result := StringReplace(Format('%*d', [LengthEdt.Int, OrderEdt.Int]), ' ', '0', [rfReplaceAll]);
  OrderEdt.Int := OrderEdt.Int + 1;
end;

procedure TReplaceDialog.FormCreate(Sender: TObject);
begin
  UsesRegexpChk.Enabled := MainForm.Regexp.Usable;
end;

procedure TReplaceDialog.CMShowingChanged(var Message: TMessage);
var
  Pt: TPoint;
begin
  //poMainFormCenter Ȃ̂́A\O܂ŁB\ poDesigned ɕωB
  if Position = poMainFormCenter then
  begin
    inherited;

    with MainForm do
      Pt := ClientToScreen(FolderView.BoundsRect.TopLeft);
    Top := Pt.Y;
  end
  else
    inherited;
end;

procedure TReplaceDialog.FormShow(Sender: TObject);
begin
  UpdateButtons;
end;

procedure TReplaceDialog.FindButtonClick(Sender: TObject);
begin
  MainForm.FindFile;
end;

procedure TReplaceDialog.ReplaceButtonClick(Sender: TObject);
begin
  MainForm.ReplaceFile;
end;

procedure TReplaceDialog.ReplaceAllButtonClick(Sender: TObject);
begin
  MainForm.ReplaceAllFile;
end;

procedure TReplaceDialog.CancelButtonClick(Sender: TObject);
begin
  MainForm.FindStop;
  Close;
end;

procedure TReplaceDialog.EdtsChange(Sender: TObject);
begin
  UpdateButtons;
end;

procedure TReplaceDialog.ModeRdoClick(Sender: TObject);
begin
  ReplaceEdt.Enabled := ReplaceRdo.Checked;
  PositionCbx.Enabled := SequenceRdo.Checked;
  OrderEdt.Enabled := SequenceRdo.Checked;
  LengthEdt.Enabled := SequenceRdo.Checked;
end;

end.
